package com.anabas.ibus;

import ch.softwired.jms.IBusJMSContext;
import javax.jms.JMSException;
import com.anabas.gxo.*;
import com.anabas.util.misc.LogManager;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class GMS_BaseMessageSelector  implements GMS_MessageSelector {

  private StringBuffer m_selector = new StringBuffer();

  public GMS_BaseMessageSelector() {
    // HACK ALERT
    // Artifically ignore messages that are generated by this particular client.
    // This is not good in the long run because local subscriber will not be
    // able to receive the message.
    //
    // However, in this phase, there will be no multiple local subscribers to
    // the same stream.

    m_selector.append("(");
    m_selector.append(GXO_JMSConstants.IBUS_CLIENTID_PROPERTY);
    m_selector.append(" <> '");
    try {
      m_selector.append(IBusJMSContext.getTopicConnection().getClientID());
    } catch (JMSException e) {
      LogManager.err("MessageSelector","Unable to get client id for topic connection",e);
      m_selector.append('.');
    }
    m_selector.append("')");
  }

  public void   addSelector(String query) {
    if (m_selector.length() > 0) {
      m_selector.append(" AND ");
    }
    m_selector.append("(");
    m_selector.append(query);
    m_selector.append(")");
  }

  public String toString() {
    return m_selector.toString();
  }

  /**
   * Currently does not support merging.  Throws conflicting selector exception.
   *
   * @exception ConflictingSelectorException If the 2 selector have conflicting
   *     interests.
   */
  public GMS_MessageSelector mergeWithSelector(GMS_MessageSelector selector)
      throws GXO_ConflictingSelectorException {
      throw new GXO_ConflictingSelectorException();
  }
}