package com.anabas.ibus;

import ch.softwired.ibus.*;
import ch.softwired.jms.*;
import javax.jms.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class PerformanceTestCase {

  public static TopicSession m_session;
  public static String s_messageText =
    "...................................................................."+
    " ..................................................................."+
    "...................................................................."+
    "...................................................................."+
    "...................................................................."+
    "....................................................................";

  public void publisher(TopicPublisher publisher) throws JMSException {
    for(int i=0;i < 10000;i++) {
      Message message = m_session.createTextMessage(s_messageText);
      publisher.publish(message);
      if (i % 100 == 0) {
        System.out.println("Sent: " + Integer.toString(i) + " msgs");
      }
      //try { Thread.currentThread().sleep(500); } catch (Exception e) {}
    }
  }

  public void subscriber(TopicSubscriber subscriber) throws JMSException {
    Message msg = subscriber.receive();
    System.out.println(msg);
    subscriber.setMessageListener(new Listener());
  }

  public static void main(String[] args) throws JMSException {
    if (args.length != 2 ) {
      System.out.println("Usage: <p | s> <id> ");
    }

    IBusJMSContext.getTopicConnection().setClientID(args[1]);
    m_session = IBusJMSContext.createTopicSession(false,
                              TopicSession.AUTO_ACKNOWLEDGE);
    PerformanceTestCase test = new PerformanceTestCase();

    Topic topic = m_session.createTopic("/test");
    if (args[0].equals("p")) {
      System.out.println("Publishing");
      test.publisher(m_session.createPublisher(topic));
    } else {
      System.out.println("Subscribing");
      test.subscriber(m_session.createSubscriber(topic));
    }

    while (true)
    try { Thread.currentThread().sleep(10000); } catch (Exception e) {}
  }
}

class Listener implements MessageListener {
  private boolean first = true;
  private int     i = 0;
  private long    startTime;
  private long    initTime;

  public void onMessage(Message msg) {
    System.out.print('.');
      TextMessage m = (TextMessage)msg;
      if (i % 1000 == 0) {
        if (i == 0) {
          startTime = System.currentTimeMillis();
          initTime = startTime;
        } else {
          long time = System.currentTimeMillis();
          System.out.println("Time: " + time);
          System.out.println("Start Time: " + startTime);
          System.out.println(1000/(double)(time-startTime)*1000+" msg/sec");
          startTime = time;
        }
      }
      i++;
    if (i == 10000)
      System.out.println(10000/(double)(System.currentTimeMillis()-initTime)*1000+" msg/sec");
  }
}