package com.anabas.sdsharedlet;

import com.anabas.util.misc.LogManager;
import com.anabas.util.nativeutils.NativeUtilsWrapper;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Title:        Shared Display Sharedlet
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Anabas Inc.
 * @author
 * @version 1.0
 */

public class SDCurAppsDialog extends JDialog {
  ///////////////////////////////////////
  // Private members
  ///////////////////////////////////////
  private static final String TITLE = "Share Application";
  private static final int WIDTH = 190;
  private static final int HEIGHT = 300;

  private JButton m_shareBut = new JButton("Share");
  private JList m_listCurApps = new JList();
  private JScrollPane m_scrollPane = new JScrollPane(m_listCurApps);

  private Object[] m_apps;
  private Object m_selectedApp;
  private SDWrapper m_sdWrapper;

  SDCurAppsDialog(SDWrapper sdWrapper,JFrame parent) {
    this(parent,new String[0]);

    m_sdWrapper = sdWrapper;
  //dialog.getContentPane().add(child);
  }

  SDCurAppsDialog(JFrame parent,Object[] apps) {
    super(parent,TITLE,false);

    setSize(WIDTH,HEIGHT);
    //setResizable(false);

    m_apps = apps;
    m_listCurApps.setListData(m_apps);

    getContentPane().add(m_scrollPane);

    JPanel buttonPanel = new JPanel();
    buttonPanel.add(m_shareBut);

    getContentPane().add(buttonPanel,BorderLayout.SOUTH);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        m_selectedApp = null;
      }
    });

    m_listCurApps.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {
          int index = m_listCurApps.locationToIndex(e.getPoint());
          if(index != -1 && shareApp()) {
            //hide();
            setVisible(false);
          }
        }
      }
    });

    m_shareBut.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if(shareApp()) {
          //hide();
          setVisible(false);
        }
      }
    });
  }

  boolean shareApp() {
    if(!((m_selectedApp = m_listCurApps.getSelectedValue()) == null)) {
      // extract the window handle from name
      int hwnd = ((NativeUtilsWrapper.SharedAppInfo)m_selectedApp).getId();
log("----------- Calling Click to share on wnd [" + hwnd + "] -----------");
      // call click to share native function
      m_sdWrapper.ClickToShare(hwnd,SDWrapper.CTS_SHARE);

      return true;
    }
    return false;
  }

  void show(Object[] apps) {
    m_apps = apps;
    m_listCurApps.setListData(m_apps);
    show();
  }

  Dimension getDimension() {
    return new Dimension(WIDTH,HEIGHT);
  }

  public static void main(String[] args) {
    /*SDCurAppsDialog SDCurAppsDialog1 = new SDCurAppsDialog(null,null);
    String[] apps = {"1","2","3"};
    SDCurAppsDialog1.log(SDCurAppsDialog1.show(apps).toString());

    apps[0] = "4";
    apps[1] = "5";
    apps[2] = "6";

//    SDCurAppsDialog1.log(SDCurAppsDialog1.show(apps));

//    SDCurAppsDialog1.dispose();*/
  }

  private void log(String msg) {
    LogManager.log("SDSharedlet::SDCurAppsDialog",msg);
  }
}