package com.anabas.sdsharedlet;

import com.anabas.util.misc.LogManager;

/**
 * Title:         JNI Wrapper for SharedDisplay
 * Description:
 * Copyright:     Copyright (c) 2000
 * Company:       Anabas Inc.
 * @author        Milind
 * @version       1.0
 */
class SDWrapper {
  /* Native parameters: ClickToShare() */
  static final int CTS_DEFAULT = 0;
  static final int CTS_SHARE = 1;
  static final int CTS_UNSHARE = 2;
  static final int CTS_ACTIVATE = 3;

  /* Native parameters: updateApplication() */
  static final int COMMAND_APP_SHARED = 0;
  static final int COMMAND_APP_ACTIVATED = 1;
  static final int COMMAND_APP_UNSHARED = 2;
  static final int COMMAND_APP_CLOSED = 4;
  static final int COMMAND_APP_SHARECANCELED = 5;

  private SDControlView m_controlView;
//  private static final String DLL_PATH =
//          "C:\\Milind\\Projects\\win32\\SharedDisplay\\Exe\\SD.dll";

  static {
    loadSharedDisplayDll();
  }

  private static void loadSharedDisplayDll()
  {
    // load the Dll
    //System.load(DLL_PATH);
    System.loadLibrary("anabas/bin/sd");
  }

  /*private void getSharedAppToolbar() {
    try {
      m_controlView = (SDControlView) SDSharedlet.getMyView(
                        SDControlViewInfo.SHAREDAPP_TOOLBAR_NAME);
    }
    catch (Exception ex) {
      err("getSharedAppToolbar: Err:" , ex);
    }
  }*/

  public void updateApplication(int id,String strTitle,int command)
  {
      m_controlView.updateApplication(id, strTitle, command);
  }

  public SDWrapper() {
  }

  public SDWrapper(SDControlView parent) {
    m_controlView = parent;
  }

  void logC(String msg) {
    LogManager.log("sd<native>",msg);
  }

  private void err(String ErrMsg, Exception ex) {
    LogManager.err("SDSharedlet::SDWrapper",ErrMsg,ex);
  }

  private void log(String msg) {
    LogManager.log("SDSharedlet::SDWrapper",msg);
  }

  /* Native methods */
  public native boolean init();
  public native boolean release();
  public native boolean listen(long token);
  public native boolean setRole(int role);
  public native boolean connect(long token);
  public native boolean SetPosition(int lef,int top, int width, int height, boolean flag);
  public native boolean waitForEvents(int waitTime);
  public native byte[]  getQueuedEvent();
  public native boolean PostEvent(byte[] eventBuf);
  public native boolean RequestFullUpdate(int requestId);
  public native boolean EnableInputControl(boolean enable,long token);
  public native boolean ClickToShare(int app_id,int command);
  public native boolean pauseCapture(boolean pause);
  public native boolean hilight();
  public native boolean mark();
  public native boolean clearAnnotations();
  public native boolean enableAnnotation(boolean enable);
  public native boolean setParent(String parentTitle);
  public native byte[] getBitmap(int format);
  public native boolean dummy();
}