package com.anabas.ibus;

import com.anabas.gxo.GMS_Destination;
import com.anabas.gxo.GMS_DestinationSelector;
import com.anabas.gxo.GXO_Exception;
import com.anabas.gxo.GXO_SyntaxException;

import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.io.IOException;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 *
 * This destination contains the property name
 * GXO_Constants.GXO_DESTINATION_PROPERTY values.
 *
 * It is used in conjunction with GXO_Constants
 * Syntax is:
 *
 * destination_string:  "$" | list
 * list:  "Y" <user_id> "," list | "N" <user_id> "," list | <user_id>
 *
 * "$"    Broadcast message
 * "Y"    Inlucde the user
 * "N"    Not include the user
 *
 * A "Y" or "N" overrides "*".  So "*,N123" will broadcast to all users
 * except for user 123.
 */

public class GMS_DestinationImpl implements GMS_Destination, GMS_DestinationSelector {

  protected String m_destinationString;

  protected void setDestinationString(String str) {
    m_destinationString = str;
  }

  public String getDestinationString() {
    return m_destinationString;
  }

  public String toString() {
    return m_destinationString;
  }

  public void setQueryString(String str) throws GXO_SyntaxException {
    setDestinationString(str);
  }

  public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
    m_destinationString = (String)in.readObject();
  }

  public void writeExternal(ObjectOutput out) throws IOException {
    out.writeObject(m_destinationString);
  }
}