package com.anabas.ibus;

import com.anabas.gxo.GMS_DestinationSelector;
import com.anabas.gxo.GXO_SyntaxException;

import java.util.Vector;
import java.util.Enumeration;
import java.io.ObjectOutput;
import java.io.ObjectInput;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 *
 * A user that is excluded and included will be excluded.
 *
 * A convenient class that represents a destination adn a destination selector.
 */

public class GMS_MulticastDestinationSelector extends GMS_DestinationImpl implements GMS_DestinationSelector {

  private Vector m_includeUsers = new Vector();
  private Vector m_excludeUsers = new Vector();

  // If the destination string has been updated to reflect the user lists.
  private boolean m_updatedDestination = false;

  public void includeUser(String userID) {
    m_includeUsers.addElement(userID);
    m_updatedDestination = false;
  }

  public void excludeUser(String userID) {
    m_excludeUsers.addElement(userID);
    m_updatedDestination = false;
  }

  public String buildList() {
    StringBuffer queryString = new StringBuffer();

    Enumeration enum;

    // If no exclusion set then we can multicast based on receipient list.
    if ((m_excludeUsers.size() == 0) && (m_includeUsers.size() == 0)) {
      return "$";
    } else if (m_excludeUsers.size() == 0) {
      enum = m_includeUsers.elements();
      while(enum.hasMoreElements()) {
        if (queryString.length() != 0) queryString.append(',');
        String userID = (String)enum.nextElement();
        queryString.append('Y');
        queryString.append(userID);
      }
    } else {   // If there is exclusion then automatically mean everyone but.
      enum = m_excludeUsers.elements();
      queryString.append('$');
      while(enum.hasMoreElements()) {
        queryString.append(',');
        String userID = (String)enum.nextElement();
        queryString.append('N');
        queryString.append(userID);
      }
    }
    return queryString.toString();
  }

  public String getDestinationString() {
    if (!m_updatedDestination) {
      setDestinationString(buildList());
    }
    return m_destinationString;
  }

  public String toString() {
    return getDestinationString();
  }

  /**
   * Developer must make sure the string syntax is correct.
   */
  public void setQueryString(String query) throws GXO_SyntaxException {
    setDestinationString(query);
    m_updatedDestination = true;
  }
}