package com.anabas.ibus;

import javax.jms.ObjectMessage;
import javax.jms.JMSException;
import javax.jms.Message;

import com.anabas.gxo.*;
import com.anabas.util.misc.LogManager;
import java.io.Serializable;
import com.anabas.concepts.Time;
import java.util.Enumeration;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class GMS_ObjectMessageImpl extends GMS_ObjectMessage {

  private ObjectMessage m_message;
  private GMS_MessageID m_id;

  public GMS_ObjectMessageImpl(ObjectMessage msg) {
    m_message = msg;
    try {
      m_id      = new GMS_MessageIDImpl(msg.getJMSMessageID());
    } catch (JMSException e) {
      LogManager.err("ObjectMessage","Unable to retrieve JMS Message ID",e);
      m_id = new GMS_MessageIDImpl("error");
    }
  }

  public Object getProperty(String name) throws com.anabas.gxo.GXO_Exception {
    try {
      return m_message.getStringProperty(name);
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public Serializable getObject() throws com.anabas.gxo.GXO_Exception {
    try {
      return m_message.getObject();
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public Time getTimeStamp() throws GXO_Exception {
    try {
      return new TimeImpl(m_message.getJMSTimestamp());
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public void setProperty(String name, Object property) throws com.anabas.gxo.GXO_Exception {
    try {
      m_message.setObjectProperty(name,property);
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public long getPriority() throws GXO_Exception {
    try {
      return m_message.getJMSPriority();
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public long getBodyType() {
    return GMS_Message.BODYTYPE_OBJECT;
  }

  public GMS_MessageID getID() {
    return m_id;
  }

  public Enumeration getPropertyNames() throws com.anabas.gxo.GXO_Exception {
    try {
      return m_message.getPropertyNames();
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public void setObject(Serializable parm1) throws com.anabas.gxo.GXO_Exception {
    try {
      m_message.setObject(parm1);
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public void clearBody() throws com.anabas.gxo.GXO_Exception {
    try {
      m_message.clearBody();
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }
  public long getMessageType() throws GXO_Exception {
    try {
      return m_message.getLongProperty("gxo_message_type");
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }

  public Message getJMSMessage() { return m_message; }

  public void clearProperties() throws com.anabas.gxo.GXO_Exception {
    try {
      m_message.clearProperties();
    } catch (JMSException e) {
      throw new GXO_JMSException(e);
    }
  }
}