package com.anabas.ibus;

import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;
import com.borland.jbcl.layout.*;

import com.anabas.util.misc.*;
import com.anabas.gxo.*;
import com.anabas.naming.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class IBusTest extends JFrame implements ActionListener {
  JLabel jLabel1 = new JLabel();
  XYLayout xYLayout1 = new XYLayout();
  JTextField m_topicName = new JTextField();
  JButton m_connectButton = new JButton();
  JTextField m_sendText = new JTextField();
  JLabel jLabel2 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea m_display = new JTextArea();
  JList m_userList = new JList();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JTextField m_userIDField = new JTextField();
  DefaultListModel m_userListModel = new DefaultListModel();

  protected GMS_Stream m_stream;   // Current stream.
  protected GMS_StreamPublisher m_publisher;
  protected GMS_StreamSubscriber m_subscriber;
  protected GMS_StreamFactory m_factory;
  protected GND_Collection m_initialContext;
  JScrollPane jScrollPane2 = new JScrollPane();
  JLabel jLabel5 = new JLabel();
  JCheckBox m_excludeBox = new JCheckBox();
  JButton m_requestButton = new JButton();
  JButton m_batchButton = new JButton();

  public IBusTest() {
    getContentPane().setLayout(new FlowLayout());
    try {
      jbInit();
      busInit("client 1");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void actionPerformed(ActionEvent e) {
    String cmd = e.getActionCommand();
    if (cmd.equals("connect")) {
      try {
        connect();
      } catch (Exception ex) {
        m_display.append("Error");
        LogManager.err("Test","Can't connect",ex);
      }
    } else if (cmd.equals("send")) {
      sendMessage();
    } else if (cmd.equals("request")) {
      requestMessage();
    } else if (cmd.equals("batch")) {
      batchMessage();
    }
  }

  protected void connect() throws Exception {
    m_display.append("Connecting.....");

    m_factory.setProperty("userid",m_userIDField.getText());
    m_stream = (GMS_Stream)m_initialContext.lookupXO(m_topicName.getText());

    if (m_stream == null) {
      m_stream = m_factory.createStream(m_topicName.getText(),null);
      m_initialContext.bindXO(m_topicName.getText(),m_stream);
    }
    m_publisher = m_stream.createPublisher();
    m_subscriber = m_stream.createSubscriber();
    m_subscriber.setMessageListener(new TestListener(m_display,this.m_userListModel,this));

    sendJoinMessage('J');
    m_display.append("Connected\n");
  }

  protected void requestMessage() {
    if (m_publisher == null) return;

    try {
      GMS_TextMessage msg = (GMS_TextMessage)m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,
                                                  GMS_Message.BODYTYPE_TEXT);
      msg.setText("Hello");
      msg = (GMS_TextMessage)m_publisher.request(msg,buildDestination(),1000);
      if (msg != null) {
        m_display.append("Got Response: " + msg.getText()+"\n");
      } else {
        m_display.append("Response Timedout");
      }
    } catch (GXO_Exception e) {
      LogManager.err("--","Unable to request message",e);
    }
  }

  protected void sendJoinMessage(char state) {
    try {
      if (m_publisher == null) return;
      GMS_ObjectMessage msg = (GMS_ObjectMessage)m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,
                                                  GMS_Message.BODYTYPE_OBJECT);
      msg.setObject(state+m_userIDField.getText());
      m_publisher.broadcast(msg);
      m_userListModel.addElement(m_userIDField.getText());
    } catch (GXO_Exception e) {
      LogManager.err("Test","Can't create or broadcast",e);
    }
  }

  protected GMS_Destination buildDestination() {
    int[] selected = m_userList.getSelectedIndices();
    GMS_MulticastDestinationSelector dst = new GMS_MulticastDestinationSelector();

    if (m_userList.getSelectedIndex() != 0) {
      boolean excluded = m_excludeBox.isSelected();
      for(int i=0;i < selected.length;i++) {
        String userName = (String)m_userListModel.getElementAt(selected[i]);
        if (!excluded) dst.includeUser(userName);
        else dst.excludeUser(userName);
      }
    }
    return dst;
  }

  protected void sendMessage() {
    try {
      GMS_TextMessage msg = (GMS_TextMessage)m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,
                                                  GMS_Message.BODYTYPE_TEXT);
      msg.setText(m_sendText.getText());

      if (m_userList.getSelectedIndex() == 0) {
        m_publisher.broadcast(msg);
      } else {
        m_publisher.sendMessage(msg,buildDestination());
      }
      m_display.append("Sent: " + m_sendText.getText()+'\n');
    } catch (GXO_Exception e) {
      LogManager.err("Test","Can't create or broadcast",e);
    }
  }

  protected void busInit(String userID) throws Exception {
    LogManager.setLevel(LogManager.ALL-1);
    m_factory = new GMS_StreamFactoryImpl();
    ContextManager.setContextManager(new ContextManager());
    m_initialContext = new GND_InitialContext();
    // Create the subcontext where all streams are stored.
    m_initialContext = (GND_Collection)m_initialContext.createSubcontext("streams");

    m_display.append("Bus Initialized\n");
  }

  protected void jbInit() throws Exception {
    jLabel1.setText("Topic");
    this.getContentPane().setLayout(xYLayout1);
    m_topicName.setText("test");
    m_connectButton.setText("Connect");
    jLabel2.setText("Send:");
    jLabel3.setBorder(BorderFactory.createEtchedBorder());
    jLabel3.setText("Users");
    jLabel4.setText("User ID");
    m_userIDField.setText("1");
    xYLayout1.setWidth(393);
    xYLayout1.setHeight(270);
    jLabel5.setBorder(BorderFactory.createEtchedBorder());
    jLabel5.setText("Topic Messages");
    m_excludeBox.setText("Exclude");
    m_requestButton.setText("Request");
    m_batchButton.setText("Batch");
     this.getContentPane().add(jLabel1, new XYConstraints(14, 10, 55, -1));
    this.getContentPane().add(m_topicName, new XYConstraints(50, 9, 73, -1));
    this.getContentPane().add(m_connectButton, new XYConstraints(288, 9, 82, 22));
    this.getContentPane().add(m_sendText, new XYConstraints(8, 229, 224, 25));
    this.getContentPane().add(jLabel4, new XYConstraints(132, 11, -1, -1));
    this.getContentPane().add(m_userIDField, new XYConstraints(184, 9, 75, -1));
    this.getContentPane().add(jScrollPane2, new XYConstraints(8, 87, 97, 115));
    this.getContentPane().add(jScrollPane1, new XYConstraints(126, 61, 258, 142));
    this.getContentPane().add(jLabel5, new XYConstraints(126, 39, 259, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(10, 207, -1, -1));
    this.getContentPane().add(jLabel3, new XYConstraints(10, 37, 97, -1));
    this.getContentPane().add(m_excludeBox, new XYConstraints(18, 59, -1, -1));
    this.getContentPane().add(m_batchButton, new XYConstraints(325, 228, -1, -1));
    this.getContentPane().add(m_requestButton, new XYConstraints(235, 227, 87, -1));
    jScrollPane1.getViewport().add(m_display, null);
    jScrollPane2.getViewport().add(m_userList, null);

    addWindowListener(new Cleaner(this));
    m_connectButton.setActionCommand("connect");
    m_connectButton.addActionListener(this);

    m_requestButton.setActionCommand("request");
    m_requestButton.addActionListener(this);

    m_batchButton.setActionCommand("batch");
    m_batchButton.addActionListener(this);

    m_sendText.addActionListener(this);
    m_sendText.setActionCommand("send");
    m_userList.setModel(m_userListModel);
    m_userListModel.addElement("ALL");
  }

  public static void main(String[] argv) {
    IBusTest t = new IBusTest();

    t.pack();
    t.show();
  }

  private void batchMessage() {
    int iteration = 100;
    int size = 3000;
    try {
      byte[] bytes = new byte[size];
      GMS_BytesMessage msg;

      for(int i=0;i < iteration;i++) {
        msg = (GMS_BytesMessage)m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,
                                                  GMS_Message.BODYTYPE_BYTES);
        msg.writeBytes(bytes);

        if (m_userList.getSelectedIndex() == 0) {
          m_publisher.broadcast(msg);
        } else {
          m_publisher.sendMessage(msg,buildDestination());
        }
      }

      // Send termination message. (type text)
      GMS_TextMessage tmsg = (GMS_TextMessage)m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,
                                                  GMS_Message.BODYTYPE_TEXT);
      if (m_userList.getSelectedIndex() == 0) {
        m_publisher.broadcast(tmsg);
      } else {
        m_publisher.sendMessage(tmsg,buildDestination());
      }

      m_display.append("Sent: " + iteration + " bytes message of size " + size +'\n');
    } catch (GXO_Exception e) {
      LogManager.err("Test","Can't create or broadcast",e);
    }
  }
}

class TestListener implements GMS_MessageListener {

  protected JTextArea m_textPane;
  protected DefaultListModel m_list;
  protected Hashtable m_user2label = new Hashtable();
  protected IBusTest m_parent;
  boolean batchMode = false;
  int numBatch = 0;

  TestListener(JTextArea p,DefaultListModel l,IBusTest parent) {
    m_textPane = p;
    m_list = l;
    m_parent = parent;
  }

  public void onRequest(GMS_Message msg,GMS_MessageReplyer replyer) {
    GMS_TextMessage m = (GMS_TextMessage)msg;
    try {
      String cmd = m.getText();
      m_textPane.append("Got Request: " +cmd+"...replying with generic 'World'\n");
      m = (GMS_TextMessage)m_parent.m_publisher.createMessage(GMS_Message.MSGTYPE_MINOR,GMS_Message.BODYTYPE_TEXT);
      m.setText("World");
      replyer.reply(msg,m);
    } catch (GXO_Exception e) {
      LogManager.err("TestListener","Can't reply",e);
    }
  }

  public void onMessage(GMS_Message msg) {

    try {
      switch((int)msg.getBodyType()) {
      case GMS_Message.BODYTYPE_OBJECT:
        GMS_ObjectMessage mo = (GMS_ObjectMessage)msg;
        String cm = (String)mo.getObject();
        String user = cm.substring(1);
        if (cm.startsWith("L")) {
          System.out.println("Left User: " + user);
          if (m_list.contains(user)) {
              m_list.removeElement(user);
          }
        } else {
          System.out.println("Got User: " + user);
          if (!m_list.contains(user)) {
            m_list.addElement(user);
          }
        }
        break;
      case GMS_Message.BODYTYPE_TEXT:
        if (!batchMode) {
          GMS_TextMessage mt = (GMS_TextMessage)msg;
          m_textPane.append(mt.getText()+"\n");
        } else {
          batchMode = false;
          m_textPane.append("Finished receiving " + numBatch + " batch bytes messages.\n");
          numBatch = 0;
        }
        break;
      case GMS_Message.BODYTYPE_BYTES:
        if (!batchMode) {
          m_textPane.append("Receiving batch bytes messages\n");
        }
        batchMode = true;
        numBatch++;
        if (numBatch % 10 == 0) {
          m_textPane.append("Received "+numBatch+" messages so far.\n");
        }
        break;
      }
    } catch (GXO_Exception e) {
      m_textPane.append(e.toString());
    }

  }
}


class Cleaner extends java.awt.event.WindowAdapter {

  protected IBusTest m_t;

  Cleaner(IBusTest t) {
    m_t = t;
  }

  public void windowClosing(WindowEvent e) {
    m_t.sendJoinMessage('L');
    System.exit(0);
  }
}