package com.anabas.testsharedlet;

/**
 * Title:        ServerInputpanel.java
 * Description:  Inputpanel GUI
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

public class ServerInputpanel extends JPanel {

  public void setMessage(String s) {
    display.setText(s);
  }

  public ServerInputpanel(ServerInterface si) {
    super();
    parent = si;

    // submit button
    submitButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
          Hashtable hashtable = new Hashtable();
          hashtable.put("mid", mID.getText());
          hashtable.put("aid", aID.getText());
          hashtable.put("tid", tID.getText());
          hashtable.put("eid", eID.getText());
          hashtable.put("edata", eData.getText());
          //parent.padaptor.setHHMP(hashtable);
      }
    });

    // input panel
    gbConstraints.fill = GridBagConstraints.NONE;
    gbConstraints.anchor = GridBagConstraints.WEST;
    JPanel textPanel = new JPanel(gbLayout);
    textPanel.setBorder(new CompoundBorder(
      new EmptyBorder(0, 5, 5, 5), new EtchedBorder()));

    addComponent(textPanel, mLabel, 0, 0, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, aLabel, 0, 1, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, tLabel, 0, 2, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, eLabel, 0, 3, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, mID, 1, 0, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, aID, 1, 1, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, tID, 1, 2, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, eID, 1, 3, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, outLabel, 2, 1, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, eData, 3, 0, 4, 1, new Insets(5, 2, 5, 2));
    addComponent(textPanel, inLabel, 4, 1, 1, 1, new Insets(5, 2, 2, 5));
    addComponent(textPanel, display, 5, 0, 4, 1, new Insets(5, 2, 5, 2));
    gbConstraints.anchor = GridBagConstraints.CENTER;
    addComponent(textPanel, submitButton, 6, 1, 2, 1, new Insets(5, 5, 5, 5));


    // header panel
    JPanel headerPanel = new JPanel();
    headerPanel.setBorder(new CompoundBorder(
      new EmptyBorder(5, 5, 2, 5), new EtchedBorder()));
    headerPanel.add(new JLabel("Server Demo"));

    // gui
    setLayout(new BorderLayout());
    add(headerPanel, BorderLayout.NORTH);
    add(textPanel, BorderLayout.CENTER);
  }

  // addComponent:
  // adds components to container according to grid
  // constraints parameters
  public void addComponent(JPanel p, JComponent c, int row, int column,
    	                     int width, int height, Insets insets) {
    // set gridx and gridy
    gbConstraints.gridx = column;
    gbConstraints.gridy = row;
    // set gridwidth and gridheight
    gbConstraints.gridwidth = width;
    gbConstraints.gridheight = height;
    gbConstraints.insets = insets;
    // set constraints
    gbLayout.setConstraints(c, gbConstraints);
    // add component
    p.add(c);
  }

  private GridBagConstraints gbConstraints = new GridBagConstraints();
  private GridBagLayout gbLayout = new GridBagLayout();
  protected JLabel mLabel = new JLabel("Machine ID");
  protected JLabel aLabel = new JLabel("Applic' ID");
  protected JLabel tLabel = new JLabel("Topic ID");
  protected JLabel eLabel = new JLabel("Event ID");
  protected JLabel outLabel = new JLabel("Out Data");
  protected JLabel inLabel = new JLabel("In Data");
  protected JTextField mID = new JTextField(3);
  protected JTextField aID = new JTextField(3);
  protected JTextField tID = new JTextField(3);
  protected JTextField eID = new JTextField(3);
  protected JTextField eData = new JTextField(26);
  public JTextField display = new JTextField(26);
  protected JButton submitButton = new JButton("Submit");
  protected ServerInterface parent;
  byte[] HHms = new byte[4096];
}


