/****************************************************************************
 * Enumeration for Anabas Connection State
 * @author   Kangseok Kim
 ****************************************************************************/
package com.anabas.pdasharedlet;

public class AnabasConnectionState
{
 public static final int CLOSED	= 0;             // Default. CLOSED
 public static final int OPEN = 1;		 // OPEN
 public static final int LISTENING = 2;		 // LISTENING
 public static final int CONNECTION_PENDING = 3; // Connection pending
 public static final int CONNECTING = 6;	 // CONNECTING
 public static final int CONNECTED = 7;          // CONNECTED
 public static final int CLOSING = 8;        // Peer is closing the Connection
 public static final int ERROR = -4000;          // ERROR
 private int miState = CLOSED;

 public AnabasConnectionState(int newState)
 {
  miState = newState;
 }

 public AnabasConnectionState()
 {
  miState = CLOSED;
 }

 public void state(int newState)
 {
  miState = newState;
 }

 public int state()
 {
  return miState;
 }

 public String toString()
 {
  switch(miState)
  {
   case CLOSED:             return "Closed";
   case OPEN:	            return "Open";
   case LISTENING:          return "Listening";
   case CONNECTION_PENDING: return "Connection Pending";
   case CONNECTING:         return "Connecting";
   case CONNECTED:          return "Connected";
   case CLOSING:            return "Closing";
   case ERROR:	            return "Error";
   default:	            return "UNKNOWN State";
  }
 }
}


