package com.anabas.testsharedlet;

/**
 * Title:        TCPClient.java
 * Description:  Test client
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import javax.swing.*;

public class TCPClient {

  public void setHHms(byte[] b) {
    HHms = b;

    try {
      dataOutput.write(HHms);
      System.out.println(new String(HHms));
    }
    catch( IOException e) {
      e.printStackTrace();
    }
  }

  public TCPClient(String s) {
    initGUI(s);
    try {
      client = new Socket("plum.csit.fsu.edu",5000);
      dataInput = new DataInputStream(client.getInputStream());
      dataOutput = new DataOutputStream(client.getOutputStream());
    }
    catch(IOException e) {
      e.printStackTrace();
    }

    try {
        boolean stop = false;
        while(!stop) {
          byte[] HHms = new byte[100];
          int i = dataInput.read(HHms);
          if(i != 0) {
            System.out.println(new String(HHms));
            inputPanel.setMessage(new String(HHms));
          }
          else stop = true;
        }
        client.close();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
  }

  public void initGUI(String s) {

    frame = new JFrame("Pseudo PDA Client: " + s);
    frame.setSize(350,350);

    frame.addWindowListener( new WindowAdapter() {
      public void windowClosing( WindowEvent e ) {
        System.exit( 0 );
      }
      public void windowOpened(WindowEvent e) {}
      public void windowClosed(WindowEvent e) {}
      public void windowIconified(WindowEvent e) {}
      public void windowDeiconified(WindowEvent e) {}
      public void windowActivated(WindowEvent e) {}
      public void windowDeactivated(WindowEvent e) {}
    });

    // gui
    frame.getContentPane().setLayout(new BorderLayout());
    frame.getContentPane().add(inputPanel, BorderLayout.CENTER);

    // ready
    frame.pack();
    frame.setVisible(true);
  }

  public static void main(String args[]) {
    TCPClient tc = new TCPClient(args[0]);
  }

  protected Socket client;
  protected DataInputStream dataInput;
  protected DataOutputStream dataOutput;
  static byte[] HHms = new byte[4096];

  protected JFrame frame;
  protected InputPanel inputPanel = new InputPanel(this);;
}
