package com.anabas.pdasharedlet;

/**
 * Title:        SVGListner.java
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */

import com.anabas.concepts.*;
import com.anabas.sharedlet.*;
import com.anabas.util.misc.LogManager;
import com.anabas.gxo.*;
import com.anabas.naming.*;

public class SVGListener extends Thread implements GMS_MessageListener {

  private PdaControlView pcv;
  private GMS_StreamSubscriber m_subscriber;

  public SVGListener(PdaControlView o_pcv, GMS_StreamSubscriber o_m_subscriber) {

    this.pcv = o_pcv;
    this.m_subscriber = o_m_subscriber;

    try {
      m_subscriber.setMessageListener(this);
    } catch (Exception e) {
      LogManager.err("PdaControlView","Unable to get comm service",e);
    }

    this.run();
  }

  public void run() {}

  /**
   * When it receives a message from the bus containing a new random number
   * that was generated by another user, display it in the presentation area.
   */
  public void onMessage(GMS_Message m) {

    try {
      if(m instanceof GMS_TextMessage){
        GMS_TextMessage msg = (GMS_TextMessage)m;
        System.out.println("SVG");
        String text = (String)msg.getText();
        System.out.println(text);
        pcv.pa.getGMSMessage(" ", " ", " ", text, 1);
     }
      else {
        System.out.println("SD");
      }
    }
    catch (GXO_Exception e) {
      LogManager.err("PdaControlView","error on message",e);
    }
  }

  public void onRequest(GMS_Message m,GMS_MessageReplyer r) {}

}