package com.anabas.commsharedlet;

import java.awt.Dimension;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.util.misc.LogManager;
import com.anabas.sharedlet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.anabas.util.ui.VolumeIndicator;
import com.anabas.util.io.StreamUtil;
import java.util.Hashtable;
import java.io.IOException;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.swing.border.*;
import com.anabas.sharedlet.LayoutService;
import audiotalk.hearmevoicelib.*;

import com.anabas.gxo.*;
import com.anabas.concepts.*;
import com.anabas.naming.*;
import com.anabas.util.ui.AnabasToolTipManager;
import com.anabas.util.ui.AnabasJPanel;

public class CommunicationControlView extends JPanel implements SharedletView, Runnable,
        CapabilityListener, AudioControlListener, TextchatListener{
//we move GMS_MessageListener temporaily
  private SharedletViewRenderer m_myRenderer;
  private String m_myName;
  private AudioControl m_audioControl;
  private CapabilitiesManager m_capabilitiesManager;

  static double MIC_RATIO = 2.5;
  private JSlider m_speakerSlider, m_speakerSliderFromApplication;
  private VolumeIndicator m_microphoneIndicator;
  private JButton m_textchat;
  private JToggleButton m_broadcast;
  private ImageIcon m_textActive, m_textInactive;
  private JCheckBox m_handsfree;
  private Color m_selected, m_background;
  private Thread m_thread;
  private boolean m_isBlinking = false;
  private boolean m_textchatSelected = false;

  private Vector m_participants = new Vector();
  private int status;
  private boolean m_micIsOn = false;
  static final int s_threshold = 1;

  private User m_myUser;
  private GMS_StreamPublisher m_publisherForPrivate, m_publisherForPhoneUser;
//  private GMS_StreamSubscriber m_subscriberForPhoneUser;
  private GMS_Stream m_streamForPhoneUser;

  private Vector m_nameList = new Vector();
  private Vector m_newParticipants = new Vector();
  private Hashtable m_phoneUserID2UserName = new Hashtable();
  private Hashtable m_phoneUserID2Speak = new Hashtable();

  private Object m_lock = new String();
  private Vector m_audioListener = new Vector();
  private boolean m_isKilled = false;

  public CommunicationControlView(){
    super();
    m_myName = "Audio and Text Chat Control";
    m_myRenderer = new JavaViewRenderer(this,this);

    m_audioControl = new AudioControl();
    initialManagers();
    initialComponents();
    m_audioControl.setAxUserInfo(m_myUser.getUserID().getID());
    m_audioControl.add_DAXAudioTalkEventsListener(new MyListener());
    this.addAudioControlListener(this);

    broadcastMessage(m_myUser,"speak","f");
    m_audioControl.callMeeting();

    m_thread = new Thread(this);
    LogManager.log("Communication","start thread now");
    m_thread.start();
  }

  public String getID(){
    return m_myName;
  }

  public SharedletViewRenderer getRenderer(String MIMEType) {
    if (MIMEType.equals("application/java")) {
      return m_myRenderer;
    }
    return null;
  }

  public String getSharedletMIME(){
    return CommunicationSharedletInfo.g_sharedletMIME;
  }


  public AudioControl getAudioControl(){
    return m_audioControl;
  }

  public void addAudioControlListener(AudioControlListener al){
    m_audioListener.addElement(al);
  }

  private void initialManagers(){
    Context ctx = ContextManager.getInitialContext();
    try {
      m_capabilitiesManager = (CapabilitiesManager)ctx.lookup("services/CapabilitiesManager");
    } catch(NamingException e) {
      LogManager.err("CommSharedlet", "Unable to locate CapabilitiesManager", e);
    }
    m_capabilitiesManager.addCapabilityListener(this);

    CommunicationService commService = null;
    try {
      commService = (CommunicationService)ctx.lookup("services/CommunicationService");
    } catch(NamingException e) {
      LogManager.err("CommSharedlet", "Unable to locate CommunicationService", e);
    }

    try {
      GMS_Stream streamForPrivate = commService.findStream("application/x-sharedlet-auditorium/private");
      if (streamForPrivate == null) {  // Create the stream if it doesn't exist.
        streamForPrivate = commService.createStream("application/x-sharedlet-auditorium/private");
      }
      m_publisherForPrivate = streamForPrivate.createPublisher();

//hack, use VA public channel to inform the phone user info
      m_streamForPhoneUser = commService.findStream("application/x-sharedlet-auditorium/public");
      if (m_streamForPhoneUser == null) {  // Create the stream if it doesn't exist.
        m_streamForPhoneUser = commService.createStream("application/x-sharedlet-auditorium/public");
      }
//System.out.println(".......communication stream "+m_streamForPhoneUser);
      m_publisherForPhoneUser = m_streamForPhoneUser.createPublisher();
/*
      m_subscriberForPhoneUser = m_streamForPhoneUser.createSubscriber();
      m_subscriberForPhoneUser.setMessageListener(this);
*/
    } catch(GXO_AccessDeniedException e) {
      LogManager.err("CommSharedlet", "Unable to create publisher", e);
    } catch(NamingException e) {
      LogManager.err("CommSharedlet", "Unable to find stream", e);
    } catch(GXO_Exception e){
      LogManager.err("CommSharedlet", "Unable to set message listener", e);
    }

    try {
      SessionManager sessionManager = (SessionManager)ctx.lookup("services/SessionManager");
      m_myUser = sessionManager.getMyUser();
      m_capabilitiesManager = (CapabilitiesManager)ctx.lookup("services/CapabilitiesManager");
      m_capabilitiesManager.addCapabilityListener(this);
    } catch (NamingException e) {
      LogManager.err("CommSharedlet","Unable to locate SessionManager and/or CapabilitiesManager",e);
    }
  }

/*
  public void onMessage(GMS_Message m) {
  //if you want to process this message, please make sure you synchronize this msg with AuditoriumLogic

  }

  public void onRequest(GMS_Message m, GMS_MessageReplyer r){
    synchronized(m){  // because you have the same stream with Auditoirum, both get the same msg
      synchronized(m_lock){
        try {
          if(m instanceof GMS_TextMessage){
            GMS_TextMessage msg = (GMS_TextMessage)m;
            if(msg.getText().equals("requestphone")){
              GMS_ObjectMessage response =
               (GMS_ObjectMessage)m_publisherForPhoneUser.createMessage(GMS_Message.MSGTYPE_ADMINISTRATION,
                                                   GMS_Message.BODYTYPE_OBJECT);
              Vector v = new Vector();
              v.addElement(m_phoneUserID2UserName);
              v.addElement(m_phoneUserID2Speak);
              response.setObject(v);
              r.reply(m, response);
            }
          }
        } catch (GXO_Exception e) {
          LogManager.err("CommSharedlet","error onRequest",e);
        }
      }
    }
  }
*/

  private void initialComponents() {//GEN-BEGIN:initComponents
    this.setLayout(new GridBagLayout());
    Dimension d = new Dimension(150,65);
    this.setPreferredSize(d);
    this.setMaximumSize(d);
    this.setMinimumSize(d);

    Font f = new Font("Dialog",Font.PLAIN,12);
    m_microphoneIndicator = new VolumeIndicator(VolumeIndicator.HORIZONTAL,
                this.getBackground().brighter(), 8, 15, 0, 0);
    m_speakerSlider = new JSlider();

    m_selected = this.getBackground().darker();
    m_background = this.getBackground();

    m_broadcast = new JToggleButton("Talk");
    m_broadcast.setName("broadcast");
    m_broadcast.setFocusPainted(false);
    setButtonBorder(m_broadcast, false);
    m_handsfree = new JCheckBox();
    m_handsfree.setSelected(false);
    m_broadcast.setPreferredSize(new Dimension(40,20));
//    m_broadcast.setMargin(new Insets(0,1,0,1));
    m_broadcast.setMinimumSize(m_broadcast.getPreferredSize());
    m_handsfree.setPreferredSize(new Dimension(100,20));
//    m_handsfree.setMinimumSize(m_handsfree.getPreferredSize());
    m_handsfree.setFocusPainted(false);
    m_broadcast.setFont(f);
    m_handsfree.setFont(f);

    m_broadcast.setToolTipText("Hold Button To Talk");
    m_broadcast.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(java.awt.event.MouseEvent evt) {
        if(m_broadcast.isEnabled()){
          m_audioControl.startTalking();
          fireHoldButtonPressed(true);
        }
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        m_audioControl.stopTalking();
        fireHoldButtonPressed(false);
      }
    });

    try{
      m_textActive = new ImageIcon(StreamUtil.inputStreamToBytes(AudioTalkInApplication.class.getResourceAsStream("TextChat_Active.gif")));
      m_textInactive = new ImageIcon(StreamUtil.inputStreamToBytes(AudioTalkInApplication.class.getResourceAsStream("TextChat_Inactive.gif")));
    }catch(IOException ie){
      LogManager.err("Audio talk","can not load in image file");
    }

    m_textchat = new JButton(m_textInactive);
    m_textchat.setPreferredSize(new Dimension(m_textInactive.getIconWidth()+4, m_textActive.getIconHeight()+4));
    m_textchat.setMinimumSize(m_textchat.getPreferredSize());
    m_textchat.setToolTipText("Text Chat");
    setButtonBorder(m_textchat, false);

//textchat button has no other function, except blink when new message comes, and press to delete blinking
/*
    m_textchat.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(java.awt.event.MouseEvent evt) {
        if(m_isBlinking){
          m_textchat.setIcon(m_textInactive);
          m_isBlinking = false;
        }
      }
    });
*/
/*
    m_textchat.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(java.awt.event.MouseEvent evt) {
        m_textchat.setBackground(m_selected);
        setButtonBorder(m_textchat, true);
      }
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        Point position = evt.getPoint();
        if(m_textchat.contains(position)){
          try {
            Context ctx = ContextManager.getInitialContext();
            LayoutService layoutService = (LayoutService)ctx.lookup("services/LayoutService");
            CommunicationView view = (CommunicationView)ctx.lookup("sharedlets/application/x-sharedlet-communication/views/com.anabas.commsharedlet.CommunicationView");
            m_textchatSelected = !m_textchatSelected;
            if(m_textchatSelected){
              layoutService.activateView(view);
              synchronized(m_textchat){
                m_textchat.setBackground(m_selected);
                setButtonBorder(m_textchat, true);
                if(m_isBlinking){
                  m_textchat.setIcon(m_textInactive);
                  m_isBlinking = false;
                }
              }
            }
            else{
              layoutService.deactivateView(view);
              m_textchat.setBackground(m_background);
              setButtonBorder(m_textchat, false);
            }
          }catch (NamingException e) {
            LogManager.err("LauncherService","Unable to locate layout service",e);
            return;
          }
        }
        else{
          if(m_textchatSelected){
            m_textchat.setBackground(m_selected);
            setButtonBorder(m_textchat, true);
          }
          else{
            m_textchat.setBackground(m_background);
            setButtonBorder(m_textchat, false);
          }
        }
      }
    });
*/
    m_handsfree.setText("Hands Free");
    m_handsfree.setToolTipText("Check To Stay Talking");
    m_handsfree.setSelected(false);
    m_handsfree.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        if(m_handsfree.isSelected()){
          m_audioControl.startTalking();
          fireHandsFreeSelected(true);
          m_broadcast.setSelected(true);
          setButtonBorder(m_broadcast, true);
        }
        else{
          m_audioControl.stopTalking();
          fireHandsFreeSelected(false);
          m_broadcast.setSelected(false);
          setButtonBorder(m_broadcast, false);
        }
      }
    });

    m_microphoneIndicator.setBarPreferredSize(new Dimension(6,16));
    m_microphoneIndicator.setToolTipText("Microphone Volume");

    m_speakerSlider.setOrientation(javax.swing.SwingConstants.HORIZONTAL);
    m_speakerSlider.setMaximum(15);
    m_speakerSlider.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        speakerStateChanged(evt);
      }
    }
    );
    m_speakerSlider.setToolTipText("Speaker Volume");

    m_microphoneIndicator.setPreferredSize(new Dimension(72,18));
    m_microphoneIndicator.setMinimumSize(m_microphoneIndicator.getPreferredSize());
    m_speakerSlider.setPreferredSize(new Dimension(80, 16));
    m_speakerSlider.setMinimumSize(m_speakerSlider.getPreferredSize());

    ImageIcon micIcon = null;
    ImageIcon speakerIcon = null;

    try{
      micIcon = new ImageIcon(StreamUtil.inputStreamToBytes(AudioTalkInApplication.class.getResourceAsStream("mic.gif")));
      speakerIcon = new ImageIcon(StreamUtil.inputStreamToBytes(AudioTalkInApplication.class.getResourceAsStream("speaker.gif")));
    }catch(IOException ie){
      LogManager.err("Audio talk","can not load in image file");
    }

    JLabel micLabel = new JLabel(micIcon);
    micLabel.setPreferredSize(new Dimension(micIcon.getIconWidth(), micIcon.getIconHeight()));
    JLabel speakerLabel = new JLabel(speakerIcon);
    speakerLabel.setPreferredSize(new Dimension(speakerIcon.getIconWidth(),speakerIcon.getIconHeight()));

    JPanel audioPanel = new JPanel(new GridBagLayout());
    audioPanel.setPreferredSize(new Dimension(140, 36));
    audioPanel.setMinimumSize(audioPanel.getPreferredSize());

    constrain(audioPanel, speakerLabel,0,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,2,0,0,0);
    constrain(audioPanel, m_speakerSlider,1,0,1,1,GridBagConstraints.HORIZONTAL,
             GridBagConstraints.NORTHWEST,1.0,0.0,0,1,0,1);
    constrain(audioPanel, micLabel,0,1,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,2,0,0,0);
    constrain(audioPanel, m_microphoneIndicator,1,1,1,1,GridBagConstraints.HORIZONTAL,
             GridBagConstraints.NORTHWEST,1.0,0.0,0,4,0,4);

    JPanel buttonPanel = new JPanel(new GridBagLayout());
    buttonPanel.setPreferredSize(new Dimension(140, 22));
    buttonPanel.setMinimumSize(buttonPanel.getPreferredSize());
    constrain(buttonPanel, m_handsfree,0,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,1,0,1,0);
    constrain(buttonPanel, m_broadcast,1,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,1,5,1,0);

    constrain(this, audioPanel,0,0,1,1,GridBagConstraints.HORIZONTAL,
             GridBagConstraints.NORTHWEST,1.0,0.0,2,3,0,3);
    constrain(this, buttonPanel,0,1,1,1,GridBagConstraints.HORIZONTAL,
             GridBagConstraints.NORTHWEST,1.0,0.0,0,3,2,3);

//    constrain(this, m_broadcast,2,1,1,1,GridBagConstraints.NONE,
//             GridBagConstraints.NORTHWEST,0.0,0.0,2,5,2,3);
//    constrain(this, m_handsfree,0,1,1,1,GridBagConstraints.NONE,
//             GridBagConstraints.NORTHWEST,0.0,0.0,0,3,2,0);

//now we don't need textchat button
//    constrain(this, m_textchat,1,0,1,1,GridBagConstraints.NONE,
//             GridBagConstraints.NORTHWEST,0.0,0.0,2,5,0,2);

    if(m_capabilitiesManager.isCapable(CommunicationSharedletInfo.g_sharedletMIME, "talk")){
      m_handsfree.setEnabled(true);
      m_broadcast.setEnabled(true);
      byte mute = 0;
      m_audioControl.setSpeakerMute(mute);
    }
    else{
      m_handsfree.setEnabled(false);
      m_broadcast.setEnabled(false);
      byte mute = 1;
      m_audioControl.setSpeakerMute(mute);
    }

    ToolTipManager defaultToolTipManager  = ToolTipManager.sharedInstance();
    defaultToolTipManager.unregisterComponent(m_broadcast);
    defaultToolTipManager.unregisterComponent(m_textchat);
    defaultToolTipManager.unregisterComponent(m_handsfree);
    defaultToolTipManager.unregisterComponent(m_microphoneIndicator);
    defaultToolTipManager.unregisterComponent(m_speakerSlider);
    defaultToolTipManager.unregisterComponent(this);
    AnabasToolTipManager myToolTipManager = new AnabasToolTipManager();
    myToolTipManager.registerComponent(m_broadcast);
    myToolTipManager.registerComponent(m_textchat);
    myToolTipManager.registerComponent(m_handsfree);
    myToolTipManager.registerComponent(m_microphoneIndicator);
    myToolTipManager.registerComponent(m_speakerSlider);
    myToolTipManager.registerComponent(this);

  }//GEN-END:initComponents

  private void speakerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_speakerLeverStateChanged
    m_audioControl.setAxSpeakerVolume(m_speakerSlider.getValue());
    fireSpeakerVolumeChanged(m_speakerSlider.getValue());
  }//GEN-LAST:event_speakerLeverStateChanged

  public void fireSpeakerVolumeChanged(int volume){
    for(int i = 0; i<m_audioListener.size(); i++){
      ((AudioControlListener)m_audioListener.elementAt(i)).speakerVolumeChanged(m_speakerSlider.getValue());
    }
  }

  public void speakerVolumeChanged(int volume){
    if(volume != m_speakerSlider.getValue()){
      m_speakerSlider.setValue(volume);
    }
  }

  public void fireHoldButtonPressed(boolean pressed){
    for(int i = 0; i < m_audioListener.size(); i++){
      ((AudioControlListener)m_audioListener.elementAt(i)).holdButtonPressed(pressed);
    }
  }

  public void fireHandsFreeSelected(boolean selected){
    for(int i = 0; i < m_audioListener.size(); i++){
      ((AudioControlListener)m_audioListener.elementAt(i)).handsFreeSelected(selected);
    }
  }

  public void holdButtonPressed(boolean pressed){
    if(pressed){
      m_broadcast.setSelected(true);
      setButtonBorder(m_broadcast, true);
    }
    else{
      if(!m_handsfree.isSelected()){
        m_broadcast.setSelected(false);
        setButtonBorder(m_broadcast, false);
      }
      else{
        m_broadcast.setSelected(true);
        setButtonBorder(m_broadcast, true);
      }
    }
  }

  public void handsFreeSelected(boolean selected){
    if(selected && m_handsfree.isSelected()) return;
    if(!selected && !m_handsfree.isSelected()) return;
    if(selected){
      m_handsfree.setSelected(true);
      m_broadcast.setSelected(true);
      setButtonBorder(m_broadcast, true);
    }
    else{
      m_handsfree.setSelected(false);
      m_broadcast.setSelected(false);
      setButtonBorder(m_broadcast, true);
    }
  }

  class MyListener implements _DAXAudioTalkEventsListener{
    public void TunneledMessageIndication(_DAXAudioTalkEventsEvent e0){
//      System.out.println("TunneledMessageIndication "+e0.getArguments());
    }
    public void QueParticipantsChanged(_DAXAudioTalkEventsEvent e0){
//      System.out.println("QueParticipantsChanged "+e0.getArguments());
    }
    public void PositionInQueHasChanged(_DAXAudioTalkEventsEvent e0){
//      System.out.println("PositionInQueHasChanged "+e0.getArguments());
    }
    public void ParticipantsChanged(_DAXAudioTalkEventsEvent e0){
//System.out.println("=================audio user changed "+m_audioControl.getParticipants());
      updatePhoneUser();
    }
    public void ParticipantSpeakingIndication(_DAXAudioTalkEventsEvent e0){
//System.out.println("....speaking "+((AudioTalkOCX)e0.getSource()).GetLocalLabel());
      com.gensym.com.Variant[] arg = e0.getArguments();
      String label = arg[0].toString();
      String isSpeaking = arg[1].toString();
      if(m_phoneUserID2UserName.containsKey(label)){
        synchronized(m_lock){
          fireSpeakingEvent(label, isSpeaking);
        }
      }
    }

    public void ParticipantIsMuted(_DAXAudioTalkEventsEvent e0){
//      System.out.println("ParticipantIsMuted "+e0.getArguments());
    }
    public void FloorRequested(_DAXAudioTalkEventsEvent e0){
//      System.out.println("FloorRequested "+e0.getArguments());
    }
    public void ConnectionStatusChanged(_DAXAudioTalkEventsEvent e0){
//      System.out.println("ConnectionStatusChanged "+e0.getArguments());
    }
    public void ConferenceMessageReceived(_DAXAudioTalkEventsEvent e0){
//      System.out.println("ConferenceMessageReceived "+e0.getArguments());
    }
  }

  private void updatePhoneUser(){
    synchronized(m_lock){
      if(!m_isKilled){
        String participants = m_audioControl.getParticipants();
        if(participants != null){
          Vector newParticipants = parseParticipants(participants);
          checkUserChanged(newParticipants);
        }
      }
    }
  }

  private Vector parseParticipants(String participants){
    Vector newParticipants = new Vector();
    m_nameList.removeAllElements();
    StringTokenizer st0 = new StringTokenizer(participants,";");
    while(st0.hasMoreTokens()) {
      String part = (String)st0.nextToken();
      StringTokenizer st1 = new StringTokenizer(part,",");
      if(st1.hasMoreTokens()){
        String name = (String)st1.nextToken();
        boolean isPhoneUser = false;
        if(name.equals("Phone caller")) isPhoneUser = true;
//if(name.equals("Not Identified")) isPhoneUser = true;
        else if(name.length() == 10){
          isPhoneUser = true;
          for(int i = 0 ; i < 10; i++){
            if(name.charAt(i) < '0' || name.charAt(i) > '9'){
              isPhoneUser = false;
              break;
            }
          }
        }
        if(isPhoneUser){
          for(int i = 0; i < 4; i++) if(st1.hasMoreTokens())st1.nextToken();
          if(st1.hasMoreTokens()){
            newParticipants.addElement((String)st1.nextToken());
            m_nameList.addElement(name);
          }
        }
      }
    }
    return newParticipants;
  }

  public boolean isDigit(String s) {
    try {
      long i = Long.parseLong(s);
    } catch(NumberFormatException e) {
      return false;
    }
    return true;
  }

  private void checkUserChanged(Vector newParticipants){
    Vector userJoin = new Vector();
    Vector userLeft = new Vector();
    Vector names = new Vector();
    for(int i = 0; i < newParticipants.size(); i++){
      if(!m_participants.contains(newParticipants.elementAt(i)))
        userJoin.addElement(newParticipants.elementAt(i));
        names.addElement(m_nameList.elementAt(i));
    }
    for(int i = 0; i < m_participants.size(); i++){
      if(!newParticipants.contains(m_participants.elementAt(i)))
        userLeft.addElement(m_participants.elementAt(i));
    }
    m_participants = newParticipants;

    for(int i = 0; i < userJoin.size(); i++){
      m_phoneUserID2UserName.put((String)userJoin.elementAt(i),(String)names.elementAt(i));
      if(m_phoneUserID2Speak.contains((String)userJoin.elementAt(i))){
        unicastMsg("PhoneUserJoin", (String)userJoin.elementAt(i), (String)names.elementAt(i),"t");
      }
      else unicastMsg("PhoneUserJoin", (String)userJoin.elementAt(i), (String)names.elementAt(i),"f");
    }
    for(int i = 0; i < userLeft.size(); i++){
      m_phoneUserID2UserName.remove((String)userLeft.elementAt(i));
      unicastMsg("PhoneUserLeft", (String)userLeft.elementAt(i),"left","f");
    }

  }
//hack, send message for phone user. We call it unicast since only one sender and one receiver
  private void unicastMsg(String command, String label, String name, String isSpeaking){
    GMS_TextMessage response = null;
    try {
      GMS_TextMessage msg = (GMS_TextMessage)m_publisherForPhoneUser.createMessage(
               GMS_Message.MSGTYPE_ADMINISTRATION,GMS_Message.BODYTYPE_TEXT);
      msg.setProperty("messagetype", "phoneuser");
      msg.setProperty("label", label);
      msg.setProperty("name", name);
      msg.setProperty("command", command);
      msg.setProperty("isSpeaking", isSpeaking);

      GMS_UserDestinationSelector selector = (GMS_UserDestinationSelector)
        m_publisherForPhoneUser.createDestinationSelector("GMS_UserDestinationSelector");
      selector.setUserID(m_myUser.getUserID());
      GMS_Destination dst = m_streamForPhoneUser.findDestination(selector);

      response = (GMS_TextMessage)m_publisherForPhoneUser.request(msg,dst,1000);
      if(response == null){
        LogManager.log("communicationsharedlet","====== phone user join, nut no reply from auditorium");
      }
      int i = 0;
      while(response == null && i < 3){
        try{
          Thread.sleep(3000);
        }catch(InterruptedException ie){}
        response = (GMS_TextMessage)m_publisherForPhoneUser.request(msg,dst,2000);
        i++;
        LogManager.log("communicationsharedlet","======resend phone user join, but no reply from auditorium "+i);
      }
    } catch (GXO_Exception ex) {
        LogManager.err("commSharedlet","Unable to broadcast the phone user msg",ex);
    }
  }

  private void fireSpeakingEvent(String label, String isSpeaking){
    if(isSpeaking.toLowerCase().equals("true")){
      isSpeaking = "t";
      m_phoneUserID2Speak.put(label,isSpeaking);
    }
    else{
     isSpeaking = "f";
     if(m_phoneUserID2Speak.containsKey(label))m_phoneUserID2Speak.remove(label);
    }
    unicastMsg("speaking", label, (String)m_phoneUserID2UserName.get(label),isSpeaking);
  }

  public void run() {
    int newValue, oldValue=-1;
    int count = 0;
    while(!m_isKilled){
      count++;
      m_microphoneIndicator.setValue((int)(MIC_RATIO*m_audioControl.getAxMicEnergy()));
      m_microphoneIndicator.repaint(100);
      if(m_microphoneIndicator.getValue() > s_threshold){
        if(!m_micIsOn){
          m_micIsOn = true;
          broadcastMessage(m_myUser,"speak","t");
        }
      }
      else{
        if(m_micIsOn){
          m_micIsOn = false;
          broadcastMessage(m_myUser,"speak","f");
        }
      }
      try{
        m_thread.sleep(300);
      }catch(InterruptedException e){
        LogManager.err("commsharedlet","Audio Control",e);
      }
      newValue = m_audioControl.getAxConnectionStatus();
      if(newValue != oldValue){
        setStatus(newValue);
      }
      oldValue = newValue;
      if(count > 20){
        count = 0;
        updatePhoneUser();
      }
    }
  }

  public void setStatus (int n){
//    System.out.println("in status changed: "+n);
    if(n==0){
      this.setToolTipText("not connected");
    }else if(n == 1){
      this.setToolTipText("connecting");
    }else if(n == 2){
      this.setToolTipText("ringing");
    }else if(n == 3){
      this.setToolTipText("connected");
    }else if(n == 4){
       this.setToolTipText("disconnected");
    }
  }

  public void newTextchatComing(){
    synchronized(m_textchat){
      if(!(m_textchatSelected || m_isBlinking)){
        m_textchat.setIcon(m_textActive);
        m_isBlinking = true;
        m_textchat.repaint(100);
      }
    }
  }


  public void modeChanged(short newMode) {
  }

  public void roleChanged(String newRole){}

  public void remoteCapabilityChanged(String capability, boolean enabled, UserID userid) {
  }

  public void capabilityChanged(String capability, boolean enabled){
    if(capability.equals("talk")){
      byte mute = 0;
      if(enabled == false){
        m_handsfree.setSelected(false);
        m_broadcast.setSelected(false);
        setButtonBorder(m_broadcast, false);
        m_audioControl.stopTalking();
        mute = 1;
      }
      m_handsfree.setEnabled(enabled);
      m_broadcast.setEnabled(enabled);
      m_audioControl.setSpeakerMute(mute);
    }
  }

  public void broadcastMessage(User user, String messageType, String messageText){
    try {
      GMS_ObjectMessage msg = (GMS_ObjectMessage)m_publisherForPrivate.createMessage(
               GMS_Message.MSGTYPE_ADMINISTRATION,GMS_Message.BODYTYPE_OBJECT);
      msg.setObject(user);
      msg.setProperty("messagetype", messageType);
      msg.setProperty("messagecontent", messageText);
      m_publisherForPrivate.broadcast(msg);
    } catch (GXO_Exception ex) {
        LogManager.err("auditorium","Unable to broadcast "+user,ex);
    }
  }

  public void setButtonBorder(JComponent component, boolean selected){
    Color background = component.getBackground();
    Color highlight = component.getBackground().brighter().brighter();
    Color shadow = component.getBackground().darker().darker();
    Border b;
    if(selected) b = new BevelBorder(BevelBorder.LOWERED, highlight,background,
                  shadow, background);
    else b = new BevelBorder(BevelBorder.RAISED, highlight,background,
                  shadow, background);
//      Border b = new EtchedBorder(EtchedBorder.LOWERED);
    component.setBorder(b);
  }

  private void constrain( Container container, Component component,
             int grid_x,int grid_y, int grid_width, int grid_height,
             int fill, int anchor, double weight_x, double weight_y,
             int top, int left, int bottom, int right)
   {
      GridBagConstraints c= new GridBagConstraints();
      c.gridx=grid_x; c.gridy=grid_y;
      c.gridwidth=grid_width; c.gridheight=grid_height;
      c.fill=fill; c.anchor=anchor;
      c.weightx=weight_x; c.weighty=weight_y;
      if(top+bottom+left+right>0)
      c.insets = new Insets(top,left,bottom,right);
      ((GridBagLayout)container.getLayout()).setConstraints(component, c);
      container.add(component);
   }

   private void pleaseStop(){
     m_isKilled = true;
   }

   public void deactivate(){
     pleaseStop();
     int count = 0;
     while(m_thread.isAlive() && count < 10){
       count++;
       try{
         Thread.sleep(500);
       }catch(InterruptedException ie){
         LogManager.err("Communication"," can not stop thread", ie);
       }
     }

     if(count >= 10) {
       LogManager.err(LogManager.PRODUCTION,"Communication",
                      "Unable to release communication control co-operatively.");
       m_thread.stop();
       LogManager.log(LogManager.PRODUCTION,"Communication","thread is forced to stop");
     }
     else LogManager.log("Communication","thread stop now");

     m_audioControl.deactivate();
     LogManager.log("Communication","Deactivated");
//     System.gc();
   }

   public void activate(){}

   public void loadDocument(java.net.URL url){}
}