package com.anabas.commsharedlet;

import com.anabas.sharedlet.*;
import java.awt.Dimension;
import java.util.Vector;

/**
 * Title:
 * Description:  This project contains the Anabas, Inc. collaboration framework libraries.
 * Copyright:    Copyright (c) 2000
 * Company:      Anabas, Inc.
 * @author John Yin
 * @version 1.0
 */

public class CommunicationSharedletInfo extends SharedletRCUtil implements SharedletInfo {

  /**
   * Private Member
   */
  private Vector m_myViewInfos = new Vector();
  private Vector m_myCapabilities = new Vector();
  private Vector m_myLogicInfos = new Vector();

  private static String s_supportedDataTypes[] = { "application/x-sharedlet-communication" };
  public static final String g_sharedletMIME = "application/x-sharedlet-communication";
  /**
   * Constructor.  Constructs view infos.
   */
  public CommunicationSharedletInfo() {

    m_myViewInfos.addElement(new CommunicationControlViewInfo());
    m_myViewInfos.addElement(new CommunicationViewInfo());
    m_myLogicInfos.addElement(new CommunicationSessionLogicInfo());

    setCapabilities("talk,textchat");
    setModeratable("Microphone","talk");
    setRole("Host","talk,textchat","Audio and Text Chat,Audio and Text Chat Control","Microphone");
    setRole("Moderator","talk,textchat","Audio and Text Chat,Audio and Text Chat Control","Microphone");
    setRole("Participant","textchat","Audio and Text Chat,Audio and Text Chat Control","");
  }

  /**
   * @return "communication Sharedlet"
   */
  public String   getDescription() { return "Audio and Text Chat"; }

  /**
   * @return "application/x-sharedlet-communication"
   */
  public String   getMIMEType()   { return g_sharedletMIME; }

  /**
   * @return Support for "application/x-sharedlet-communication"
   */
  public String[] getSupportedDataTypes() { return s_supportedDataTypes; }

  /**
   * @return 1.0
   */
  public double   getVersion() { return 1.0; }

  public SharedletViewInfo  getViewInfo(String name) {
    java.util.Enumeration enum = m_myViewInfos.elements();
    while(enum.hasMoreElements()) {
      SharedletViewInfo info = (SharedletViewInfo)enum.nextElement();
      if (info.getID().equals(name)) return info;
    }
    return null;
  }

  public Vector getLogicInfos() {
    return m_myLogicInfos;
  }

  public Vector getViewInfos() {
    return m_myViewInfos;
  }

  public String[] getSupportedDocumentTypes(){return null;}

}