package com.anabas.commsharedlet;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.anabas.util.misc.LogManager;
import java.util.Vector;
import com.anabas.util.ui.AnabasMessageDialog;

import com.anabas.sharedlet.*;
import com.anabas.gxo.*;
import com.anabas.naming.*;
import com.anabas.concepts.*;

public class Textchat extends JPanel implements ActionListener,GMS_MessageListener, CapabilityListener{
   private JButton m_send, m_help;
   private JToggleButton m_pause;
   private JTextField m_textField;
   private JTextArea m_textArea;
   private JScrollPane m_messagePane;

   private GMS_Stream m_streamForPrivate;
   private GMS_StreamPublisher m_publisherForPrivate;
   private GMS_StreamSubscriber m_subscriberForPublic;
   private CapabilitiesManager m_capabilitiesManager;
   private User m_myUser;
   private String m_myUserName;
   private Vector m_textchatListener = new Vector();

   private boolean m_isReady = false;
   private Object m_lock = new String();

   private AnabasMessageDialog m_helpDialog = null;

   public Textchat() {
     this.setName("Text Chat");
     this.setLayout(new GridBagLayout());
     initialComponents();
     initialManagers();
     synchronized (m_lock){
       updateState();
     }
     //anyway, in case update has something wrong, we should let user can receive message
     m_isReady = true;
   }

   public void initialComponents(){
     m_send = new JButton("Send");
     m_pause = new JToggleButton("Pause");
     m_help = new JButton("Help");
     m_send.setPreferredSize(new Dimension(50,25));
     m_send.setMargin(new Insets(2,2,2,2));
     m_pause.setPreferredSize(new Dimension(60,25));
     m_pause.setMargin(new Insets(2,2,2,2));
     m_help.setPreferredSize(new Dimension(50,25));
     m_help.setMargin(new Insets(2,2,2,2));
     m_send.setActionCommand("send");
     m_pause.setActionCommand("pause");
     m_help.setActionCommand("help");
     m_pause.setSelected(false);
     m_send.setFocusPainted(false);
     m_help.setFocusPainted(false);
     m_pause.setFocusPainted(false);
     m_send.addActionListener(this);
     m_pause.addActionListener(this);
     m_help.addActionListener(this);

     m_textArea = new JTextArea(); //otherwise use, for example (6,20)
     m_textArea.setText("Text Chat Board: ");
     m_textArea.setLineWrap(true);
     m_textArea.setWrapStyleWord(true);
     m_textArea.setEditable(false);
     m_textField = new JTextField();
     m_textField.setPreferredSize(new Dimension(230,25));
     m_textField.addKeyListener(new MyKeyListener());
     m_textArea.setBackground(Color.white);
     m_textArea.setOpaque(true);
     m_textField.setBackground(Color.white);
     m_textField.setOpaque(true);

     m_textArea.addComponentListener(new ComponentAdapter(){
       public void componentResized(ComponentEvent e){
         if(!m_pause.isSelected())scrollUp();
       }
     });
     m_messagePane = new JScrollPane(m_textArea);
     m_messagePane.setBackground(Color.white);
     m_messagePane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
     m_messagePane.setAutoscrolls(true);
     JPanel bottom = new JPanel(new GridBagLayout());
     constrain(bottom,m_textField,0,0,1,1,GridBagConstraints.BOTH,
             GridBagConstraints.NORTHWEST, 1.0, 1.0,0,0,0,0);
     constrain(bottom, m_send,1,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,0,2,0,0);
     constrain(bottom, m_pause,2,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,0,2,0,0);
     constrain(bottom, m_help,3,0,1,1,GridBagConstraints.NONE,
             GridBagConstraints.NORTHWEST,0.0,0.0,0,2,0,0);

     this.setPreferredSize(new Dimension(400,125));
     constrain(this,m_messagePane,0,0,1,1,GridBagConstraints.BOTH,
             GridBagConstraints.NORTHWEST, 1.0, 1.0,3,3,3,3);
     constrain(this,bottom,0,1,1,1,GridBagConstraints.HORIZONTAL,
             GridBagConstraints.NORTHWEST, 1.0, 0.0,0,3,2,3);

//     constrain(this,m_textField,0,1,1,1,GridBagConstraints.HORIZONTAL,
//             GridBagConstraints.NORTHWEST, 1.0, 0.0,0,3,0,0);
//     constrain(this, m_send,1,1,1,1,GridBagConstraints.NONE,
//             GridBagConstraints.NORTHWEST,0.0,0.0,0,2,0,0);
//     constrain(this, m_pause,2,1,1,1,GridBagConstraints.NONE,
//             GridBagConstraints.NORTHWEST,0.0,0.0,0,2,0,2);

     m_messagePane.addComponentListener(new ComponentAdapter(){
       public void componentResized(ComponentEvent e){
         if(m_textArea != null && !m_pause.isSelected()) scrollUp();
       }
     });

   }

   public void constrain( Container container, Component component,
             int grid_x,int grid_y, int grid_width, int grid_height,
             int fill, int anchor, double weight_x, double weight_y,
             int top, int left, int bottom, int right)
   {
      GridBagConstraints c= new GridBagConstraints();
      c.gridx=grid_x; c.gridy=grid_y;
      c.gridwidth=grid_width; c.gridheight=grid_height;
      c.fill=fill; c.anchor=anchor;
      c.weightx=weight_x; c.weighty=weight_y;
      if(top+bottom+left+right>0)
      c.insets = new Insets(top,left,bottom,right);
      ((GridBagLayout)container.getLayout()).setConstraints(component, c);
      container.add(component);
   }


   class MyKeyListener extends KeyAdapter{
     public void keyReleased(KeyEvent ke){
       if(ke.getKeyCode()==KeyEvent.VK_ENTER){
         if(m_textField.getText().length() > 0){
           writeText(m_myUserName+": "+m_textField.getText());
           broadcastMessage("textchat",m_textField.getText());
         }
         m_textField.setText("");
       }
     }
   }

   public void actionPerformed(ActionEvent e){
     if(e.getActionCommand().equals("send")){
       if(m_textField.getText().length() > 0){
         writeText(m_myUserName+": "+m_textField.getText());
         broadcastMessage("textchat",m_textField.getText());
       }
       m_textField.setText("");
     }
     if(e.getActionCommand().equals("pause")){
       if(m_pause.isSelected()){
         m_messagePane.setAutoscrolls(false);
       }
       else m_messagePane.setAutoscrolls(true);
     }
     if(e.getActionCommand().equals("help")){
       String message = "Use Ctrl-C to copy"+"\n"+"Use Ctrl-V to paste"+"\n"+"Click Pause button to freeze the movement of scrollbar";
//       JOptionPane.showMessageDialog(this, message, "Help", JOptionPane.PLAIN_MESSAGE);
       if(m_helpDialog == null) m_helpDialog = new AnabasMessageDialog(this, message, "Help", AnabasMessageDialog.INFORMATION_MESSAGE);
       m_helpDialog.setVisible(true);
     }
   }

   public void scrollUp()
   {
     JScrollBar vbar = m_messagePane.getVerticalScrollBar();
     vbar.setValue(vbar.getMaximum());
   }

   public void writeText(String typeInText){
     JScrollBar vbar = m_messagePane.getVerticalScrollBar();
     int p = vbar.getValue();

     m_textArea.append("\n"+typeInText);
     if(m_pause.isSelected()) vbar.setValue(p);
     else{
       // delay needed for append thread to finish before setting the scroll bar
       // work around for Java bug #4201999
       try {Thread.sleep(100); } catch (InterruptedException e) {}
       scrollUp();
//       m_textArea.setCaretPosition(m_textArea.getText().length());
     }
   }

   public void show(){
     this.setVisible(true);
   }

   public void hide(){
     this.setVisible(false);
   }

   public void initialManagers(){
     try {
       Context ctx = ContextManager.getInitialContext();
       CommunicationService commService = (CommunicationService)ctx.lookup("services/CommunicationService");
       m_streamForPrivate = commService.findStream(CommunicationSharedletInfo.g_sharedletMIME+"/private");
       if (m_streamForPrivate == null) {  // Create the stream if it doesn't exist.
         m_streamForPrivate = commService.createStream(CommunicationSharedletInfo.g_sharedletMIME+"/private");
       }
       m_publisherForPrivate = m_streamForPrivate.createPublisher();

       GMS_Stream stream = commService.findStream(CommunicationSharedletInfo.g_sharedletMIME+"/public");
       if (stream == null) {  // Create the stream if it doesn't exist.
         stream = commService.createStream(CommunicationSharedletInfo.g_sharedletMIME+"/public");
       }
       m_subscriberForPublic = stream.createSubscriber();
       m_subscriberForPublic.setMessageListener(this);

       SessionManager sessionManager = (SessionManager)ctx.lookup("services/SessionManager");
       m_myUser = sessionManager.getMyUser();
       m_myUserName = m_myUser.getFirstName()+" "+m_myUser.getLastName();

       m_capabilitiesManager = (CapabilitiesManager)ctx.lookup("services/CapabilitiesManager");
       m_capabilitiesManager.addCapabilityListener(this);

       CommunicationControlView controlView = null;
       try{
         controlView = (CommunicationControlView)ctx.lookup("sharedlets/application/x-sharedlet-communication/views/com.anabas.commsharedlet.CommunicationControlView");
       } catch (NamingException e) {
         LogManager.err("Communication audiotlak","Unable to get control view",e);
       }
       if(controlView != null)this.addTextchatListener(controlView);
     } catch (Exception e) {
       LogManager.err("communicationSharedlet","Unable to get comm service inside textchat",e);
     }

   }

   public void broadcastMessage(String messageType, String messageText){
     try {
       GMS_TextMessage msg = (GMS_TextMessage)m_publisherForPrivate.createMessage(GMS_Message.MSGTYPE_ADMINISTRATION,
                                                    GMS_Message.BODYTYPE_TEXT);
       msg.setProperty("messagetype", messageType);
       msg.setProperty("username", m_myUserName);
       msg.setProperty("userid",m_myUser.getUserID().getID());
       msg.setText(messageText);
       m_publisherForPrivate.broadcast(msg);

     } catch (GXO_Exception ex) {
         LogManager.err("Textchat","Unable to broadcast",ex);
     }
   }

   public void onMessage(GMS_Message message) {
    if(!m_isReady) return;
    synchronized(m_lock){
      if(message instanceof GMS_TextMessage){
        GMS_TextMessage msg = (GMS_TextMessage)message;
        try {
          String messageType = (String)msg.getProperty("messagetype");
          if(messageType.equals("textchat")){
            String userName = (String)msg.getProperty("username");
            String userID = (String)msg.getProperty("userid");
            if(!userID.equals(m_myUser.getUserID().getID())){
              writeText(userName+": "+msg.getText());
              fireNewTextChatEvent();
            }
          }
        } catch (GXO_Exception e) {
          LogManager.err("Textchat","Unable to extract  the message",e);
        }
      }
    }
  }

  public void addTextchatListener(TextchatListener tl){
    m_textchatListener.addElement(tl);
  }

  private void fireNewTextChatEvent(){
    for(int i= 0; i < m_textchatListener.size(); i++){
      TextchatListener tl = (TextchatListener)m_textchatListener.elementAt(i);
      tl.newTextchatComing();
    }
  }

  public void onRequest(GMS_Message message,GMS_MessageReplyer replyer) {
  }

  private void updateState() {
    GMS_TextMessage response = null;
    try {
      GMS_TextMessage requestMsg = (GMS_TextMessage)m_publisherForPrivate.createMessage(GMS_Message.MSGTYPE_ADMINISTRATION,
                                                           GMS_Message.BODYTYPE_TEXT);
      requestMsg.setText("request");
      GMS_MulticastDestinationSelector selector = (GMS_MulticastDestinationSelector)
        m_publisherForPrivate.createDestinationSelector("GMS_MulticastDestinationSelector");
      GMS_Destination   dst    = m_streamForPrivate.findDestination(selector);
      response = (GMS_TextMessage)m_publisherForPrivate.request(requestMsg,dst,1000);
      m_isReady = true;
      if(response != null) {
        String text = response.getText();
        if(text.length() > 0)writeText(text);
      }// otherwise, we suppose no text chat published before
    } catch (GXO_Exception e) {
      LogManager.err("CommunicationSharedlet","Unable to update sessionLogic state",e);
    }
  }


  public String getSharedletMIME(){
    return CommunicationSharedletInfo.g_sharedletMIME;
  }

  public void roleChanged(String newRole){}

  public void modeChanged(short newMode) {
  }

  public void remoteCapabilityChanged(String capability, boolean enabled, UserID userid) {
  }
  public void capabilityChanged(String capability, boolean enabled){
    if(capability.equals("textchat")){
      m_send.setEnabled(enabled);
      m_pause.setEnabled(enabled);
      m_textField.setEnabled(enabled);
      m_textArea.setEnabled(enabled);
    }
  }

  public void deactivate(){
    if(m_helpDialog != null) {
      m_helpDialog.setVisible(false);
      m_helpDialog.dispose();
      m_helpDialog = null;
    }
  }

}
















