package com.anabas.sdsharedlet;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.JFrame;

import com.anabas.sharedlet.*;
import com.anabas.util.misc.LogManager;
import com.anabas.sharedlet.NativeRenderer;
import com.anabas.naming.*;

/**
 * Title:        Shared Display Sharedlet
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Anabas Inc.
 * @author
 * @version 1.0
 */

public class SDNativeRenderer extends Component implements NativeRenderer
{
    private SDWrapper m_sdWrapper;
    private SDControlView m_controlView;
    private Point m_pt = new Point();
    private Dimension m_dim = new Dimension();
    private Vector m_compListeners = new Vector();
    private Vector m_wndListeners = new Vector();
    private SharedletViewManager m_viewManager;

    private SharedletInfo m_sharedletInfo;
    private Container m_parent;
    private JFrame m_mainFrame;
    private ComponentListener m_compListener1;
    private ComponentListener m_compListener2;

    private WindowListener m_wndListener;

    private byte[] m_eventData;

    public SDNativeRenderer(SDWrapper sdWrapper)
    {
	//log("--------------------------> SDNativeRenderer called ");
	m_sdWrapper = sdWrapper;
	m_eventData = new byte[80];
	if(m_sdWrapper == null)
	{
	    log("### SDNativeRenderer: could not get the SDWrapper ");
	}

	getControlView();
    }

  public void setLocation(Point pt) {
    /*log("<<<<<<<<<<<<< setLocation called [" + pt + "]>>>>>>>>>>>>>>>>");*/
    m_sdWrapper.SetPosition(pt.x,pt.y,-1,-1,true);
    //m_lastLocation = pt;
  }

  public void setDimension(Dimension dim) {
    /*log("<<<<<<<<<<<<< setDimension called [" + dim + "] >>>>>>>>>>>>>>>>");*/
    m_sdWrapper.SetPosition(-1,-1,dim.width,dim.height,true);
  }

  public void setVisible(boolean visible) {
    //log("<<<<<<<<<<<<< setVisible called >>>>>>>>>>>>>>>>");
    if(!m_sdWrapper.SetPosition(-1,-1,-1,-1,visible)) {
      log("!!!!!!!!!!!!!!!! SetVisible failed !!!!!!!!!!!!!!!!!");
    }
  }

  public void addComponentListener(ComponentListener listener) {
    m_compListeners.addElement(listener);
  }

  public void removeComponentListener(ComponentListener listener) {
    m_compListeners.removeElement(listener);
  }

  public void addWindowListener(WindowListener listener) {
    m_wndListeners.addElement(listener);
  }

  public void removeWindowListener(WindowListener listener) {
    m_wndListeners.removeElement(listener);
  }

  public Object getRendering() {
    return this;
  }

  public Point getLocation() {
    //log("<<<<<<<<<<<<< getLocation called >>>>>>>>>>>>>>>>");
    //Point pt = new Point();
    m_pt.x = byteArrToInt(m_eventData,14);
    m_pt.y = byteArrToInt(m_eventData,18);
    return m_pt;
  }

  public Dimension getDimension() {
    //log("<<<<<<<<<<<<< getDimension called >>>>>>>>>>>>>>>>");
    //Dimension dim = new Dimension();
    int left = byteArrToInt(m_eventData,14);
    int top = byteArrToInt(m_eventData,18);
    int right = byteArrToInt(m_eventData,22);
    int bottom = byteArrToInt(m_eventData,26);
    m_dim.width = right - left;
    m_dim.height = bottom - top;
    return m_dim;
  }

  public void toFront() {
  //log("!!!!!!!! toFront: called !!!!!!!!!");
    //setVisible(true);
    setLocation(m_parent.getLocationOnScreen());

    /*if(m_controlView != null || getControlView())
    {
      int wnd = m_controlView.getLastActivatedWnd();
      log("!!!!!!! calling click to share on wnd [" + wnd + "]");
      if(wnd != 0)
        m_sdWrapper.ClickToShare(wnd,SDWrapper.CTS_ACTIVATE);
    }
    callWndActivated();*/
  }

  void setWindowEvent(WindowEvent we,byte[] eventData) {
    m_eventData = eventData;
    /*Enumeration enum = m_wndListeners.elements();
    while (enum.hasMoreElements()) {
      WindowListener listener = (WindowListener) enum.nextElement();*/
      switch (we.getID()) {
        case WindowEvent.WINDOW_ACTIVATED:
          //log("!!!!!!!!!!!!!!!! got wnd activated from native  !!!!!!!!!!!!!!!!!!");
          if(m_mainFrame != null)
            m_mainFrame.setVisible(true);
          //listener.windowActivated(we);
          break;
        case WindowEvent.WINDOW_CLOSED:
          //listener.windowClosed(we);
          break;
        case WindowEvent.WINDOW_CLOSING:
          //listener.windowClosing(we);
          break;
        case WindowEvent.WINDOW_DEACTIVATED:
          //listener.windowDeactivated(we);
          break;
        case WindowEvent.WINDOW_DEICONIFIED:
          //listener.windowDeiconified(we);
          break;
        case WindowEvent.WINDOW_ICONIFIED:
          //listener.windowIconified(we);
          break;
        case WindowEvent.WINDOW_OPENED:
          //listener.windowOpened(we);
          break;
        default:
          log("!!!!!!!!!!!!!!!!!!!!!!!! Unknown wnd event got in Renderer !!!!!!!!!!!!!!!!!!!!!!!");
          break;
      }
    //}
  }

  void setComponentEvent(ComponentEvent ce,byte[] eventData) {
    m_eventData = eventData;
    /*Enumeration enum = m_compListeners.elements();
    while (enum.hasMoreElements()) {
      ComponentListener listener = (ComponentListener) enum.nextElement();*/
      switch (ce.getID()) {
        case ComponentEvent.COMPONENT_HIDDEN:
          //listener.componentHidden(ce);
          break;
        case ComponentEvent.COMPONENT_MOVED:
          //listener.componentMoved(ce);
          break;
        case ComponentEvent.COMPONENT_RESIZED:
          //listener.componentResized(ce);
          break;
        case ComponentEvent.COMPONENT_SHOWN:
          //listener.componentShown(ce);
          break;
        default:
          log("!!!!!!!!!!!!!!!!!!!!!!!! Unknown componenet event got in Renderer !!!!!!!!!!!!!!!!!!!!!!!");
          break;
      }
    //}
  }

  /*private void callWndActivated() {
    Window wnd = new Frame();
    WindowEvent we = new WindowEvent(wnd,WindowEvent.WINDOW_ACTIVATED);

    Enumeration enum = m_wndListeners.elements();
    while (enum.hasMoreElements()) {
      WindowListener listener = (WindowListener) enum.nextElement();
      listener.windowActivated(we);
    }
  }*/

  boolean getControlView() {
    try {
      m_controlView = (SDControlView) getMyView(
                        SDControlViewInfo.g_SDControlViewName);
    }
    catch (Exception ex) {
      err("getControlView: Err:" , ex);
      return false;
    }
    return true;
  }

  static int byteArrToInt(byte[] ba,int startIndex) {
    int result = 0;
    int tmp = 0;
    for(int iCount=startIndex;iCount < startIndex+4;iCount++) {
      tmp = ba[iCount];
      tmp &= 0xFF;
      tmp <<= (8*(iCount-startIndex));
      result |= tmp;
    }
    return result;
  }

  public void doLayout() {
    log("<<<<<<<<<<<<< doLayout called >>>>>>>>>>>>>>>>");
  }

  public float getAlignmentX() {
    log("<<<<<<<<<<<<< getAlignmentX called >>>>>>>>>>>>>>>>");
    return super.getAlignmentX();
  }

  public float getAlignmentY() {
    //log("<<<<<<<<<<<<< getAlignmentY called >>>>>>>>>>>>>>>>");
    return super.getAlignmentY();
  }

  public Rectangle getBounds() {
    //log("<<<<<<<<<<<<< getAlignmentY called >>>>>>>>>>>>>>>>");
    Point p = this.getLocation();
    Dimension d = this.getDimension();
    return new Rectangle(p,d);
  }

  public void setBounds(int x,
                      int y,
                      int width,
                      int height) {
    /*log("<<<<<<<<<<<<< setBounds called [" + x + "," + y + "," +
                    width + "," + height + "]    >>>>>>>>>>>>>>>>");*/
    //Component container = getParent();
    if(m_parent == null) {
      m_parent = getParent();
      if(m_parent == null) {
        log("<<<<<<<<<<<<< Could not get parent >>>>>>>>>>>>>>");
        return;
      }
    }
    Point pt = m_parent.getLocationOnScreen();
    setLocation(pt);
    setDimension(new Dimension(width,height));
  }

  public int getHeight() {
    log("<<<<<<<<<<<<< getHeight called >>>>>>>>>>>>>>>>");
    return 5;
  }

  public int getWidth() {
    log("<<<<<<<<<<<<< getWidth called >>>>>>>>>>>>>>>>");
    return 5;
  }

  public Dimension getMaximumSize() {
    //log("<<<<<<<<<<<<< getMaximumSize called >>>>>>>>>>>>>>>>");
    return new Dimension(5,5);
  }

  public Dimension getMinimumSize() {
    //log("<<<<<<<<<<<<< getMinimumSize called >>>>>>>>>>>>>>>>");
    return new Dimension(5,5);
  }

  public Dimension getPreferredSize() {
    //log("<<<<<<<<<<<<< getPreferredSize called >>>>>>>>>>>>>>>>");
    return new Dimension(5,5);
  }

  public Dimension getSize() {
    log("<<<<<<<<<<<<< getSize-1 called >>>>>>>>>>>>>>>>");
    return new Dimension(5,5);
  }

  public Dimension getSize(Dimension rv) {
    log("<<<<<<<<<<<<< getSize-2 called >>>>>>>>>>>>>>>>");
    if(rv == null)
      return new Dimension(5,5);
    else {
      rv.width = 5;
      rv.height = 5;
      return rv;
    }
  }

  /*public void addFocusListener(FocusListener l){
    log("<<<<<<<<<<<<< addFocusListener called >>>>>>>>>>>>>>>>");
  }

  public Toolkit getToolkit() {
    log("<<<<<<<<<<<<< getToolkit called >>>>>>>>>>>>>>>>");
    return null;
  }

  public boolean hasFocus() {
    log("<<<<<<<<<<<<< hasFocus called >>>>>>>>>>>>>>>>");
    return true;
  }

  public void invalidate() {
    log("<<<<<<<<<<<<< invalidate called >>>>>>>>>>>>>>>>");
  }

  public boolean isDisplayable() {
    log("<<<<<<<<<<<<< invalidate called >>>>>>>>>>>>>>>>");
    return true;
  }

  public boolean isVisible() {
    log("<<<<<<<<<<<<< isVisible called >>>>>>>>>>>>>>>>");
    return true;
  }

  public boolean isFocusTraversable() {
    log("<<<<<<<<<<<<< isFocusTraversable called >>>>>>>>>>>>>>>>");
    return true;
  }

  public boolean isLightweight() {
    log("<<<<<<<<<<<<< isLightweight called >>>>>>>>>>>>>>>>");
    return false;
  }

  public boolean isShowing() {
    log("<<<<<<<<<<<<< isShowing called >>>>>>>>>>>>>>>>");
    return true;
  }

  public boolean isValid() {
    log("<<<<<<<<<<<<< isValid called >>>>>>>>>>>>>>>>");
    return true;
  }

  public void paint(Graphics g) {
    log("<<<<<<<<<<<<< paint called >>>>>>>>>>>>>>>>");
  }

  protected void processComponentEvent(ComponentEvent e) {
    log("<<<<<<<<<<<<< processComponentEvent called [" + e + "] >>>>>>>>>>>>>>>>");
  }

  protected void processFocusEvent(FocusEvent e) {
    log("<<<<<<<<<<<<< processFocusEvent called >>>>>>>>>>>>>>>>");
  }

  public void repaint() {
    log("<<<<<<<<<<<<< repaint-1 called >>>>>>>>>>>>>>>>");
  }

  public void repaint(long tm){
    log("<<<<<<<<<<<<< repaint-2 called >>>>>>>>>>>>>>>>");
  }

  public void repaint(int x,
                    int y,
                    int width,
                    int height) {
    log("<<<<<<<<<<<<< repaint-3 called >>>>>>>>>>>>>>>>");
  }

  public void repaint(long tm,
                    int x,
                    int y,
                    int width,
                    int height) {
    log("<<<<<<<<<<<<< repaint-4 called >>>>>>>>>>>>>>>>");
  }

  public void requestFocus() {
    log("<<<<<<<<<<<<< requestFocus called >>>>>>>>>>>>>>>>");
  }

  public void update(Graphics g) {
    log("<<<<<<<<<<<<< update called >>>>>>>>>>>>>>>>");
  }*/

  public void addNotify() {
    log("<<<<<<<<<<<<< addNotify called >>>>>>>>>>>>>>>>");
    super.addNotify();

    m_parent = getParent();
    m_mainFrame = getMainFrame(this);

    if(m_sdWrapper != null)
    {
	Rectangle rect = m_parent.getBounds();
	Point pt = m_parent.getLocationOnScreen();
	LogManager.log("SDNativeRenderer", "pt - " + pt + "rect - " + rect);
	m_sdWrapper.SetPosition(pt.x, pt.y, rect.width, rect.height, true);
    }
    else
    {
	LogManager.log("SDNativeRenderer", "Failed to set SD Position");
    }

    String strMainFrameTitle = m_mainFrame.getTitle();
    if(!m_sdWrapper.setParent(strMainFrameTitle)) {
      log("********** cannot set parent in native ***********");
    } else {
      log("********** parent set in native successfully ***********");
    }
    log("************ Main Frame Caption [" + strMainFrameTitle + "] ***************");

    m_compListener1 = new ComponentAdapter() {
      public void componentHidden(ComponentEvent e) {
        //log("************* [componentHidden][1] ****************");
        //setVisible(false);
      }

      public void componentMoved(ComponentEvent e) {
        //log("************* [componentMoved][1] ****************");
        setLocation(m_parent.getLocationOnScreen());
      }

      public void componentResized(ComponentEvent e) {
        //log("************* [componentResized][1] ****************");
        //setDimension(m_parent.getDimension());
      }

      public void componentShown(ComponentEvent e) {
        //log("************* [componentShown][1] ****************");
        setVisible(true);
      }
    };
    m_mainFrame.addComponentListener(m_compListener1);

    m_compListener2 = new ComponentAdapter() {
      public void componentHidden(ComponentEvent e) {
        //log("************* [componentHidden][2] ****************");
        //setVisible(false);
      }

      public void componentMoved(ComponentEvent e) {
        //log("************* [componentMoved][2] ****************");
        setLocation(m_parent.getLocationOnScreen());
      }

      public void componentResized(ComponentEvent e) {
        //log("************* [componentResized][2] ****************");
        //setDimension(m_parent.getDimension());
      }

      public void componentShown(ComponentEvent e) {
        log("************* [componentShown][2] ****************");
        //setVisible(true);
      }
    };

    addListenersToParents(m_compListener2);
    //m_parent.addComponentListener(m_compListener2);

log("<<<<<<<<<<<< added listener to the parents >>>>>>>>>>>>>");
    m_wndListener = new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        //log("************* windowClosing ****************");
        //m_sdWrapper.release();
      }

      public void windowClosed(WindowEvent e) {
        log("************* windowClosed ****************");
      }

      public void windowOpened(WindowEvent e) {
        log("************* windowOpened ****************");
      }

      public void windowIconified(WindowEvent e) {
        log("************* windowIconified ****************");
        setVisible(false);
      }

      public void windowDeiconified(WindowEvent e) {
        log("************* windowDeiconified ****************");
        setVisible(true);
      }

      public void windowActivated(WindowEvent e) {
        //log("************* windowActivated ****************");
        setVisible(true);
      }

      public void windowDeactivated(WindowEvent e) {
        //log("************* windowDeactivated ****************");
      }
    };

    m_mainFrame.addWindowListener(m_wndListener);
  }

  public void removeNotify() {
    log("<<<<<<<<<<<<< removeNotify called >>>>>>>>>>>>>>>>");
    super.removeNotify();

    m_mainFrame.removeComponentListener(m_compListener1);
    m_parent.removeComponentListener(m_compListener2);
    m_mainFrame.removeWindowListener(m_wndListener);
  }

  void refresh() {
    /*if(m_parent != null)
      setLocation(m_parent.getLocationOnScreen());*/
  }

  void addListenersToParents(ComponentListener compListener) {
    Component temp = this;
    Component root = null;

    while(true) {
      root = temp;
      temp = root.getParent();
      if(temp != null)
        temp.addComponentListener(compListener);
      else break;
    }
  }

  static JFrame getMainFrame(Component child) {
    Component temp = child;
    Component root = null;

    while(temp != null) {
      root = temp;
      temp = root.getParent();
    }
    return (JFrame) root;
  }

  private boolean getMyViewInfo() throws Exception {
    Context ctx = ContextManager.getInitialContext();
    SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");

    m_sharedletInfo = sharedletManager.getInfo(SDSharedletInfo.g_sharedletMIME);

    if(m_sharedletInfo == null) {
      throw new Exception("### getMyViewInfo: cannot get sharedlet info for [" +
                  SDSharedletInfo.g_sharedletMIME + "]");
    }
    m_viewManager = sharedletManager.getViewManager();

    return m_viewManager != null;
  }

  SharedletView getMyView(String viewName) throws Exception {
    if((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo())
    {
      log("==========>> 1 : " + m_sharedletInfo + ", " + m_viewManager + "<<======");
      return null;
      }

    Vector views = m_sharedletInfo.getViewInfos();
    if(views == null) {
      throw new Exception("### getMyView: cannot get views for [" + SDSharedletInfo.g_sharedletMIME + "]");
    }

    SharedletViewInfo viewInfo = null;
    Enumeration enum = views.elements();
    while (enum.hasMoreElements()) {
      SharedletViewInfo item = (SharedletViewInfo) enum.nextElement();
      if(item.getID().equals(viewName)) {
        viewInfo = item;
        break;
      }
    }

    if(viewInfo == null) {
      throw new Exception("### getMyView: cannot get view named [" + viewName + "]");
    }
    return m_viewManager.getView(viewInfo);
  }

  private void err(String ErrMsg, Exception ex) {
    LogManager.err("SDSharedlet::SDNativeRenderer",ErrMsg,ex);
  }

  private void log(String msg) {
    LogManager.log("SDSharedlet::SDNativeRenderer",msg);
  }
}