package com.anabas.pdasharedlet;

/**
 * Title:        IMNet.java
 * Description:  IM module class.
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       KangSeok Kim kskim@csit.fsu.edu
 *               Sangyoon Oh  soh@csit.fsu.edu
 * @version 2.0
 */

import java.io.*;
import java.net.*;
import java.util.*;

public class IMNet implements Config, IJabberClient, IAnabasClient
{

 public static JabberComm moJabberComm = null;
 public static AnabasComm anabasComm = null;
 public static TestConnect testConnect = null;
 private String eventString = "";
 private static int love = 0;
 private static int like = 0;
 private static int i = 0;

 // get Hashtable from PAdaptor
 protected Hashtable message = new Hashtable();
 protected static PAdaptor parent;

 public void getMessage(Hashtable hash) {
    this.message = hash;
    String mid = (String)hash.get("mid");
    String aid = (String)hash.get("aid");
    String tid = (String)hash.get("tid");
    String eid = (String)hash.get("eid");
    String edata = (String)hash.get("edata");
    read(eid, edata);
 }

/**************************************************************************
 *                  IMNet(Socket socket, IMModule root)
 **************************************************************************/
 public IMNet(PAdaptor pa)
 {
  parent = pa;
  moJabberComm = new JabberComm(this);
  anabasComm = new AnabasComm(this);

  //-----------------------------------------------------------------------
  //      Initialize periodic jabber server connection testing
  //-----------------------------------------------------------------------
  if (testConnect == null)
  {
   testConnect = new TestConnect(this);
  }
 }

/**************************************************************************
 *                   read(String evtNum, String evtData)
 **************************************************************************/
 static void read(String evtNum, String evtData)
 {
  boolean bool = false;

  if (evtNum.equals("01"))
  {
   //System.out.println("Adapter got #1 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.connect(st.nextToken(), st.nextToken(),
                                Integer.parseInt(st.nextToken()));
   }
   //System.out.println("Return value : " + love);
   send(Integer.toString(love));

   return;
  }
  if (evtNum.equals("99"))
  {
   //System.out.println("Adapter got #99 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.connect(st.nextToken(), st.nextToken(),
                                Integer.parseInt(st.nextToken()));
   }
   //System.out.println("Return value : " + love);
   send(Integer.toString(love));

   return;
  }
  if (evtNum.equals("02"))
  {
   //System.out.println("Adapter got #2 evtNum.......");

   love = moJabberComm.disconnect();

   return;
  }
  if (evtNum.equals("03"))
  {
   //System.out.println("Adapter got #3 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.logon(st.nextToken(),st.nextToken(), st.nextToken());
   }

   //System.out.println("Return value : " + love);
   send(Integer.toString(love));

   return;
  }
  if (evtNum.equals("04"))
  {
   //System.out.println("Adapter got #4 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.createNewAccount(st.nextToken(), st.nextToken(),
                                         st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("05"))
  {
   //System.out.println("Adapter got #5 evtNum.......");

   testConnect.testing(false);

   love = moJabberComm.logoff();

   return;
  }
  if (evtNum.equals("85"))
  {
   //System.out.println("Adapter got #85 evtNum.......");

   anabasComm.disconnect();

   return;
  }
  if (evtNum.equals("55"))
  {
   //System.out.println("Adapter got #55 evtNum.......");

   // done with initialization, start periodic connection testing.
   testConnect.testing(true);
   if (testConnect.getStarted() == false)
     testConnect.start();

   return;
  }
  if (evtNum.equals("06"))
  {
   //System.out.println("Adapter got #6 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    if (st.nextToken().equals("true")) bool = true;
    else bool = false;
    love = moJabberComm.setAvailable(bool);
   }

   return;
  }
  if (evtNum.equals("07"))
  {
   //System.out.println("Adapter got #7 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);
   String str4 = st.nextToken(); //System.out.println("str4 : " + str4);
   String str5 = st.nextToken(); //System.out.println("str5 : " + str5);
   String str6 = st.nextToken(); //System.out.println("str6 : " + str6);

   if (str1.equals(" ")) str1 ="";
   if (str2.equals(" ")) str2 ="";
   if (str3.equals(" ")) str3 ="";
   if (str4.equals(" ")) str4 ="";
   if (str5.equals(" ")) str5 ="";
   if (str6.equals(" ")) str6 ="";

   like = moJabberComm.sendPresence(str1, str2, str3, str4, str5, str6);

   //System.out.println("Return value : " + like);

   return;
  }
  if (evtNum.equals("08"))
  {
   //System.out.println("Adapter got #8 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    like = moJabberComm.sendRosterRequest(st.nextToken());
   }
   //System.out.println("Return value : " + like);

   return;
  }
  if (evtNum.equals("09"))
  {
   //System.out.println("Adapter got #9 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);

   if (str1.equals(" ")) str1 ="";
   if (str2.equals(" ")) str2 ="";
   if (str3.equals(" ")) str3 ="";

   love = moJabberComm.sendRosterSet(str1, str2, str3);
   /*
   while (st.hasMoreTokens()) {
        love = moJabberComm.sendRosterSet(st.nextToken(), st.nextToken(),
                                          st.nextToken());
   }
   */
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("10"))
  {
   //System.out.println("Adapter got #10 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.sendUnsubscribe(st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("11"))
  {
   //System.out.println("Adapter got #11 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);
   String str4 = st.nextToken(); //System.out.println("str4 : " + str4);
   String str5 = st.nextToken(); //System.out.println("str5 : " + str5);

   if (str1.equals(" ")) str1 ="";
   if (str2.equals(" ")) str2 ="";
   if (str3.equals(" ")) str3 ="";
   if (str4.equals(" ")) str4 ="";
   if (str5.equals(" ")) str5 ="";

   love = moJabberComm.sendMsg(str1, str2, str3, str4, str5);

   //System.out.println("Return value : " + love);

   return;
  }
 if (evtNum.equals("61"))
  {
   //System.out.println("Adapter got #61 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken();
   String str2 = st.nextToken();
   String str3 = st.nextToken();
   String str4 = st.nextToken();
   /*
   if (str1.equals(" ")) str1 ="";
   if (str2.equals(" ")) str2 ="";
   if (str3.equals(" ")) str3 ="";
   if (str3.equals(" ")) str3 ="";
   */
   anabasComm.sendMsg(str1, str2, str3, str4);

   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("12"))
  {
   //System.out.println("Adapter got #12 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.sendAgentsRequest(st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);
   send(Integer.toString(love));

   return;
  }
  if (evtNum.equals("13"))
  {
   //System.out.println("Adapter got #13 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatJoin(st.nextToken(), st.nextToken(),
                                      st.nextToken());
   }

   return;
  }
  if (evtNum.equals("81"))
  {
   //System.out.println("Adapter got #81 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    anabasComm.connect(st.nextToken(), st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);
   //send(Integer.toString(love));

   return;
  }
  if (evtNum.equals("83"))
  {
   //System.out.println("Adapter got #83 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");
   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);
   String str4 = st.nextToken(); //System.out.println("str4 : " + str4);

   anabasComm.anabasChatJoin(str1, str2, str3, str4);

   return;
  }
  if (evtNum.equals("14"))
  {
   //System.out.println("Adapter got #14 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);
   String str4 = st.nextToken(); //System.out.println("str4 : " + str4);
   String str5 = st.nextToken(); //System.out.println("str5 : " + str5);

   if (str5.equals(" ")) str5 ="";

   if (st.nextToken().equals("true"))
   {
    bool = true;
    //System.out.println("str6 : " + "true");
   }
   else
   {
    bool = false;
    //System.out.println("str6 : " + "false");
   }
   love = moJabberComm.groupChatNick(str1, str2, str3, str4, str5, bool);

   return;
  }
  if (evtNum.equals("15"))
  {
   //System.out.println("Adapter got #15 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);

   if (str3.equals(" ")) str3 ="";

   love = moJabberComm.groupChatEnter(str1, str2, str3);
   //System.out.println("Return value : " + love);
   /*
   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatEnter(st.nextToken(), st.nextToken(),
                                       st.nextToken());
   }
   */

   return;
  }
  if (evtNum.equals("16"))
  {
   //System.out.println("Adapter got #16 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);

   if (str3.equals(" ")) str3 ="";

   love = moJabberComm.groupChatLeave(str1, str2, str3);
   /*
   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatLeave(st.nextToken(), st.nextToken(),
                                       st.nextToken());
   }
   */
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("17"))
  {
   //System.out.println("Adapter got #17 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatSubscribe(st.nextToken(), st.nextToken(),
                                           st.nextToken());
   }

   return;
  }
  if (evtNum.equals("18"))
  {
   //System.out.println("Adapter got #18 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatInvite(st.nextToken(), st.nextToken(),
                                        st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("19"))
  {
   //System.out.println("Adapter got #19 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatMsg(st.nextToken(), st.nextToken(),
                                     st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("20"))
  {
   //System.out.println("Adapter got #20 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.groupChatMsgPrivate(st.nextToken(), st.nextToken(),
                           st.nextToken(), st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("21"))
  {
   //System.out.println("Adapter got #21 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.sendRosterSet(st.nextToken(), st.nextToken(),
                                      st.nextToken(), st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("22"))
  {
   //System.out.println("Adapter got #22 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   while (st.hasMoreTokens())
   {
    love = moJabberComm.sendRawXML(st.nextToken());
   }
   //System.out.println("Return value : " + love);

   return;
  }
 if (evtNum.equals("51"))
  {
   //System.out.println("Adapter got #51 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);
   String str3 = st.nextToken(); //System.out.println("str3 : " + str3);
   String str4 = st.nextToken(); //System.out.println("str4 : " + str4);

   if (str1.equals(" ")) str1 ="";
   if (str2.equals(" ")) str2 ="";
   if (str3.equals(" ")) str3 ="";
   if (str4.equals(" ")) str4 ="";

   love = moJabberComm.conferenceBrowse(str1, str2, str3, str4);

   //System.out.println("Return value : " + love);

   return;
  }
  if (evtNum.equals("52"))
  {
   //System.out.println("Adapter got #52 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);

   love = moJabberComm.groupChatEnter2(str1, str2);

   return;
  }
  if (evtNum.equals("53"))
  {
   //System.out.println("Adapter got #53 evtNum.......");

   StringTokenizer st = new StringTokenizer(evtData, "\0");

   String str1 = st.nextToken(); //System.out.println("str1 : " + str1);
   String str2 = st.nextToken(); //System.out.println("str2 : " + str2);

   //love = moJabberComm.groupChatBrowse(str1, str2);

   return;
  }

  love = 0;  // for #1, #3, #12, #99

  //System.out.println("Unknown IM service request: " + evtNum);
 }

/**************************************************************************
 *                           send(Hashtable event)
 **************************************************************************/
 static synchronized void send(String event)
 {
  try {

    parent.setHHMP2(event);
  }
   catch (Exception e) {
        System.out.println(e);
  }
 }

/**************************************************************************
 *                    Required AnabasClient methods
 **************************************************************************/
 public void anabasMsgReceived(String sName, String sBody)
 {
  if (sName == "")  sName = " ";
  if (sBody == "")  sBody = " ";

  eventString = "0" + "0" + "0" + "11"
              + sName + "\0" + sBody;
  send(eventString);
  eventString = "";
 }

/**************************************************************************
 *                    Required iJabberClient methods
 **************************************************************************/
 public void infoQueryReceived(String sTo, String sFrom, String sID,
                               String sType, String sQuery, String sError,
                               String sCode)
 {
  /*
  if (i > 1)
  {
   if (like == 0) System.out.println("like : problem error");
   else System.out.println("like : O.K");
  }
  */

  i++;

  if (sTo == "")    sTo = " ";
  if (sFrom == "")  sFrom = " ";
  if (sID == "")    sID = " ";
  if (sType == "")  sType = " ";
  if (sQuery == "") sQuery = " ";
  if (sError == "") sError = " ";
  if (sCode == "")  sCode = " ";

  eventString = "0" + "0" + "0" + "01"
              + sTo + "\0" + sFrom + "\0" + sID + "\0" + sType + "\0"
              + sQuery + "\0" + sError + "\0" + sCode;
  send(eventString);
  eventString = "";
 }

 public void unsupportedTag(String sTagName, String sXMLDoc)
 {
  if (sTagName == "") sTagName = " ";
  if (sXMLDoc == "")  sXMLDoc = " ";

  eventString = "0" + "0" + "0" + "02"
              + sTagName + "\0" + sXMLDoc;
  send(eventString);
  eventString = "";

  //System.out.println("unsupported tag: " + sTagName);
 }

 public void msgReceived(String sFrom, String sType, String sSubject,
                         String sBody, String sThread)
 {
  if (sFrom == "")    sFrom = " ";
  if (sType == "")    sType = " ";
  if (sSubject == "") sSubject = " ";
  if (sBody == "")    sBody = " ";
  if (sThread == "")  sThread = " ";

  eventString = "0" + "0" + "0" + "03"
              + sFrom + "\0" + sType + "\0"
              + sSubject + "\0" + sBody + "\0" + sThread;
  send(eventString);
  eventString = "";
 }

 public void presenceReceived(String sTo, String sFrom, String sType,
                              String sStatus, String sPriority, String sShow,
                              String sError, String sCode)
 {
  if (sTo == "")       sTo = " ";
  if (sFrom == "")     sFrom = " ";
  if (sType == "")     sType = " ";
  if (sStatus == "")   sStatus = " ";
  if (sPriority == "") sPriority = " ";
  if (sShow == "")     sShow = " ";
  if (sError == "")    sError = " ";
  if (sCode == "")     sCode = " ";

  eventString = "0" + "0" + "0" + "04"
              + sTo + "\0" + sFrom + "\0" + sType + "\0" + sStatus + "\0"
              + sPriority + "\0" + sShow + "\0" + sError + "\0" + sCode;
  send(eventString);
  eventString = "";
 }

/**************************************************************************
 *                             TestConnect()
 **************************************************************************/
 public void connectionClosed()
 {
  if (testConnect.testing() == true)
    connectionTest();
 }

 public void connectionTest()
 {
  if (moJabberComm.sendRawXML(" ") != Constants.SEND_SUCCEEDED)
  {
   testConnect.testing(false);
   eventString = "0" + "0" + "0" + "05";
   send(eventString);
   eventString = "";
  }
 }

 public void rawXML(String sXML) {}

 public void error(String sXML)
 {
  if (sXML == "") sXML = " ";

  eventString = "0" + "0" + "0" + "06" + sXML;
  send(eventString);
  eventString = "";
  //System.out.println("XML error: " + sXML);
 }
}

/****************************************************************************
 *                                 The End
 ****************************************************************************/





