package com.anabas.pdasharedlet;

import com.sun.image.codec.jpeg.*;
import com.anabas.sdsharedlet.*;

import java.awt.*;
import java.io.*;
import java.awt.image.*;


//  SD.java
//    auther : Sangmi Lee (slee@csit.fsu.edu)
//    purpose : control SD module in adapter side
//    last update : April,29,2001

public class SD{

     private FileOutputStream outputfileM = null;
     private DataInputStream inputM = null;
     private FileInputStream inputfileS = null;
     private DataInputStream inputS = null;
     private DataOutputStream outputS = null;

     //Event message definitions
     private int EventMessage = 0;  // Sending message to Slave
     private int OpenEventBus = 1;  // First hand shaking with Slave
     private int UpdateImage = 2;   // Send new image to slave
     private int EndofImage = 3;    // Mark of End of image
     private int NoEvent = 0;       // There is no event

     private int MessageLength = 64;
     private int DataLength = 59;
     private int TagLength = 5;
     private int M = 1; // assign 1 for master
     private int S = 2; // assign 2 for slave
     private int N = 0; // assign 0 for no use
     private int File1 = 1;
     private int File2 = 2;

     // key for hash table
     private byte mid = (byte)2;           // machine id
     private byte aid = (byte)2;           // application id
     private byte tid = (byte)0;          // topic id
     private byte[] eid = new byte[2];
     private byte eid1 =(byte)NoEvent;     // event
     private byte eid2 =(byte)NoEvent;
     private byte[] edata = new byte[MessageLength];


     //useful value definitions
     private int OK = 1;
     private int NG = 0;

     private String filename1 = "sdtmp01.jpg";
     private String filename2 = "sdtmp02.jpg";

     private FileSharingControl fsdc;
     SDRenderingEngine sdRE;

     protected PAdaptor parent;
     protected byte[] message = new byte[64];
     protected boolean isChanged = false;

     public void getMessage (byte[] b) {
          message = b;
          isChanged = true;
     }

     public SD(PAdaptor _parent) {

	    System.out.println("SD_PDA Adaptor is running");
          parent = _parent;
          fsdc = new FileSharingControl();
          sdRE = new SDRenderingEngine(240,300);
          fsdc.FreeFile(File1);
          fsdc.FreeFile(File2);
          //fsdc.FileSharingStatus();
     }


     public void SendData(int i) {

                     if ( i == File2 ) {
                        try {
                             fsdc.LockFile(File2,S);
                             //fsdc.FileSharingStatus();
                             inputfileS = new FileInputStream(filename2);
                             try {
                                 SendMessage(OpenEventBus);
                                 SendMessage(UpdateImage);
                                 SendMessage(EndofImage);
                                 inputfileS.close();
                                 System.out.println("Finish sending image file2");
                                 fsdc.FreeFile(File2);
                                 
                              }
                              catch(IOException e){};
                        }
                        catch(IOException e){};
                     }
                     else if ( i == File1) {
                             try {
                                  System.out.println("start second thread");
                                  fsdc.LockFile(File1,S);
                                  //fsdc.FileSharingStatus();
                                  inputfileS = new FileInputStream(filename1);
                                  try {
                                       SendMessage(OpenEventBus);
                                       SendMessage(UpdateImage);
                                       SendMessage(EndofImage);
                                       inputfileS.close();
                                       System.out.println("Finish sending image file1");
                                       fsdc.FreeFile(File1);
                                       //fsdc.FileSharingStatus();
                                   }
                                   catch(IOException e){};
                              }

                              catch(IOException e){};
                     }





  }





   public int SendMessage(int i) {
          byte[] messagebyte = new byte[MessageLength];
          byte[] databyte = new byte[DataLength];
          // when PC sends a new image to PDA with event "update image"
          try {
                     if ( i == UpdateImage) {

                        int j = 0;
                        while(( j=inputfileS.read(databyte))!=-1) {
                                messagebyte = new byte[MessageLength];
                                messagebyte[0] = mid;
                                messagebyte[1] = aid;
                                messagebyte[2] = tid;
                                messagebyte[3] = eid1;
                                messagebyte[4] = (byte)i;
                                for (int m = 0 ; m < DataLength ; m++)
                                    messagebyte[m + TagLength] = databyte[m];
                                parent.setHHMP1(messagebyte);
                        }
                     }
            // when PC sends only event messages (i.e. "open event bus", "end of image")
                     else {
                        messagebyte = new byte[MessageLength];
                        messagebyte[0] = mid;
                        messagebyte[1] = aid;
                        messagebyte[2] = tid;
                        messagebyte[3] = eid1;
                        messagebyte[4] = (byte) i;
                        parent.setHHMP1(messagebyte);


                     }
            }
            catch(IOException e){};
                     return(1);
    }

    public int ReceiveMessage(){
                try{
                    byte[] revent = new byte[1024];
                    inputS.read(revent);
                    int i = (int)revent[4];
                    return(i);
                }
                catch (IOException e){
                    System.out.println(e);}
                    return(0);
    }

    public void getGMSMessage(SDBitmap m){

         System.out.println("Start getmessage in SVG " + m);
         
            if ( (fsdc.NewFileStatus() == File1)||(fsdc.NewFileStatus() == 0) ) {
               fsdc.LockFile(File2,M);
               sdRE.GetUpdateImage(m,filename2);
               fsdc.FreeFile(File2);
               //fsdc.FileSharingStatus();
               fsdc.MarkNewFile(File2);
               this.SendData(File2);

          }
          else if (fsdc.NewFileStatus() == File2) {
                   fsdc.LockFile(File1,M);
                   sdRE.GetUpdateImage(m,filename1);
                   fsdc.FreeFile(File1);
                   //fsdc.FileSharingStatus();
                   
                   fsdc.MarkNewFile(File1);
                   System.out.println("check else");
                   this.SendData(File1);
           }
         

    }





}



