package com.anabas.pdasharedlet;
/**
 * Title:        TCPServer.java
 * Description:  TCP/IP Server class
 *               support TCP/IP connection to PDA and communicate HHms
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */

import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

public class TCPServer extends Thread {

  /**
   *  constructor:  open one socket and assign one SocketHandler
   *                to each PDA client. registry is updated whenever
   *                new SocketHandler is created.
   */
  public TCPServer(PAdaptor _parent) {
    parent = _parent;

    try {
      File f = new File("c:\\anabas\\lib\\pda.cfg");
      if (!f.exists()) portNum = 7000;
      else {
        FileInputStream fin = new FileInputStream(f);
        BufferedReader configInput = new BufferedReader(new InputStreamReader(fin));
        String str = configInput.readLine();
        Integer int1 = new Integer(str);
        portNum = int1.intValue();
      }
    }
    catch(Exception e){
      e.printStackTrace();
    };
  }

  public void run() {
    try {

      server = new ServerSocket(portNum);
      System.out.println("[PDA-ADAPTOR] Server Socket open :" + portNum);

      int i = 0;
      while(true) {
        Socket connection = server.accept();

        // create SocketHandler
        // @param this/TCPServer and Socket
        SocketHandler s = new SocketHandler(this, connection);

        /**
        // put SocketHandler with machineID jey
        String machineID = i + "machine";
        s.MACHINEID = machineID;
        registry.put(machineID, s);

        // update registry at PAdaptor
        parent.upDate(registry);
        **/

        s.start();
        i++;
      }
    }
    catch(IOException e) {
      // e.printStackTrace();
    }
  }

  File fileName;
  private int portNum = 7000;
  // public Hashtable registry = new Hashtable();
  public ServerSocket server;
  public PAdaptor parent;
}