package com.anabas.pdasharedlet;

import com.sun.image.codec.jpeg.*;
import com.anabas.sdsharedlet.*;

import java.awt.*;
import java.io.*;
import java.awt.image.*;


//  SDRenderingEngine.java
//    auther : Sangmi Lee (slee@csit.fsu.edu)
//    purpose : control resolution for PDA
//              
//    last update : April,29,2001




 


class SDRenderingEngine extends Frame {
    private Image img = null;
    private int width = 0;
    private int height = 0;
    private Image resizedimg = null;
    private int resizedwidth = 300;
    private int resizedheight = 300;
    private int check = 0;
    private int[] pixels = null;
    protected PAdaptor parent;  
    public SDRenderingEngine (int int1, int int2) {
        resizedwidth = int1;
        resizedheight = int2;
    }
    
    public void update() {
  
    }
  
    public void paint(Graphics g) {
                   
    }

    public void GetUpdateImage(SDBitmap msg,String str1){
         ColorModel cm = ColorModel.getRGBdefault(); 
         MemoryImageSource source = new MemoryImageSource(msg.width, msg.height, 
                                                   cm, msg.data, 0, msg.width);          
  
         int[] pixels = new int[msg.width*msg.height];
         int[] fpixels = new int[msg.width*msg.height];       
         for(int i=0;i < msg.data.length/3;i++) {
             pixels[(msg.data.length/3)-(i+1)] = ((((int)msg.data[i*3])<<16)&0x00FF0000)+
		      	          ((((int)msg.data[i*3+1])<<8)&0x0000FF00)+
		             	           (int)msg.data[i*3+2];
			
         }
         for (int j = 0; j <msg.height; j++) {
              for (int k = 0; k< msg.width; k++) { 
                   fpixels[j*msg.width+k] = pixels[j*msg.width+(msg.width-k-1)];
              }
         }

         MemoryImageSource source2 = 
                new MemoryImageSource(msg.width,msg.height,cm,fpixels,0,msg.width);
         img = createImage(source2);
         width = msg.width;
         height = msg.height;
         //SaveAsINT(pixels,msg.data.length/3,"\\sdtmpINT"+msg.width+"_"+msg.height+".txt");     
         //SaveAsRAW(msg.data,msg.data.length,"\\sdtmpRAW"+msg.width+"_"+msg.height+".txt");
         //System.out.println("SaveAsRaw1111");    
         RotateImage();
         ScaleImage();
         SaveAsJPEG(img,str1);
         img = getToolkit().getImage("SDtmpout2.jpg");
        

    }


      public void ScaleImage(){
         
         MediaTracker media = new MediaTracker(this);
         media.addImage(img,0);
         try {
             media.waitForID(0);
             ImageFilter replicate = 
                   new ReplicateScaleFilter(resizedwidth, resizedheight);
             ImageProducer prod = 
                               new FilteredImageSource(img.getSource(),replicate);
             img = createImage(prod);
             
             
             media.addImage(img,1);
             media.waitForID(1);
        }
        catch(InterruptedException e) {}      
      }

 
      public void RotateImage(){
         int[] rotate = new int[width * height];
         int[] pixels = new int[width * height];

         MediaTracker media = new MediaTracker(this);
         media.addImage(img,0);
         try {
             media.waitForID(0);
             PixelGrabber pg = new PixelGrabber(img, 0, 0, width,  
                                      height, pixels, 0, width);
             
             try{
                 pg.grabPixels();
             }
             catch(InterruptedException e) {
                 e.printStackTrace();
             }

               for (int y = 0; y < height ; y++) {
                 for (int x = 0; x <  width ; x++) {
                      rotate[((width-x-1)*height)+y] = 
                                 pixels[x+(y*width)];
                      
                 }
             }

             img = createImage(new MemoryImageSource(height, 
                                    width,rotate,0,height));

          }
          catch(Exception e) { e.printStackTrace(); }

      }

      public void SaveAsRAW(byte[] pixels, int int1, String str1) {
           try {
              File f = new File(str1);
              FileOutputStream fos = new FileOutputStream(f);
              for(int iii = 0; iii < int1; iii ++) fos.write(pixels[iii]);
              
              fos.close();
          }
          catch(IOException e){};
       }
      public void SaveAsINT(int[] pixels, int int1, String str1) {
           try {
              
              File f = new File(str1);
              
              FileOutputStream fos = new FileOutputStream(f);
              for(int iii = 0; iii < int1; iii ++) {
               
               fos.write(pixels[iii]);
               
              }
              fos.close();
          }
          catch(IOException e){};
       }


 
      public void SaveAsJPEG(Image img1, String str1) {
  
          BufferedImage bimg = null;
          int [] pixels = new int[resizedwidth * resizedheight];
          PixelGrabber pg = new PixelGrabber(img1, 0, 0, resizedwidth, resizedheight, 
                                             pixels, 0, resizedwidth);
          try {
               pg.grabPixels();
          }
          catch(InterruptedException ie) {
               ie.printStackTrace();
          }
          bimg = new BufferedImage(resizedwidth,resizedheight,BufferedImage.TYPE_INT_RGB);
          bimg.setRGB(0,0,resizedwidth,resizedheight,pixels,0,resizedwidth);
          try {
              File f = new File(str1);
              FileOutputStream fos = new FileOutputStream(f);
              JPEGImageEncoder jpeg = JPEGCodec.createJPEGEncoder(fos);
              jpeg.encode(bimg);
              fos.close();
          }
          catch(IOException e){};
       }


}
