package com.anabas.commsharedlet;

import audiotalk.hearmevoicelib.*;
//import com.gensym.com.*;

import com.anabas.sharedlet.*;
import com.anabas.util.misc.LogManager;

import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.util.misc.LogManager;

public class AudioControl{

//hack, we can not release the hear me control, so detect if there is one already in memory
  public static HearMeVoiceOCX m_client;
  public static HearMeVoiceListener m_myListener;
//? if it doesn't work, return to the old one
//  public HearMeVoiceOCX m_client;
  private _DAXAudioTalkEventsListener m_dl;
  private boolean m_isKilled = false;

  public AudioControl(){
    if(m_client == null){
      m_client = new audiotalk.hearmevoicelib.HearMeVoiceOCX();
      byte b = 1;
      m_client.initializeProxy();
      m_client.setAxRunSilent(b);
    }
    m_client.setAxMicVolume(15);

//    callMeeting();

  }

  public HearMeVoiceOCX getClient(){
    if(!m_isKilled) return m_client;
    else return null;
  }

  public void add_DAXAudioTalkEventsListener(_DAXAudioTalkEventsListener dl){
    if(m_myListener == null){
      m_myListener = new HearMeVoiceListener();
      m_client.add_DAXAudioTalkEventsListener(m_myListener);
    }
    m_dl = dl;
    m_myListener.addListener(dl);
//    m_client.add_DAXAudioTalkEventsListener(dl);
  }

  public void addVoiceListener(){

  }

  public void stopTalking() {//GEN-FIRST:event_broadcastMouseReleased
    byte b = 0;
    if(m_client != null)m_client.setAxHandsFree(b);
  }//GEN-LAST:event_broadcastMouseReleased

  public void startTalking() {//GEN-FIRST:event_broadcastMousePressed
    // not connected, so placecall again
    if(!m_isKilled){
      if(m_client.getAxConnectionStatus() != 3) callMeeting();
      byte b = 1;
      m_client.setAxHandsFree(b);
    }
  }

  public void speakerStateChanged(int value) {//GEN-FIRST:event_speakerLeverStateChanged
    if(!m_isKilled){
      m_client.setAxSpeakerVolume(value);
    }
  }//GEN-LAST:event_speakerLeverStateChanged

  public void microphoneStateChanged(int value) {//GEN-FIRST:event_micLeverStateChanged
    if(!m_isKilled){
      m_client.setAxMicVolume(value);
    }
  }//GEN-LAST:event_micLeverStateChang

  public void callMeeting(){
    if(!m_isKilled){
      Context ctx = ContextManager.getInitialContext();
      try{
        String sipAddress = (String)ctx.lookup("session_param/audio.sipurl");
        if(sipAddress.length() > 0){  //during paly back there is no audio, so the sipaddress is empty
          m_client.getAxConnectionStatus();
          m_client.PlaceCall(sipAddress);
        }
      } catch (Exception e) {
         LogManager.err("Communication","Unable to get audio sipurl inside audiotalk",e);
      }
    }
  }

  public int getAxConnectionStatus(){
     if(!m_isKilled) return m_client.getAxConnectionStatus();
     else return -1;
  }

  public int getAxSpeakerEnergy(){
     if(!m_isKilled) return m_client.getAxSpeakerEnergy();
     else return 0;
  }

  public int getAxMicEnergy(){
     if(!m_isKilled)return m_client.getAxMicEnergy();
     else return 0;
  }

  public int getAxMicVolume(){
     if(!m_isKilled)return m_client.getAxMicVolume();
     else return 0;
  }

  public int getAxSpeakerVolume(){
    return m_client.getAxSpeakerVolume();
  }

  public void setAxMicVolume(int value){
     if(!m_isKilled)m_client.setAxMicVolume(value);
  }

  public void setAxSpeakerVolume(int value){
     if(!m_isKilled)m_client.setAxSpeakerVolume(value);
  }

  public void setAxUserInfo(String info){
     if(!m_isKilled)m_client.setAxUserInfo(info);
  }

  public String getUserInfo(){
     if(!m_isKilled) return m_client.getAxUserInfo();
     else return "";
  }

  public void setSpeakerMute(byte mute){
     if(!m_isKilled)m_client.setAxMicMute(mute);
  }

  public String getParticipants(){
     if(!m_isKilled)return m_client.GetParticipants();
     else return null;
  }

  public void deactivate(){
    m_isKilled = true;
    m_myListener.removeListener(m_dl);
    stopTalking();
    m_client.HangUpCall();
//?
//    m_client.remove_DAXAudioTalkEventsListener(m_dl);
//    try{
//      m_client.delete();
//    }catch(com.gensym.com.ActiveXException ae){
//      LogManager.err(LogManager.PRODUCTION,"Communication", "HearMeVoiceOcx delete err.", ae);
//    }
//    int count = 0;
//    while(m_client.isAlive() && count < 10){
//      count++;
//      try{ Thread.sleep(300);
//      }catch(InterruptedException ie){};
//      LogManager.log(LogManager.PRODUCTION,"Communication", "try to delete hearMeVoiceOCX object, count = "+count);
//    }
//    if(count >= 10) LogManager.err(LogManager.PRODUCTION,"Communication","can not delete hearMeVoiceOcx object");
//    else LogManager.log(LogManager.PRODUCTION,"Communication","delete HearMeVoiceOcx object successfully");
  }
}