package com.anabas.sdsharedlet;

import com.anabas.sharedlet.*;
import com.anabas.concepts.*;
import com.anabas.util.misc.LogManager;
import com.anabas.util.nativeutils.NativeUtilsWrapper;
import com.anabas.util.ui.AnabasToolTipManager;
import com.anabas.gxo.*;
import com.anabas.naming.*;
import com.anabas.util.io.StreamUtil;
import com.anabas.sharedlet.framework.DefaultCapabilitiesManager;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.net.*;
import java.io.*;

/**
 * Title:
 * Description:
 * Copyright:     Copyright (c) 2000
 * Company:       Anabas Inc.
 * @author        Milind
 * @version       1.0
 */

public class SDControlView extends JPanel implements  SharedletView,
                                                      CapabilityListener,
                                                      ActionListener,
                                                      SessionListener {
  ///////////////////////////////////////
  // Private members
  ///////////////////////////////////////

  /* Dimensions */
  private static final int VIEW_WIDTH = 150;
  private static final int VIEW_HEIGHT = 35; // 90
  private static final int COMBO_WIDTH = 148;
  private static final int COMBO_HEIGHT = 22;

  /* Action Commands */
  private static final String ACTION_COMMAND_PAUSE = "a";
  private static final String ACTION_COMMAND_CLICK_TO_SHARE = "b";
  private static final String ACTION_COMMAND_SD_APP_LIST = "c";
  private static final String ACTION_COMMAND_RESUME = "d";
  private static final String ACTION_COMMAND_SD_CUR_APP_LIST = "e";
  private static final String ACTION_COMMAND_LIST_ALL_APPS = "f";
  private static final String ACTION_COMMAND_HILIGHT = "g";
  private static final String ACTION_COMMAND_MARKER = "h";
  private static final String ACTION_COMMAND_CLEAR = "i";
  //private static final String ACTION_COMMAND_ENABLE_ANNOTATION = "j";

  /* Button Images */
  private static final String PAUSE_IMAGE = "Pause.gif";
  private static final String CLICK_TO_SHARE_IMAGE = "ClickToShare.gif";
  private static final String SHOW_ALL_APPS_IMAGE = "share.gif";
  private static final String HIGHLIGHT_IMAGE = "Highlight.gif";
  private static final String MARKER_IMAGE = "Marker.gif";
  private static final String CLEAR_ANNOTATION_IMAGE = "ClearAll.gif";
  //private static final String ENABLE_ANNOTATION_IMAGE = "AnnoteMode.gif";
  private static final String PAUSEPRESSED_IMAGE = "PausePressed.gif";

  /* Button Tooltips */
  private static final String PAUSE_TOOLTIP = "Pause";
  private static final String CLICK_TO_SHARE_TOOLTIP = "Click to Share";
  private static final String SHOW_ALL_APPS_TOOLTIP = "Show All Applications";
  private static final String HIGHLIGHT_TOOLTIP = "Highlight";
  private static final String MARKER_TOOLTIP = "Marker";
  private static final String CLEAR_ANNOTATION_TOOLTIP = "Clear All";
  private static final String RESUME_TOOLTIP = "Resume";
  //private static final String ENABLE_ANNOTATION_TOOLTIP = "Enable Annotation";
  //private static final String DISABLE_ANNOTATION_TOOLTIP = "Disable Annotation";

  /* Other constants */
  private static final Color SELECTED_BUTTON_COLOR = new Color(170,170,170);
  private static final Border EMPTY_BORDER = new EmptyBorder(2,2,2,2);

  /* Instance variables */
  private int       m_lastActivatedWnd = 0;
  /*private int       m_browserWnd;
  private boolean   m_bSetBrowserWnd = false;*/
  private boolean   m_bHost = false;
  private boolean   m_bParticipant = false;
  private boolean   m_bAnnotating = false;
  private boolean   m_bRemoveURL = false;
  //private boolean   m_bAnnotationEnabled = false;
  private String    m_role;
  //private String    m_curURL = "";
  private Hashtable m_ht_sdAppList = new Hashtable();
  private Hashtable m_ht_curAppList = new Hashtable();
  private SharedletInfo m_sharedletInfo;
  private SharedletViewManager m_viewManager;

  private SharedletManager        m_sharedletManager;
  private SDSharedlet             m_sdsharedlet;
  private User                    m_thisUser;
  private JavaViewRenderer        m_renderer;
  private CapabilitiesManager     m_capabilitiesManager;
  private SessionManager          m_sessionManager;
  private LayoutService           m_layoutService;
  private SDWrapper               m_sdWrapper;
  private NativeUtilsWrapper      m_nativeUtils;
  private SDEventListenerThread   m_eventListenerThread;
  private SDPresentationView      m_presentationView;
  private NativeUtilsWrapper.SharedAppInfo m_curAppInfo;
  private ImageIcon               m_pauseIcon;
  private ImageIcon               m_resumeIcon;

  /* Components */
  private JLabel      m_label1              = new JLabel("Shared Applications");
  private JComboBox   m_cb_sdAppList        = new JComboBox();
//  private JComboBox   m_cb_sdCurAppList     = new JComboBox();
  private JButton     m_pauseResumeButton   = new JButton();
  private JButton     m_clickToShareButton  = new JButton();
  private JButton     m_AllAppsButton       = new JButton();
  private JButton     m_HilightButton       = new JButton();
  private JButton     m_MarkerButton        = new JButton();
  private JButton     m_ClearAnnotButton    = new JButton();
//  private JButton     m_AnnotModeButton     = new JButton();
  private JPanel      MainPanel;

  private JButton     m_pressedButton;
  private SDCurAppsDialog m_curAppsDialog;

  private JFrame      m_mainFrame;
  ///////////////////////////////////////
  // Public Methods
  ///////////////////////////////////////
  /* ----- Constructor ----- */
  public SDControlView() {
    log("Creating ControlView ...");
    m_sdWrapper = new SDWrapper(this);
    m_nativeUtils = new NativeUtilsWrapper();
    m_renderer = new JavaViewRenderer(this,this);

    // get handle to all required services
    getServices();

    //m_sdsharedlet.setSDWrapper(m_sdWrapper);

    ToolTipManager  tt_man = ToolTipManager.sharedInstance();
    AnabasToolTipManager    att_man = new AnabasToolTipManager();
    att_man.setInitialDelay( 2000 );

    tt_man.unregisterComponent(m_pauseResumeButton);
    tt_man.unregisterComponent(m_clickToShareButton);
    tt_man.unregisterComponent(m_AllAppsButton);
    tt_man.unregisterComponent(m_HilightButton);
    tt_man.unregisterComponent(m_MarkerButton);
    tt_man.unregisterComponent(m_ClearAnnotButton);

    att_man.registerComponent(m_pauseResumeButton);
    att_man.registerComponent(m_clickToShareButton);
    att_man.registerComponent(m_AllAppsButton);
    att_man.registerComponent(m_HilightButton);
    att_man.registerComponent(m_MarkerButton);
    att_man.registerComponent(m_ClearAnnotButton);

   // initialize the control view
    jbInit();
  }

  /* SharedletView Methods */
  public void activate() {
    boolean canAnnotate = canAnnotate();

    m_mainFrame = SDNativeRenderer.getMainFrame(this);

    log("activate: called  with Annotation set to [" + canAnnotate + "]");
    m_curAppsDialog = new SDCurAppsDialog(m_sdWrapper,m_mainFrame);

    // get the Layout Service handle ...
    if(m_layoutService == null)
      getLayoutService();

    m_sdWrapper.enableAnnotation(canAnnotate);
    enableAnnotationButtons(canAnnotate);
    m_pauseResumeButton.setToolTipText(PAUSE_TOOLTIP);
    m_pauseResumeButton.setActionCommand(ACTION_COMMAND_PAUSE);
    m_pauseResumeButton.setIcon(m_pauseIcon);
    enableSDButtons(canPresent());
  }

    public void deactivate()
    {
        /*disableAnnotation();
        enableAnnotation(false);*/
        log("deactivate: called ");
	if(m_curAppsDialog != null)
        {
            endAnnotation();
            m_curAppsDialog.dispose();
        }
    }

  /* ----- Other Instance Methods ----- */
  public void actionPerformed(ActionEvent e) {
     if (e.getActionCommand().equals(ACTION_COMMAND_RESUME)) {
      resumePressed();
    } else if (e.getActionCommand().equals(ACTION_COMMAND_PAUSE)) {
      pausePressed();
    } else if (e.getActionCommand().equals(ACTION_COMMAND_CLICK_TO_SHARE)) {
      clickToSharePressed();
    } else if (e.getActionCommand().equals(ACTION_COMMAND_SD_APP_LIST)) {
      appSelected();
    }/*else if (e.getActionCommand().equals(ACTION_COMMAND_SD_CUR_APP_LIST)) {
      appCurSelected();
    }*/else if (e.getActionCommand().equals(ACTION_COMMAND_LIST_ALL_APPS)) {
      listAllAppsPressed();
    }else if (e.getActionCommand().equals(ACTION_COMMAND_HILIGHT)) {
      hilightPressed();
    }else if (e.getActionCommand().equals(ACTION_COMMAND_MARKER)) {
      markerPressed();
    }else if (e.getActionCommand().equals(ACTION_COMMAND_CLEAR)) {
      clearPressed();
    }/*else if (e.getActionCommand().equals(ACTION_COMMAND_ENABLE_ANNOTATION)) {
      enableAnnotationPressed();
    }*/
  }

  private void clearPressed() {
    log("Clear pressed ...");
    endAnnotation();
    m_sdWrapper.clearAnnotations();
  }

  private void resumePressed() {
    log("Resume pressed ...");

    /*if(m_pressedButton != null)
      depressButton(m_pressedButton);*/

    enableSDButtons(true);
    enableAnnotationButtons(canAnnotate());

    //m_pressedButton = null;
    m_pauseResumeButton.setToolTipText(PAUSE_TOOLTIP);

    //depressButton(m_pauseResumeButton);
    pressPauseResumeButton(false);
    //m_pauseResumeButton.setSelected(false);

    m_pauseResumeButton.setActionCommand(ACTION_COMMAND_PAUSE);
    m_sdWrapper.pauseCapture(false);
  }

  private void pausePressed() {
    // For temp testing ...
    /*try {
      Context ctx = ContextManager.getInitialContext();
      // get Native Sharedlet instance ...
      Sharedlet native_sh = (Sharedlet) ctx.lookup("sharedlets/application/x-sharedlet-native/sharedlet");

      native_sh.loadDocument(new URL("file://c:/milind/docs/java.txt"));
    }
    catch (Exception ex) {
      log("Error while geting Native Sharedlet handle ....");
    }*/
    //SDSharedlet.loadURL();
    // For testing
/*    try {
      m_capabilitiesManager.setRemoteApplicationRole(newUserID,SDSharedletInfo.ROLE_HOST);
    }
    catch (Exception ex) {
      err("Could not set remote role  for the user [" + newUserID + "]", ex);
    }*/

//    m_pauseResumeButton.setText("Resume");
    log("Pause pressed ...");
    /*if(m_pressedButton != null)
      depressButton(m_pressedButton);*/

    //m_pauseResumeButton.setBackground(new Color(170,170,170));
    //setButtonPressed(m_pauseResumeButton);
    pressPauseResumeButton(true);
    //m_pauseResumeButton.setSelected(true);

    //enableSDButtons(false);
    m_AllAppsButton.setEnabled(false);
    enableAnnotationButtons(false);
    //m_pressedButton = m_pauseResumeButton;

    m_pauseResumeButton.setToolTipText(RESUME_TOOLTIP);
    //m_pauseResumeButton.repaint();

    m_pauseResumeButton.setActionCommand(ACTION_COMMAND_RESUME);
    m_sdWrapper.pauseCapture(true);
  }

  private void pressPauseResumeButton(boolean press) {
    ImageIcon icon = press ? m_resumeIcon : m_pauseIcon;
    m_pauseResumeButton.setIcon(icon);
  }

  private void enableSDButtons(boolean enable) {
    m_label1.setEnabled(enable);
    //m_cb_sdAppList.setEnabled(enable);

    m_AllAppsButton.setEnabled(enable);
    //m_clickToShareButton.setEnabled(enable);
    m_pauseResumeButton.setEnabled(enable);
  }

  private void setButtonPressed(JComponent component) {
    component.setBackground(SELECTED_BUTTON_COLOR);

    Color background = component.getBackground();
    Color highlight = component.getBackground().brighter().brighter();
    Color shadow = component.getBackground().darker().darker();
    Border b = new BevelBorder(BevelBorder.LOWERED, highlight,background,
                shadow, background);
//      Border b = new EtchedBorder(EtchedBorder.LOWERED);
    component.setBorder(b);
  }

  private void clickToSharePressed() {
    log("Click to Share pressed ...");
    //disableAnnotation();

    //endAnnotation();
//    if(m_pressedButton != m_clickToShareButton) {
    if(!m_clickToShareButton.isSelected()) {
      setButtonPressed(m_clickToShareButton);
      //m_pressedButton = m_clickToShareButton;
      m_clickToShareButton.setSelected(true);
      m_sdWrapper.ClickToShare(0,SDWrapper.CTS_DEFAULT);
    } else {
      /*depressButton(m_clickToShareButton);
      m_pressedButton = null;*/
    }
  }

  private void listAllAppsPressed() {
    log("List All Apps Pressed");

    //disableAnnotation();

    //endAnnotation();

    // get all current app list from the native code
    m_nativeUtils.clearCurApps();
    m_ht_curAppList = m_nativeUtils.getCurApps();

    // remove the action listener temporarily
    //m_cb_sdCurAppList.removeActionListener(this);

    // empty the UI list
    //m_cb_sdCurAppList.removeAllItems();

    int iCount = 0;
    Enumeration enum = m_ht_curAppList.elements();
    while (enum.hasMoreElements()) {
      enum.nextElement();
      iCount++;
    }

    log("Total #of current apps [" + iCount + "]");

    Object[] apps = new Object[iCount];
    enum = m_ht_curAppList.elements();
    iCount = 0;
    while (enum.hasMoreElements()) {
      Object item = enum.nextElement();
      apps[iCount++] = item;
    }

    m_curAppsDialog.setLocation(calculateDialogPos());
    NativeUtilsWrapper.SharedAppInfo curApp = null;
    m_curAppsDialog.show(apps);
/*    // make the list UI visible
    m_cb_sdCurAppList.setVisible(true);

    // restore the action listener
    m_cb_sdCurAppList.addActionListener(this);*/
  }

  /*private Point calculateDialogPos() {
    if(m_layoutService != null || getLayoutService()) {
      //Point pt1       = m_layoutService.getRegionPosition("control");
      Point pt1       = getParent().getLocationOnScreen();
      Point pt2       = new Point(0,0);
      Point CentrePt  = new Point(0,0);
log("######### calculateDialogPos: Got Control Panel Position [" + pt1 + "] ########");
      Dimension d   = m_layoutService.getRegionDimension("control");
log("######### calculateDialogPos: Got Control Panel size [" + d + "] ########");

      pt2.x = pt1.x + d.width;
      pt2.y = pt1.y + d.height;

      CentrePt.x = pt1.x + (pt2.x - pt1.x) / 2;
      CentrePt.y = pt1.y + (pt2.y - pt1.y) / 2;

      Dimension dim = m_curAppsDialog.getDimension();

      return new Point(CentrePt.x - dim.width / 2,
                    CentrePt.y - dim.height / 2);
    } else {
log("######### calculateDialogPos: cannot get Layout Service ###########");
     return new Point(0,0);
    }
  }*/

  private Point calculateDialogPos() {
    if(m_layoutService != null || getLayoutService() && m_mainFrame != null) {
      //Point pt1       = m_layoutService.getRegionPosition("control");
      Point pt1       = m_mainFrame.getLocationOnScreen();
      Point pt2       = new Point(0,0);
      Point CentrePt  = new Point(0,0);
log("######### calculateDialogPos: Got main frame Position [" + pt1 + "] ########");
      Dimension d   = m_mainFrame.getSize();
log("######### calculateDialogPos: Got main frame size [" + d + "] ########");

      pt2.x = pt1.x + d.width;
      pt2.y = pt1.y + d.height;

      CentrePt.x = pt1.x + (pt2.x - pt1.x) / 2;
      CentrePt.y = pt1.y + (pt2.y - pt1.y) / 2;

      Dimension dim = m_curAppsDialog.getDimension();

      return new Point(CentrePt.x - dim.width / 2,
                    CentrePt.y - dim.height / 2);
    } else {
log("######### calculateDialogPos: cannot get Layout Service ###########");
     return new Point(0,0);
    }
  }

  /*private void appCurSelected() {
    //log("appCurSelected: called ");
    // get the selected item
    NativeUtilsWrapper.SharedAppInfo curApp =
        (NativeUtilsWrapper.SharedAppInfo) m_cb_sdCurAppList.getSelectedItem();

    // extract the window handle from name
    int hwnd = curApp.getId();

    // call click to share native function
    m_sdWrapper.ClickToShare(hwnd,SDWrapper.CTS_SHARE);

    // make the list UI invisible
    m_cb_sdCurAppList.setVisible(false);
  }*/

  private void appSelected() {
    // get the SharedAppInfo object from the combo box
    NativeUtilsWrapper.SharedAppInfo appInfo = (NativeUtilsWrapper.SharedAppInfo)
                                                    m_cb_sdAppList.getSelectedItem();
    if(appInfo == null || m_curAppInfo == appInfo) {
      //log("same or null app selected ...");
      return;
    }

    //disableAnnotation();

    m_curAppInfo = appInfo;

    // get the app name
    String str = appInfo.getName();
    //log("---> Selection changed to : " + str);

    // get the app id
    int app_id = appInfo.getId();
    //log("---> Application id : " + app_id);

    m_sdWrapper.ClickToShare(app_id,SDWrapper.CTS_ACTIVATE);
  }

  private void hilightPressed() {
    log("Hilight pressed ...");
    //if(m_pressedButton != m_HilightButton) {
    if(!m_HilightButton.isSelected()) {
      endAnnotation();
      m_bAnnotating = true;
      setButtonPressed(m_HilightButton);
      //m_pressedButton = m_HilightButton;
      m_HilightButton.setSelected(true);
      log("Calling Hilight on SDWrapper ...");
      m_sdWrapper.hilight();
    } else {
      //depressButton(m_HilightButton);
      //m_pressedButton = null;
    }

/*
    SDBitmap    bitmap;

    bitmap = m_sdsharedlet.getBitmap(0);
    log("GetBitmap - (" + bitmap.width + ", " + bitmap.height + " (" + bitmap.format + ") - " + bitmap.data.length + " bytes");

    bitmap = m_sdsharedlet.getBitmap(0x01);
    log("GetBitmap - (" + bitmap.width + ", " + bitmap.height + " (" + bitmap.format + ") - " + bitmap.data.length + " bytes");

    bitmap = m_sdsharedlet.getBitmap(0x0D);
    log("GetBitmap - (" + bitmap.width + ", " + bitmap.height + " (" + bitmap.format + ") - " + bitmap.data.length + " bytes");
*/
/*

	ImageTestDlg            dlg = new ImageTestDlg(null);

	ColorModel.getRGBdefault().equals();
	              cm = new ColorModel(24);
	MemoryImageSource       mis = new MemoryImageSource(bitmap.width,
							bitmap.height,
	    						cm,
							bitmap.data, 0, bitmap.width);
	Image image = Toolkit.getDefaultToolkit().createImage(mis);
	dlg.setImage(image, bitmap.width, bitmap.height);
*/
    }

  private void markerPressed() {
    log("Marker pressed ...");
    //if(m_pressedButton != m_MarkerButton) {
    if(!m_MarkerButton.isSelected()) {
      endAnnotation();
      m_bAnnotating = true;
      setButtonPressed(m_MarkerButton);
      //m_pressedButton = m_MarkerButton;
      m_MarkerButton.setSelected(true);
      m_sdWrapper.mark();
    } else {
      //depressButton(m_MarkerButton);
      //m_pressedButton = null;
    }
  }

  /*void disableAnnotation() {
    log("@@@@@@@@@@@@@@@@@@@@@@@@ disableAnnotation called @@@@@@@@@@@@@@@@@");
    if(m_bAnnotationEnabled)
      enableAnnotationPressed();
  }*/

  /*private void enableAnnotationPressed() {
    log("Enable Annotation pressed ...");
    m_sdWrapper.enableAnnotation(!m_bAnnotationEnabled);
  }*/

  void endAnnotation() {
    /*if(m_pressedButton == m_HilightButton ||
        m_pressedButton == m_MarkerButton) {
      depressButton(m_pressedButton);
      m_pressedButton = null;
      m_bAnnotating = false;
    }*/
    JButton pressedBut = m_HilightButton.isSelected() ? m_HilightButton :
                         m_MarkerButton.isSelected() ? m_MarkerButton : null;

    if(pressedBut != null) {
      depressButton(pressedBut);
      pressedBut.setSelected(false);
      m_bAnnotating = false;
    }
  }

  /*private void selectButton(JComponent component){
    component.setBackground(SELECTED_BUTTON_COLOR);

    Color background = component.getBackground();
    Color highlight = component.getBackground().brighter().brighter();
    Color shadow = component.getBackground().darker().darker();
    Border b = new BevelBorder(BevelBorder.LOWERED, highlight,background,
              shadow, background);
    //      Border b = new EtchedBorder(EtchedBorder.LOWERED);
    component.setBorder(b);
    //component.repaint();
  }*/

  private void depressButton(JComponent component) {
    component.setBackground(getBackground());
    clearBorder(component);
    //component.repaint();
  }

  private void clearBorder(JComponent component) {
    component.setBorder(EMPTY_BORDER);
  }

  public SharedletViewRenderer getRenderer(String MIMEType) {
    if (MIMEType.equals("application/java")) {
      return m_renderer;
    }
    return null;
  }

  /* ----- SessionListener Methods ----- */
  public void userJoined(SessionEvent e) {
    User user = (User)e.getSource();
    //UserID id = user.getUserID();
    log("New user joined [" + user.getFirstName() + "]" );
//    m_userList.addItem(u.getUserID().getID());
  }

  public void userLeft(SessionEvent e) {
    User user = (User)e.getSource();
    //UserID id = user.getUserID();
    log("User left [" + user.getFirstName() + "]" );

    //    m_userList.removeItem(u.getUserID());
  }

  /* ----- CapabilityListener Methods ----- */
  public String getSharedletMIME() {
    return SDSharedletInfo.g_sharedletMIME;
  }

  public void remoteCapabilityChanged(String capability,boolean enabled,UserID userid) {
    log("Remote capability [" + capability + "] of user [" + userid.getID() + "] is ["
                + enabled + "]");
    /*try {
      if(m_bHost) {
        if(capability.equals(SDSharedletInfo.CAP_INPUTCONTROL)) {
          if(enabled) {
            m_capabilitiesManager.disableCapability(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.CAP_INPUTCONTROL);
          } else {
            m_capabilitiesManager.enableCapability(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.CAP_INPUTCONTROL);
          }
        } else if(capability.equals(SDSharedletInfo.CAP_PRESENTATION)) {
          if(enabled) {
            m_capabilitiesManager.disableCapability(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.CAP_PRESENTATION);
            m_capabilitiesManager.enableRemoteModeratable(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.ME_INPUTCONTROL,userid);
          } else {
            m_capabilitiesManager.enableCapability(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.CAP_PRESENTATION);
            m_capabilitiesManager.disableRemoteModeratable(SDSharedletInfo.g_sharedletMIME,
                      SDSharedletInfo.ME_INPUTCONTROL,userid);
          }
        }
      }
    }
    catch (Exception ex) {
      err("Error: while handling remote capability changed ...",ex);
    }*/
  }

  public void capabilityChanged(String capability,boolean enabled) {
    log("My '"+capability+"' is now " + enabled);

    if(capability.equals(SDSharedletInfo.CAP_INPUTCONTROL)) {
      enableInputControl(enabled);
    }
    else if(capability.equals(SDSharedletInfo.CAP_ANNOTATION)) {
      enableAnnotationCapability(enabled);
    }
    else if(capability.equals(SDSharedletInfo.CAP_PRESENTATION)) {
      enablePresentationCapability(enabled);
    }
    else {
      log("Capability changed to : Unknown : " + capability);
      return;
    }
  }

  public void roleChanged(String newRole) {
    log("roleChanged: ==========> My Role changed to [" + newRole + "]");
    if(m_presentationView != null || getPresentationView() != null)
      m_presentationView.refresh();
  }

  /*void enableAnnotation(boolean enable) {
    if(canAnnotate()) {
      if(enable) {
        setButtonPressed(m_AnnotModeButton);
        //m_pressedButton = m_AnnotModeButton;
        m_AnnotModeButton.setSelected(true);
      } else {
        depressButton(m_AnnotModeButton);
        //m_pressedButton = null;
        m_AnnotModeButton.setSelected(false);
      }
      enableAnnotationButtons(enable);
    }
    m_bAnnotationEnabled = enable;
    m_AnnotModeButton.setToolTipText(enable ? DISABLE_ANNOTATION_TOOLTIP :
                                        ENABLE_ANNOTATION_TOOLTIP);
  }*/

  void enableAnnotationButtons(boolean enable) {
    m_HilightButton.setEnabled(enable);
    m_MarkerButton.setEnabled(enable);
    m_ClearAnnotButton.setEnabled(enable);
  }

  void enableAnnotationCapability(boolean enable) {
  log("calling enable Annotation on SDWrapper with [" + enable + "]");
    boolean ret =  m_sdWrapper.enableAnnotation(enable);
    log("enableAnnotation: returned : [" + ret + "]");
    enableAnnotationButtons(enable);

    /*if(!enable) {
      if(m_HilightButton.isSelected()) {
        depressButton(m_HilightButton);
        m_HilightButton.setSelected(false);
      }
      if(m_MarkerButton.isSelected()) {
        depressButton(m_MarkerButton);
        m_MarkerButton.setSelected(false);
      }
      if(m_AnnotModeButton.isSelected()) {
        depressButton(m_AnnotModeButton);
        m_AnnotModeButton.setSelected(false);
      }
      enableAnnotationButtons(false);
    }
    m_AnnotModeButton.setEnabled(enable);
    if(enable && m_bAnnotationEnabled) {
      enableAnnotationButtons(true);
      setButtonPressed(m_AnnotModeButton);
    }*/
  }

  private void enableInputControl(boolean enable) {
    m_sdWrapper.EnableInputControl(enable,getToken(SDSharedletInfo.CAP_INPUTCONTROL));
  }

  private void enablePresentationCapability(boolean enable) {
    if(enable) {
      m_sdWrapper.listen(getToken(SDSharedletInfo.CAP_PRESENTATION));
    } else {
      m_sdWrapper.connect(getToken(SDSharedletInfo.CAP_PRESENTATION));
    }

    if(m_eventListenerThread != null || getEventListenerThread()) {
      m_eventListenerThread.startRFUThread(enable);
    }

    if(m_presentationView != null || getPresentationView() != null) {
    log("!!!!!!!!!!!!!!!!!!!! seting presenter as [" + enable + "] !!!!!!!!!!!!!!!!!!!!!!!!");
      m_presentationView.setAsPresenter(enable);
    }

    this.enableSDButtons(enable);
  }

  private void jbInit() {
    Dimension d = new Dimension(VIEW_WIDTH,VIEW_HEIGHT);
    this.setPreferredSize(d);

    setLayout(new GridBagLayout());

    MainPanel = new JPanel();
    MainPanel.setLayout(new GridBagLayout());

    /*constrain(MainPanel, m_label1,
        0,0,
        6,1,
        GridBagConstraints.HORIZONTAL ,
        GridBagConstraints.SOUTHWEST,1.0,0.0,
        0,0,0,0);

    Dimension size = new Dimension(COMBO_WIDTH,COMBO_HEIGHT);

    m_cb_sdAppList.setMaximumSize(size);
    m_cb_sdAppList.setMinimumSize(size);
    m_cb_sdAppList.setPreferredSize(size);

    constrain(MainPanel, m_cb_sdAppList,
        0,1,
        6,1,
        GridBagConstraints.HORIZONTAL ,
        GridBagConstraints.NORTHWEST,1.0,0.0,
        0,0,4,0);*/

    //JPanel buttonsPanel = new JPanel();
    addImageButtons(MainPanel);

    /*constrain(MainPanel, buttonsPanel,
          1,1,
          1,1,
          GridBagConstraints.NONE ,
          GridBagConstraints.SOUTH,
          0.0,1.0,
          2,0,0,0);*/
    /*m_cb_sdCurAppList.setMaximumSize(size);
    m_cb_sdCurAppList.setMinimumSize(size);
    m_cb_sdCurAppList.setPreferredSize(size);
    constrain(MainPanel, m_cb_sdCurAppList,
        0,3,
        6,1,
        GridBagConstraints.HORIZONTAL ,
        GridBagConstraints.SOUTH,1.0,0.0,
        2,0,0,0);*/

    constrain(this, MainPanel,
        1,1,
        5,2,
        GridBagConstraints.NONE ,
        GridBagConstraints.CENTER,1.0,0.0,
        0,0,0,0);

    enableAnnotationButtons(canAnnotate());
    enableSDButtons(canPresent());

    /*m_HilightButton.setEnabled(false);
    m_MarkerButton.setEnabled(false);
    m_ClearAnnotButton.setEnabled(false);

    if(!canAnnotate())
      m_AnnotModeButton.setEnabled(false);

    if(m_bParticipant)
    {
      m_pauseResumeButton.setEnabled(false);
      m_clickToShareButton.setEnabled(false);
      m_AllAppsButton.setEnabled(false);
      //m_cb_sdCurAppList.setEnabled(false);
      m_label1.setEnabled(false);
      m_cb_sdAppList.setEnabled(false);
    }*/

    /*if(m_bParticipant)
    {
      m_label1.setEnabled(false);
      m_cb_sdAppList.setEnabled(false);
    }*/

    //m_cb_sdCurAppList.setVisible(false);

    //m_cb_sdAppList.setActionCommand(ACTION_COMMAND_SD_APP_LIST);
    //m_cb_sdCurAppList.setActionCommand(ACTION_COMMAND_SD_CUR_APP_LIST);

    //m_cb_sdAppList.addActionListener(this);
    //m_cb_sdCurAppList.addActionListener(this);

    try {
      m_pauseIcon = new ImageIcon(StreamUtil.inputStreamToBytes(
          SDControlView.class.getResourceAsStream(PAUSE_IMAGE)));

      m_resumeIcon = new ImageIcon(StreamUtil.inputStreamToBytes(
          SDControlView.class.getResourceAsStream(PAUSEPRESSED_IMAGE)));
    }
    catch (Exception ex) {
      err("Error: loading button image icons: ",ex);
    }
  }

  private void addImageButtons(Container panel) {
    Dimension ButtonSize = new Dimension(24,24);
    ImageIcon icon = null;

    JButton[] buttons = {
        m_AllAppsButton,
        //m_clickToShareButton,
        m_pauseResumeButton,
        m_HilightButton,
        m_MarkerButton,
        m_ClearAnnotButton
        //m_AnnotModeButton
        };

    String[] defaultIcons = {
        SHOW_ALL_APPS_IMAGE,
        //CLICK_TO_SHARE_IMAGE,
        PAUSE_IMAGE,
        HIGHLIGHT_IMAGE,
        MARKER_IMAGE,
        CLEAR_ANNOTATION_IMAGE,
        //ENABLE_ANNOTATION_IMAGE
      };

    String[] tooltips = {
        SHOW_ALL_APPS_TOOLTIP,
        //CLICK_TO_SHARE_TOOLTIP,
        PAUSE_TOOLTIP,
        HIGHLIGHT_TOOLTIP,
        MARKER_TOOLTIP,
        CLEAR_ANNOTATION_TOOLTIP,
        //ENABLE_ANNOTATION_TOOLTIP
      };

    String[] actionCommands = {
        ACTION_COMMAND_LIST_ALL_APPS,
        //ACTION_COMMAND_CLICK_TO_SHARE,
        ACTION_COMMAND_PAUSE,
        ACTION_COMMAND_HILIGHT,
        ACTION_COMMAND_MARKER,
        ACTION_COMMAND_CLEAR,
        //ACTION_COMMAND_ENABLE_ANNOTATION
      };

    try {
      MouseListener mouseListener = new MouseAdapter() {
          public void mouseEntered(MouseEvent e){
            JButton but = (JButton) e.getSource();

            /*if(!m_bAnnotating && m_pressedButton != m_clickToShareButton)
              m_pressedButton = null;*/

            //if(but != m_pressedButton) {
            if(!but.isSelected()) {
              /*if(but == m_AnnotModeButton && m_bAnnotationEnabled)
                return;*/
              Color background = but.getBackground();
              Color highlight = but.getBackground().brighter().brighter();
              Color shadow = but.getBackground().darker().darker();
              Border b = new BevelBorder(BevelBorder.RAISED, highlight,background,
                          shadow, background);
              if(but.isEnabled())
                but.setBorder(b);
            }
          }
          public void mouseExited(MouseEvent e){
            JButton but = (JButton) e.getSource();
            //if(but != m_pressedButton) {
            if(!but.isSelected()) {
              /*if(but == m_AnnotModeButton && m_bAnnotationEnabled)
                return;*/
              if(but.isEnabled())
                clearBorder(but);
            }
          }
        };

      for(int ButtonCount = 0;ButtonCount < buttons.length;ButtonCount++) {

        icon = new ImageIcon(StreamUtil.inputStreamToBytes(
            SDControlView.class.getResourceAsStream(defaultIcons[ButtonCount])));
        buttons[ButtonCount].setIcon(icon);

/*        buttons[ButtonCount].setPreferredSize(
            new Dimension(icon.getIconWidth()+4, icon.getIconHeight()+4));*/
        clearBorder(buttons[ButtonCount]);
        buttons[ButtonCount].setFocusPainted(false);
        buttons[ButtonCount].setToolTipText(tooltips[ButtonCount]);
        buttons[ButtonCount].setActionCommand(actionCommands[ButtonCount]);
        buttons[ButtonCount].addActionListener(this);
        buttons[ButtonCount].addMouseListener(mouseListener);
        buttons[ButtonCount].setMaximumSize(ButtonSize);
        buttons[ButtonCount].setMinimumSize(ButtonSize);
        buttons[ButtonCount].setPreferredSize(ButtonSize);

        //panel.add(buttons[ButtonCount]);
        constrain(panel, buttons[ButtonCount],
          ButtonCount,1,
          1,1,
          GridBagConstraints.NONE ,
          GridBagConstraints.SOUTH,
          0.0,1.0,
          2,0,0,0);
      }
    }
    catch (IOException ex) {
      err("setButtonImages: Error",ex);
    }
  }

  boolean canAnnotate() {
    return m_capabilitiesManager.isCapable(SDSharedletInfo.g_sharedletMIME,
                         SDSharedletInfo.CAP_ANNOTATION);
  }

  boolean canPresent() {
    return m_capabilitiesManager.isCapable(SDSharedletInfo.g_sharedletMIME,
                         SDSharedletInfo.CAP_PRESENTATION);
  }

  private void constrain( Container container, Component component,
             int grid_x,int grid_y,
             int grid_width, int grid_height,
             int fill,
             int anchor, double weight_x, double weight_y,
             int top, int left, int bottom, int right) {
     GridBagConstraints c= new GridBagConstraints();

     c.gridx=grid_x; c.gridy=grid_y;
     c.gridwidth=grid_width; c.gridheight=grid_height;
     c.fill=fill; c.anchor=anchor;
     c.weightx=weight_x; c.weighty=weight_y;
     if(top+bottom+left+right>0)
     c.insets = new Insets(top,left,bottom,right);
     ((GridBagLayout)container.getLayout()).setConstraints(component, c);
     container.add(component);
  }

  private boolean getLayoutService() {
    try {
      Context ctx = ContextManager.getInitialContext();
      // get the Layout service handle
      m_layoutService = (LayoutService) ctx.lookup("services/LayoutService");
    }
    catch (Exception ex) {
      //err("getLayoutService: Error ",ex);
      return false;
    }
    return true;
  }

  void enableRemoveURL(boolean enable) {
    m_bRemoveURL = enable;
  }

  int[] getSharedWnds() {
    int apps = m_ht_sdAppList.size();
    int[] ids = new int[apps];

    int iCount = 0;
    Enumeration enum = m_ht_sdAppList.keys();
    while (enum.hasMoreElements()) {
      Integer id = (Integer) enum.nextElement();
      ids[iCount++] = id.intValue();
    }
    return ids;
  }

  void updateApplication(int id, String strTitle,int command) {
    //log("updateApplication: called ....");

    //if(m_pressedButton == m_clickToShareButton) {
    if(m_clickToShareButton.isSelected()) {
    log("depressing Click-To-Share button ...");
      depressButton(m_clickToShareButton);
      m_clickToShareButton.setSelected(false);
    };

    NativeUtilsWrapper.SharedAppInfo appInfo = null;
    //NativeUtilsWrapper.SharedAppInfo appToRemove = null;
    Integer key = null;

    switch (command) {
      case SDWrapper.COMMAND_APP_SHARED:
        log("updateApplication: Adding application : " + strTitle);

        /*if(m_bSetBrowserWnd) {
          m_bSetBrowserWnd = false;
          m_browserWnd = id;
        }*/

        // create SharedAppInfo object ..
        appInfo = new NativeUtilsWrapper.SharedAppInfo(id,strTitle);
        // add this to the local hash table ..
        m_ht_sdAppList.put(new Integer(id),appInfo);

        // remove temporarily the action listener of the combo box ...
        m_cb_sdAppList.removeActionListener(this);
        // add it to the combo box ..
        m_cb_sdAppList.addItem(appInfo);
        // make it the current item
        m_cb_sdAppList.setSelectedItem(appInfo);
        m_curAppInfo = appInfo;
        // restore the action listener
        m_cb_sdAppList.addActionListener(this);
        break;

      case SDWrapper.COMMAND_APP_ACTIVATED:
        log("updateApplication: Activating application : " + strTitle);

        key = new Integer(id);

        // if other URL is opened in the same browser window
        /*if(id == m_browserWnd) {
          // create SharedAppInfo object ..
          appInfo = new NativeUtilsWrapper.SharedAppInfo(id,m_curURL);

          // add this to the local hash table ..
          appToRemove = (NativeUtilsWrapper.SharedAppInfo) m_ht_sdAppList.put(key,appInfo);

          // add it to the combo box ..
          m_cb_sdAppList.addItem(appInfo);

        } else {*/
          // get the SharedAppInfo object from the hash table with key as the id
          appInfo = (NativeUtilsWrapper.SharedAppInfo) m_ht_sdAppList.get(key);
        //}
        if(appInfo != null) {
          m_lastActivatedWnd = id;
          // remove temporarily the action listener of the combo box ...
          m_cb_sdAppList.removeActionListener(this);

          /*if(appToRemove != null) {
            m_cb_sdAppList.removeItem(appToRemove);
          }*/

          // make it the current item
          m_cb_sdAppList.setSelectedItem(appInfo);
          m_curAppInfo = appInfo;
          // restore the action listener
          m_cb_sdAppList.addActionListener(this);
        }
        else {
          log("updateApplication: Got invalid id from natie code while activating app ["
                  + strTitle + "]");
        }
        break;

      case SDWrapper.COMMAND_APP_UNSHARED:
        log("updateApplication: Removing application : " + strTitle);
        key = new Integer(id);

        if(m_bRemoveURL)
          m_sdsharedlet.removeURL(key);

        /*if(id == m_browserWnd) {
            m_browserWnd = 0;
        }*/

        // get the SharedAppInfo object from the hash table with key as the id
        appInfo = (NativeUtilsWrapper.SharedAppInfo) m_ht_sdAppList.get(key);
        if(appInfo != null) {
          // remove this entry from the hash table ...
          m_ht_sdAppList.remove(key);
          // remove this app from the combo box ...
          m_cb_sdAppList.removeItem(appInfo);
        }
        else {
          log("updateApplication: Got invalid id from natie code while removing app ["
                  + strTitle + "]");
        }
        break;

      case SDWrapper.COMMAND_APP_CLOSED:
        /*if(id == m_browserWnd) {
            m_browserWnd = 0;
        }*/
        log("updateApplication: application closed: " + strTitle);
        break;

      case SDWrapper.COMMAND_APP_SHARECANCELED:
        log("updateApplication: application share cancelled: " + strTitle);
        /*if(m_sdsharedlet != null)
          m_sdsharedlet.removeURL(new Integer(id));
        else log("SDSharedlet null ...");*/
        break;

      default:
          log("updateApplication: updating application [" + strTitle + "]");
          log("Unknow command [" + command + "] while updating application ...");
        break;
    }
  }

  /*public void   modeChanged(short newMode) {
    switch (newMode) {
      case CapabilitiesManager.SLAVE_MODE:
        log("Mode changed to : Slave");
        break;

      case CapabilitiesManager.MODERATOR_MODE:
        log("Mode changed to : Moderator");
        break;

      case CapabilitiesManager.MASTER_MODE:
        log("Mode changed to : Master");
        break;

      default:
        log("Mode changed to : Unknown");
        break;
    }
  }*/

  private boolean getServices() {
    try {
      Context ctx = ContextManager.getInitialContext();
      // get a handle to the Communication service ...
      /*m_commService = (CommunicationService)ctx.lookup("services/CommunicationService");

      m_stream = m_commService.findStream(SDSharedletInfo.g_sharedletMIME);
      if (m_stream == null) {  // Create the stream if it doesn't exist.
        m_stream = m_commService.createStream(SDSharedletInfo.g_sharedletMIME);
      }
      m_publisher = m_stream.createPublisher();
      m_subscriber = m_stream.createSubscriber();
      m_subscriber.setMessageListener(this);*/

      // get a handle to the Capabilities Manager
      m_capabilitiesManager = (CapabilitiesManager)ctx.lookup("services/CapabilitiesManager");
      m_capabilitiesManager.addCapabilityListener(this);

      m_role = m_capabilitiesManager.getRole(SDSharedletInfo.g_sharedletMIME);

      if(m_role == null) {
        log("Could not get role from the Capabilities manager ...");
      } else {
        log("My role is [" + m_role + "]");
        if(m_role.equals(SDSharedletInfo.ROLE_HOST))
          m_bHost = true;
        else if(m_role.equals(SDSharedletInfo.ROLE_PARTICIPANT))
          m_bParticipant = true;
      }

      m_sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
      m_sdsharedlet = (SDSharedlet) m_sharedletManager.getSharedlet(
                          m_sharedletManager.getInfo(SDSharedletInfo.g_sharedletMIME));

      m_sessionManager = (SessionManager)ctx.lookup("services/SessionManager");
      m_sessionManager.addSessionListener(this);

      m_thisUser = m_sessionManager.getMyUser();

      log("The current user is [" + m_thisUser.getFirstName() + "]");
/*      Vector p = m_sessionManager.getParticipants();
      Enumeration enum = p.elements();
      while(enum.hasMoreElements()) {
        m_userList.addItem(((User)enum.nextElement()).getUserID().getID());
      }*/
    }
    catch (Exception ex) {
        err("getServices: Error",ex);
        return false;
    }
    return true;
  }

  SDWrapper getSDWrapper() {
    return m_sdWrapper;
  }

  Object getPresentationView() {
    try {
    m_presentationView = (SDPresentationView) getMyView(
                                  SDPresentationViewInfo.PRESENTATION_VIEW_NAME);
    }
    catch (Exception ex) {
      err("getPresentationView: Error: " , ex);
    }
    return m_presentationView;
  }

  int getLastActivatedWnd() {
    return m_lastActivatedWnd;
  }

  boolean getEventListenerThread() {
    if(m_presentationView != null || getPresentationView() != null) {
      m_eventListenerThread = m_presentationView.getEventListenerThread();
    }
    return m_eventListenerThread != null;
  }

  long getToken(String capability) {
    DefaultCapabilitiesManager defLayoutService = (DefaultCapabilitiesManager)
                    m_capabilitiesManager;

    return defLayoutService.getAtomicCapabilityNumber(SDSharedletInfo.g_sharedletMIME, capability);
  }

  private boolean getMyViewInfo() throws Exception {
    Context ctx = ContextManager.getInitialContext();
    SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");

    m_sharedletInfo = sharedletManager.getInfo(SDSharedletInfo.g_sharedletMIME);

    if(m_sharedletInfo == null) {
      throw new Exception("### getMyViewInfo: cannot get sharedlet info for [" +
                  SDSharedletInfo.g_sharedletMIME + "]");
    }
    m_viewManager = sharedletManager.getViewManager();

    return m_viewManager != null;
  }

  SharedletView getMyView(String viewName) throws Exception {
    if((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo())
    {
      log("==========>> 1 : " + m_sharedletInfo + ", " + m_viewManager + "<<======");
      return null;
      }

    Vector views = m_sharedletInfo.getViewInfos();
    if(views == null) {
      throw new Exception("### getMyView: cannot get views for [" + SDSharedletInfo.g_sharedletMIME + "]");
    }

    SharedletViewInfo viewInfo = null;
    Enumeration enum = views.elements();
    while (enum.hasMoreElements()) {
      SharedletViewInfo item = (SharedletViewInfo) enum.nextElement();
      if(item.getID().equals(viewName)) {
        viewInfo = item;
        break;
      }
    }

    if(viewInfo == null) {
      throw new Exception("### getMyView: cannot get view named [" + viewName + "]");
    }
    return m_viewManager.getView(viewInfo);
  }


  /*void setBrowserWnd(String strCurURL) {
    m_curURL = strCurURL;
    if(m_browserWnd == 0) {
      log("########## finding the browser wnd #########");
      m_bSetBrowserWnd = true;
    }
  }*/

  private void err(String ErrMsg, Exception ex) {
    LogManager.err("SDSharedlet::SDControlView",ErrMsg,ex);
  }

  private void log(String msg) {
    LogManager.log("SDSharedlet::SDControlView",msg);
  }
}
