package com.anabas.testsharedlet;

/****************************************************************************
 * iJabberClient is an interface, which you can implement and
 * register to handle incoming Jabber Instant Messages and rawXML.
 * @author	Jonathan Paulson
 * @version 	$ 0.7.3 $
 ****************************************************************************/
public interface IJabberClient
{
 // Incoming Jabber Instant Message
 public void msgReceived(String from, String type, String subject,
                         String body, String trhread);

 // A reply to your message has been started
 //public void msgReplyStarted(String from, String msg);

 // Incoming Jabber Presence
 public void presenceReceived(String to,String from,String type,String status,
                              String priority, String show, String error,
                              String code);

 // Incoming Jabber InfoQuery
 public void infoQueryReceived(String to, String from, String ID,
                               String type, String query, String error,
                               String code);

 // Incoming XML received from the Jabber Server (one character at a time)
 // This is primarily used for debugging.
 public void rawXML(String XML);

 // An incoming Jabber Tag and XML that currently isn't supported by JabberAnt
 public void unsupportedTag(String tagName, String XMLDoc);
 public void error(String str);
 public void connectionClosed();
};










