#!/bin/sh
#
#This script is called once every 5 minutes by CRON to check if the sonicMQ
#is running.  If not, it is going to recreate the database and then
#restart the sonic MQ
#

SONIC_HOME=/opt/anabas/sonic

function record()
{
	echo `date` > $mailfile
	echo "Sonic crashed, restart it now" >> $mailfile
	mail -s "sonic crashed" cms-admin@anabas.com < $mailfile
	echo >> $error
	echo `date` >> $error
	echo "***************************************" >> $error
	if [ -e $recordfile ]
	then
		read count < $recordfile	
	else
		count=0
	fi
	count=`expr $count + 1`
	echo $count > $recordfile
}

function forcestart()
{
	killall java
	/etc/rc.d/init.d/sonicMQ start 	
}


function cleanstart()
{
	killall java
	sleep 1
	rm -fr /opt/anabas/sonic/SonicMQDB
	sleep 2
#	su - anabas -c "/opt/anabas/sonic/bin/createdb.sh"
	$SONIC_HOME/bin/createdb.sh
	sleep 2
#	su - anabas -c "/opt/anabas/sonic/bin/dbtool.sh -d all"
	$SONIC_HOME/bin/dbtool.sh -r a
	sleep 2
#	su - anabas -c "/opt/anabas/sonic/bin/dbtool.sh -c all"
	sleep 10	
	$SONIC_HOME/bin/dbtool.sh -r i
	sleep 2
	/etc/rc.d/init.d/sonicMQ start

	echo `date` > $mailfile
	echo "SonicMQ has been successfully restarted. Don't worry" >> $mailfile
	mail -s "sonic restarted" cms-admin@anabas.com < $mailfile
}


error=/opt/anabas/sonic/error.log
recordfile=/opt/anabas/sonic/record.log
pidfile=/opt/anabas/sonic/sonicMQ_pid
mailfile=/opt/anabas/sonic/sonicMQmail

if [ ! -e $pidfile ]
then
	record
	echo "SonicMQ not running, force it to start">>${error}
	cleanstart
	exit 0
else
	read pid < $pidfile
	ps -ef | grep $pid > temppidfile
	processes=`cat temppidfile | wc -l`
	if [ $processes -lt 2 ]
	then
		record
		echo "SonicMQ not running, force it to start">>${error}
		cleanstart
		exit 0
	fi	
	read a mypid b < temppidfile
	echo "pid=$pid   mypid=$mypid"
	rm -f $temppidfile
	if [ $pid = "$mypid" ]
	then
		echo "sonicMQ is running properly"
	else
		echo "sonicMQ not running,start it now" >> ${error}
		record
#		n=`expr $count % 10`
#		if [ $n -eq 0 ]
#		then
			echo "clean database start" >> ${error}
			cleanstart
#		else
#			echo "force start" >> ${error}
#			forcestart
#		fi
	fi
	
fi
