/****************************************************************************
 * IAnabasClient is an interface, which you can implement and  register
 * to handle incoming Anabas Instant Messages.
 * @author  Kangseok Kim
 ****************************************************************************/
package com.anabas.pdasharedlet;

public interface IAnabasClient
{
 // Incoming Anabas Message
 public void anabasMsgReceived(String name, String body);

 // Incoming XML received from the Anabas Server (one character at a time)
 // This is primarily used for debugging.
 public void rawXML(String XML);

 // An incoming Anabas Tag and XML that currently isn't supported by Anabas
 public void unsupportedTag(String tagName, String XMLDoc);

 public void error(String str);

 public void connectionClosed();
};










