package com.anabas.pdasharedlet;

/**
 * Title:        PAdaptor.java
 * Description:  PDA Adaptor class.
 *               extends Thread as a daemon
 *               get HHms message from TCP/IP Server class and process it.
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */

import java.awt.*;
import java.awt.Event;
import java.lang.*;
import java.util.*;

public class PAdaptor extends Thread {

  /**
   *  called from TCPServer and maintain up-to-date registry
   *
   *  @param  registry hashtable

  public void upDate(Hashtable registry) {
    hash = registry;
  }
  */

  public void getGMSMessage(String messageType, String userName, String userID,
        String msg, int applicationID){

    System.out.println(messageType + " " + userName + " " + userID + " " + msg);

    switch(applicationID) {
      case 0:
        break;
      case 1:
        svg.getGMSMessage(msg);
        System.out.println(messageType + " " + userName + " " + userID + " " + msg);
        break;
      case 2:
        // sd.getGMSMessage(messageType, userName, userID, msg);
        System.out.println(messageType + " " + userName + " " + userID + " " + msg);
        break;
      case 3:
        // im.getGMSMessage(messageType, userName, userID, msg);
        System.out.println(messageType + " " + userName + " " + userID + " " + msg);
        break;
      default:
        System.out.println("ERROR: Un-Registered Application Message");
        break;
    }
  }

  /**
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 0);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 1);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 2);
  }
  public void sendGMSMessage(String messageType, String userName, String userID,
              String msg){
      pcv.broadcastMessage(messageType, userName, userID, messageText, 3);
  }
  **/

  /**
   *
   */
  public void getHHMP(byte[] b, int i) {
    byte[] hhms = new byte[i];
    hhms = b;

    Hashtable hashMessage = hc.HHMPtoplain(hhms, i);
    System.out.println(hashMessage);
    String s = (String)hashMessage.get("aid");

    if(s.compareTo("0")==0) im.getMessage(hashMessage);
    /**
    else if(s.compareTo("1")==0) {
      String dataString = (String)hashMessage.get("edata");
      if(dataString.compareTo("test") != 0) {
        svg.getMessage(hashMessage);
      }
    }
    else if(s.compareTo("2")==0) sd.getMessage(hashMessage);
    else if(s.compareTo("3")==0) textchat.getMessage(hashMessage);
    **/

    System.out.println("machineID " + hashMessage.get("mid"));
    System.out.println("applicationID " + hashMessage.get("aid"));
    System.out.println("topicID " + hashMessage.get("tid"));
    System.out.println("eventID " + hashMessage.get("eid"));
    System.out.println("eventData " + hashMessage.get("edata"));

  }

  /**
   *
   */
  public void setHHMP(Hashtable hs) {
    String s = (String)hs.get("edata");
    int size = s.length();
    byte[] hhmp = new byte[size + 5];
    hhmp = hc.plaintoHHMP(hs);
    String aid = (String) hs.get("aid");
    Hashtable temp = new Hashtable();
    if(aid.compareTo("0")==0) temp = IMhash;
    else if(aid.compareTo("1")==0) temp = SVGhash;
    else if(aid.compareTo("2")==0) temp = SDhash;
    else if(aid.compareTo("3")==0) temp = TextChathash;

    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         String ac = (String)hs.get("aid") + "AC";
         if(ac.compareTo(sh.APPLICATIONID)==0) sh.sendHHMP(hhmp);
    }
  }

  public void setHHMP0(byte[] b) {
    Hashtable temp = new Hashtable();
    temp = SVGhash;

    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(b);
    }
  }

  public void setHHMP2(String s) {
    Hashtable temp = new Hashtable();
    temp = IMhash;

    for (Enumeration e = temp.elements() ; e.hasMoreElements() ;) {
         sh = (SocketHandler)e.nextElement();
         sh.sendHHMP(s.getBytes());
    }
  }

  public PAdaptor(PdaControlView o_pcv) {
    this.pcv = pcv;
    run();
  }


  public void run() {
    tc = new TCPServer(this);
    tc.start();
  }

  // IMModule
  protected IMNet im = new IMNet(this);
  // SVGModule
  protected SVG svg = new SVG(this);

  // protected ServerInterface si = new ServerInterface(this);
  protected HHMPconverter hc = new HHMPconverter();
  public Hashtable IMhash = new Hashtable();
  public Hashtable SVGhash = new Hashtable();
  public Hashtable SDhash = new Hashtable();
  public Hashtable TextChathash = new Hashtable();

  protected TCPServer tc;
  protected SocketHandler sh;

  // Parent Class PdaControlView
  protected PdaControlView pcv;
}


