package com.anabas.pdasharedlet;

//  SVGRendering.java 
//    auther : Sangmi Lee (slee@csit.fsu.edu)
//    purpose : Parse and Render image from SVG docuement 
//    functions : Parse SVG document, 
//                Render JAVA 2D JPEG image
//    last update : April,02,2001



import java.io.*;
import java.net.*;
import org.apache.batik.transcoder.image.JPEGTranscoder;
import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.TranscoderOutput;

public class SVGRenderingEngine {
    
    public SVGRenderingEngine () {
    }


    public void GetSVG(String str) {

       InputStream in = null;
       OutputStream out = null;
       System.out.println("PDA Adaptor is getting SVG document..."); 
       try {
        //  File f = new File("tmpout.svg");
         // if (f.exists()) f.delete();   
       
	    URL url = new URL(str);  // Create URL
	    in = url.openStream();	// Open stream to it
		 
	    out = new FileOutputStream("tmpout.svg");
		  

	    // Copy bytes from URL to output stream
	    byte[] buffer = new byte[4096];
	    int bytes_read;
	    while((bytes_read = in.read(buffer)) != -1)
		    out.write(buffer, 0, bytes_read);
	 }
	 // On exceptions, print error message and usage message
	 catch (Exception e) {
		  System.err.println(e);
		  System.err.println("Usage: getURL  []");
	 }
	 finally {  // Always close the streams, no matter what.
              try {
			 in.close();
			 out.close();
                   //System.out.print("SVG file done");
		  }
              catch (Exception e) {}

	 }
   }
 
  
    public void SVGRender(String str1 , String str2, double d) {
        String svgfilename = str1.substring(0);
        String jpegfilename = str2.substring(0);
        //System.out.println("PDA Acreating svg file");
        // create a JPEG transcoder
        
        JPEGTranscoder t = new JPEGTranscoder();
        // set the transcoding hints
        t.addTranscodingHint(JPEGTranscoder.KEY_XML_PARSER_CLASSNAME,
                             "org.apache.crimson.parser.XMLReaderImpl");
        t.addTranscodingHint(JPEGTranscoder.KEY_QUALITY,
                             new Float(.8));
//        t.addTranscodingHint(JPEGTranscoder.KEY_WIDTH, new Float(int1));
        t.addTranscodingHint(JPEGTranscoder.KEY_WIDTH,new Float(d));
        // create the transcoder input
        try{
            
           
            String svgURI = new File(svgfilename).toURL().toString();
            TranscoderInput input = new TranscoderInput(svgURI);
        
       
            
        
           // create the transcoder output
        
            OutputStream ostream = new FileOutputStream(jpegfilename);
            TranscoderOutput output = new TranscoderOutput(ostream);    
       
            // save the image
        
            t.transcode(input, output);
            ostream.flush();
            ostream.close();
            System.out.println("SVG Image Rendering is done...");
        }
        catch(Exception e){};
                       
    }

    

}
