package com.anabas.pdasharedlet;
/**
 * Title:        TCPServer.java
 * Description:  TCP/IP Server class
 *               support TCP/IP connection to PDA and communicate HHms
 * Copyright:    Copyright (c) 2001
 * Company:      CSIT FSU
 * @author       Sangyoon Oh soh@csit.fsu.edu
 * @version 1.0
 */

import java.io.*;
import java.net.*;
import java.util.*;

public class TCPServer extends Thread {

  /**
   *  constructor:  open one socket and assign one SocketHandler
   *                to each PDA client. registry is updated whenever
   *                new SocketHandler is created.
   */
  public TCPServer(PAdaptor _parent) {
    parent = _parent;
  }

  public void run() {
    try {

      server = new ServerSocket(7000);
      System.out.println("Server Socket open");

      int i = 0;
      while(true) {
        Socket connection = server.accept();

        // create SocketHandler
        // @param this/TCPServer and Socket
        SocketHandler s = new SocketHandler(this, connection);

        /**
        // put SocketHandler with machineID jey
        String machineID = i + "machine";
        s.MACHINEID = machineID;
        registry.put(machineID, s);

        // update registry at PAdaptor
        parent.upDate(registry);
        **/

        s.start();
        i++;
      }
    }
    catch(IOException e) {
      e.printStackTrace();
    }
  }

  // public Hashtable registry = new Hashtable();
  public ServerSocket server;
  public PAdaptor parent;
}