/****************************************************************************
 * Periodically test the Jabber Server connection so we can inform user
 * when connection is lost.
 * @author David Scott
 ****************************************************************************/
package com.anabas.pdasharedlet;

class TestConnect extends Thread
{
 public IMNet imnet = null;

 private int nDelay = 60000;          // default 1 minute, delay timer
 private boolean bTest = false;       // Flag when we're testing (on/off)
 private boolean bStarted = false;    // Delayed start

 TestConnect(IMNet imnet)
 {
  this.imnet = imnet;
 }

 public void testing(boolean bTesting)
 {
  bTest = bTesting;   // Toggle testing flag on/off
 }

 // Get state of testing on/off flag: true - testing on, false - testing off
 public boolean testing()
 {
  return(bTest);
 }

 // Get state of started flag: true - started testing, false - no started
 public boolean getStarted()
 {
  return(bStarted);
 }

 // Infinitely run thread to continuously test connection
 public void run()
 {
  bStarted = true;
  try {
     while(true)
     {
      Thread.sleep(nDelay);
      if (bTest == true)
        imnet.connectionTest();
     }
  }
  catch (InterruptedException ex) {
       ex.printStackTrace();
  }
 }
}



