package com.anabas.testsharedlet;

import com.anabas.sharedlet.DefaultSharedletImpl;
import java.net.URL;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletSessionLogic;

import com.anabas.util.misc.LogManager;

/**
 * Extends DefaultSharedletImpl to trap load document function call.
 *
 * This sharedlet is a simple demonstration that has 1 button to generate a
 * random number which is then display to each client.
 *
 * It has 3 roles defined:
 * (1) Host
 *     The host can generate the random number, give/take the ability to generate a
 *     random number to another user, and promote/demote another user to moderator.
 * (2) Moderator
 *     The moderator can give/take the ability to generate a random number to
 *     another user.
 * (3) Participant
 *     No abilities unless given to it by the host.
 *
 * The sharedlet has 3 views:
 * (1) Control View (TestControlView)
 *     Where all of the controls are placed.
 * (2) Presentation View
 *     Where the random number is displayed
 * (3) Application view
 *     Currently empty to illustrate that an application view can exist.
 *
 * Although the sharedlet implements a session logic, the session logic is empty
 * serving as only a skeleton to demonstration how to include session logic.
 *
 * @author John Yin
 * @version 1.0
 */

public class TestSharedlet extends DefaultSharedletImpl {

  public TestSharedlet() {
    super(TestSharedletInfo.g_sharedletMIME);
  }

  public void loadDocument(java.net.URL documentURL) {
    LogManager.log("TestSharedlet",TestSharedletInfo.g_sharedletMIME + " load document: " + documentURL);
  }
}