/* DefaultCapabilitiesManagerOnServer - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sessionserver;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

import com.anabas.concepts.UserID;
import com.anabas.gxo.GMS_Destination;
import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_ObjectMessage;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GMS_UserDestinationSelector;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.CapabilitiesManager;
import com.anabas.sharedlet.CapabilityList;
import com.anabas.sharedlet.CapabilityListener;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.ModeratableElementInfo;
import com.anabas.sharedlet.PermissionDeniedException;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletRoleInfo;
import com.anabas.util.misc.LogManager;

public class DefaultCapabilitiesManagerOnServer
    implements CapabilitiesManager, GMS_MessageListener, CapabilityListener
{
    private boolean m_isInitialized = false;
    private static final int COMMAND_TIMEOUT = 2000;
    private Hashtable m_s2capabilities = new Hashtable();
    private Hashtable m_visibleModeratables = new Hashtable();
    private Hashtable m_enabledModTable = new Hashtable();
    private Hashtable m_appRoleTable = new Hashtable();
    private SharedletManager m_sharedletManager;
    private String m_applicationRole;
    private short m_mode = 0;
    private Vector m_listeners = new Vector();
    private GMS_StreamPublisher m_publisher;
    private GMS_StreamSubscriber m_subscriber;
    private GMS_Stream m_stream;
    private UserID m_myUserID;
    private static String s_selfMIMEType = "application/x-sharedletservice-capabilitiesmanager";
    
    public String getRole(String sharedletMIME) {
	Hashtable applicationRole = (Hashtable) m_appRoleTable.get(m_applicationRole);
	String sharedletRole = (String) applicationRole.get(sharedletMIME);
	if (sharedletRole == null)
	    LogManager.warn("CapabilitiesManager", String.valueOf(new StringBuffer("Found sharedlet ").append(sharedletMIME).append(" has no role.")));
	return sharedletRole;
    }
    
    public void addCapabilityListener(CapabilityListener l) {
	m_listeners.addElement(l);
    }
    
    public void removeCapabilityListener(CapabilityListener l) {
	m_listeners.removeElement(l);
    }
    
    public boolean isCapable(String sharedletMIME, String capability) {
	return false;
    }
    
    public boolean isRemoteCapable(String sharedletMIME, String capability, UserID user)
    throws PermissionDeniedException {
	if (m_mode == 0)
	    throw new PermissionDeniedException();
	try {
	    GMS_TextMessage response = remoteCommand("query-cap", sharedletMIME, capability, user);
	    if (response == null) {
		LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to get capability '").append(capability).append("' status for remote user '").append(user.getID()).append("'.  defaulting to not allowed.")));
		boolean bool_5_0_ = false;
		return bool_5_0_;
	    }
	    boolean bool_5_1_ = response.getText().equals("t");
	    return bool_5_1_;
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to get remote capability setting for user: ").append(user).append(" sharedlet: ").append(sharedletMIME).append(" cap: ").append(capability)), e);
	    boolean bool_5_2_ = false;
	    return bool_5_2_;
	}
    }
    
    public boolean isRemoteModeratable(String sharedletMIME, String moderatableElement, UserID user)
    throws PermissionDeniedException {
	if (m_mode == 0)
	    throw new PermissionDeniedException();
	try {
	    GMS_TextMessage response = remoteCommand("query-mod", sharedletMIME, moderatableElement, user);
	    if (response == null) {
		LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to get modertable '").append(moderatableElement).append("' status for remote user '").append(user.getID()).append("'.  defaulting to not allowed.")));
		boolean bool_5_3_ = false;
		return bool_5_3_;
	    }
	    boolean bool_5_4_ = response.getText().equals("t");
	    return bool_5_4_;
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to get remote modertable setting for user: ").append(user).append(" sharedlet: ").append(sharedletMIME).append(" mod: ").append(moderatableElement)), e);
	    boolean bool_5_5_ = false;
	    return bool_5_5_;
	}
    }
    
    public void setRemoteMode(short mode, UserID user)
    throws PermissionDeniedException {
	if (m_mode != 2)
	    throw new PermissionDeniedException();
	String modeStr = "";
	switch (mode) {
	case 2:
	    modeStr = "master";
	    break;
	case 0:
	    modeStr = "slave";
	    break;
	case 1:
	    modeStr = "moderator";
	    break;
	}
	try {
	    GMS_Message response = remoteCommand("set-mode", "", modeStr, user);
	    if (response == null)
		LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to set remote capability manager of remote user '").append(user.getID()).append("' to mode '").append(modeStr).append("'.")));
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to set remote capability manager of remote user '").append(user.getID()).append("' to mode '").append(modeStr).append("'.")));
	}
    }
    
    public void enableRemoteModeratable(String sharedletMIME, String moderatableElement, UserID user)
    throws PermissionDeniedException {
	/* empty */
    }
    
    public String getCurrentApplicationRole() {
	return m_applicationRole;
    }
    
    public Vector getApplicationRoles() {
	Vector v = new Vector();
	Enumeration enum = m_appRoleTable.keys();
	while (enum.hasMoreElements())
	    v.addElement(enum.nextElement());
	return v;
    }
    
    public void setRemoteApplicationRole(UserID user, String appRole)
    throws PermissionDeniedException {
	if (m_mode != 2)
	    throw new PermissionDeniedException("You must be in master mode set application role");
	try {
	    GMS_Message response = remoteCommand("setapprole", "", appRole.toLowerCase(), user);
	    if (response == null)
		LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to set remote application role '").append(appRole).append("' status for remote user '").append(user.getID()).append("'.")));
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to set remote application role: ").append(user).append(" application role: ").append(appRole)), e);
	}
    }
    
    public String getRemoteApplicationRole(UserID user)
    throws PermissionDeniedException {
	if (m_mode == 0)
	    throw new PermissionDeniedException("Can not get remote appliaction role in slave mode");
	try {
	    GMS_TextMessage response = remoteCommand("query-role", "", "", user);
	    if (response == null) {
		LogManager.err("CapabilitiesManager", "Unable to get remote app role for remote user '".concat(String.valueOf(user)));
		String string_3_6_ = "";
		return string_3_6_;
	    }
	    String string_3_7_ = response.getText();
	    return string_3_7_;
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", "Unable to get remote application role for user: ".concat(String.valueOf(user)), e);
	    String string_3_8_ = "";
	    return string_3_8_;
	}
    }
    
    public void disableRemoteModeratable(String sharedletMIME, String moderatableElement, UserID user)
    throws PermissionDeniedException {
	/* empty */
    }
    
    public void init() {
	Context ctx = ContextManager.getInitialContext();
	try {
	    m_sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	    SessionManager manager = (SessionManager) ctx.lookup("services/SessionManager");
	    m_myUserID = manager.getMyUser().getUserID();
	} catch (NamingException e) {
	    LogManager.err("CapabilitiesManager", "Unable to locate a needed service", e);
	}
	String currentRole = null;
	try {
	    m_applicationRole = (String) ctx.lookup("session_param/roles.current");
	    m_applicationRole = m_applicationRole.toLowerCase();
	    LogManager.log(7, "CapabilitiesManager", "Found current application role: ".concat(m_applicationRole));
	} catch (NamingException e) {
	    LogManager.err("CapabilitiesManager", "Unable to find current role.  Missing roles.current parameter");
	    return;
	}
	com.anabas.naming.NamingEnumeration roleList = null;
	try {
	    roleList = ctx.list("session_param/roles.possible");
	    while (roleList.hasMoreElements()) {
		String roleName = (String) roleList.nextElement();
		String roleValue = (String) ctx.lookup("session_param/roles.possible/".concat(roleName));
		Hashtable sharedletRoles = parseRoleParameter(roleValue);
		m_appRoleTable.put(roleName, sharedletRoles);
	    }
	} catch (NamingException e) {
	    LogManager.err("CapabilitiesManager", "Unable to build application roles", e);
	}
	Hashtable s2role = (Hashtable) m_appRoleTable.get(m_applicationRole);
	if (s2role == null)
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Current role definition of ").append(currentRole).append(" not defined.")));
	else {
	    String roleName = (String) s2role.get(s_selfMIMEType);
	    if (roleName == null) {
		LogManager.log("CapabilitiesManager", "No role defined for self.  Assuming slave");
		m_mode = (short) 0;
	    } else {
		String lcRoleName = roleName.toLowerCase();
		if (lcRoleName.equals("master"))
		    m_mode = (short) 2;
		else if (lcRoleName.equals("moderator"))
		    m_mode = (short) 1;
		else if (lcRoleName.equals("slave"))
		    m_mode = (short) 0;
	    }
	    Vector v = m_sharedletManager.getSharedletInfos();
	    Enumeration enum = v.elements();
	    while (enum.hasMoreElements()) {
		SharedletInfo info = (SharedletInfo) enum.nextElement();
		roleName = (String) s2role.get(info.getMIMEType());
		addSharedlet(info, roleName);
	    }
	    try {
		CommunicationService com = (CommunicationService) ctx.lookup("services/CommunicationService");
		m_stream = com.findStream(s_selfMIMEType);
		if (m_stream == null)
		    m_stream = com.createStream(s_selfMIMEType);
		m_publisher = m_stream.createPublisher();
		m_subscriber = m_stream.createSubscriber();
		m_subscriber.setMessageListener(this);
	    } catch (NamingException e) {
		LogManager.err("CapabilitiesManager", "Unable to locate communication service", e);
	    } catch (GXO_Exception e) {
		LogManager.err("CapabilitiesManager", "Unable to initialize stream", e);
	    }
	    m_isInitialized = true;
	}
    }
    
    public void onRequest(GMS_Message m, GMS_MessageReplyer replyer) {
	String command = "<unknown>";
	try {
	    GMS_TextMessage msg = (GMS_TextMessage) m;
	    String sharedletMIME = (String) msg.getProperty("sharedlet");
	    String element = (String) msg.getProperty("element");
	    String requestor = (String) msg.getProperty("requestor");
	    command = msg.getText();
	    LogManager.log("CapabilitiesManager", String.valueOf(new StringBuffer("Request '").append(command).append("' for sharedlet '").append(sharedletMIME).append("', element '").append(element).append("'")));
	    msg = (GMS_TextMessage) m_publisher.createMessage((short) 0, (short) 1);
	    if (command.equals("set-mode")) {
		if (element.equals("master"))
		    m_mode = (short) 2;
		else if (element.equals("slave"))
		    m_mode = (short) 0;
		else if (element.equals("moderator"))
		    m_mode = (short) 1;
		msg.setText("t");
	    } else if (command.equals("setapprole")) {
		setApplicationRole(element, requestor);
		msg.setText("t");
	    } else if (command.equals("query-cap")) {
		if (isCapable(sharedletMIME, element))
		    msg.setText("t");
		else
		    msg.setText("f");
	    } else if (command.equals("query-mod")) {
		if (isLocalModeratable(sharedletMIME, element))
		    msg.setText("t");
		else
		    msg.setText("f");
	    } else if (command.equals("query-role"))
		msg.setText(m_applicationRole);
	    else if (command.equals("enable")) {
		enableModeratable(sharedletMIME, element);
		msg.setText("t");
	    } else if (command.equals("disable")) {
		disableModeratable(sharedletMIME, element);
		msg.setText("t");
	    }
	    replyer.reply(m, msg);
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilitiesManager", String.valueOf(new StringBuffer("Error while handling request '").append(command).append("'")), e);
	}
    }
    
    public void onMessage(GMS_Message m) {
	try {
	    GMS_ObjectMessage msg = (GMS_ObjectMessage) m;
	    String sharedletMIME = (String) msg.getProperty("s");
	    String capability = (String) msg.getProperty("c");
	    boolean enabled = ((String) msg.getProperty("e")).equals("1");
	    UserID userID = (UserID) msg.getObject();
	    LogManager.log("CapabilitiesManager", String.valueOf(new StringBuffer("Got remote cap changed: sharedlet=").append(sharedletMIME).append(", capability=").append(capability).append(",enabled=").append(enabled).append(",userID=").append(userID)));
	    fireRemoteCapabilityChanged(sharedletMIME, capability, enabled, userID);
	} catch (GXO_Exception e) {
	    LogManager.err("CapabilityManager", "Error in receiving remote cap changed", e);
	}
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void shutdown() {
	/* empty */
    }
    
    public void resume() {
	/* empty */
    }
    
    public String getSharedletMIME() {
	return s_selfMIMEType;
    }
    
    public void remoteCapabilityChanged(String capability, boolean enabled, UserID userid) {
	/* empty */
    }
    
    public void capabilityChanged(String capability, boolean enabled) {
	/* empty */
    }
    
    public void roleChanged(String roleName) {
	roleName = roleName.toLowerCase();
	if (roleName.equals("master"))
	    m_mode = (short) 2;
	else if (roleName.equals("moderator"))
	    m_mode = (short) 1;
	else if (roleName.equals("slave"))
	    m_mode = (short) 0;
	else
	    LogManager.err("CapabilityManager", "Unrecognized capability mode: ".concat(roleName));
    }
    
    public boolean isLocalModeratable(String sharedletMIME, String moderatable) {
	Vector v = (Vector) m_enabledModTable.get(sharedletMIME);
	if (v == null)
	    return false;
	return v.contains(moderatable);
    }
    
    protected void sendRemoteCapabilityChanged(String sharedletMIME, String capability, boolean enabled) {
	try {
	    GMS_ObjectMessage message = (GMS_ObjectMessage) m_publisher.createMessage((short) 0, (short) 3);
	    message.setProperty("s", sharedletMIME);
	    message.setProperty("c", capability);
	    message.setProperty("e", enabled ? "1" : "0");
	    message.setObject(m_myUserID);
	    LogManager.log(10, "CapabilitiesManager", String.valueOf(new StringBuffer("Sent broadcast 'remote cap change',sharedlet=").append(sharedletMIME).append(",cap=").append(capability).append(",enable=").append(enabled)));
	    m_publisher.broadcast(message);
	} catch (GXO_Exception e) {
	    LogManager.err(10, "CapabilitiesManager", String.valueOf(new StringBuffer("Unable to send 'remote cap change',sharedlet=").append(sharedletMIME).append(",cap=").append(capability).append(",enable=").append(enabled)), e);
	}
    }
    
    protected void fireRemoteCapabilityChanged(String sharedletMIME, String capability, boolean enabled, UserID userid) {
	Enumeration enum = m_listeners.elements();
	while (enum.hasMoreElements()) {
	    CapabilityListener l = (CapabilityListener) enum.nextElement();
	    if (l.getSharedletMIME().equals(sharedletMIME))
		l.remoteCapabilityChanged(capability, enabled, userid);
	}
    }
    
    protected void fireCapabilityChange(String sharedletMIME, String capability, boolean enabled) {
	Enumeration enum = m_listeners.elements();
	while (enum.hasMoreElements()) {
	    CapabilityListener l = (CapabilityListener) enum.nextElement();
	    if (l.getSharedletMIME().equals(sharedletMIME)) {
		l.capabilityChanged(capability, enabled);
		sendRemoteCapabilityChanged(sharedletMIME, capability, enabled);
	    }
	}
    }
    
    protected void fireApplicationRoleChange(String filter) {
	Enumeration enum = m_listeners.elements();
	Hashtable currentRoles = (Hashtable) m_appRoleTable.get(m_applicationRole);
	while (enum.hasMoreElements()) {
	    CapabilityListener l = (CapabilityListener) enum.nextElement();
	    if (filter.equals("*") || l.getSharedletMIME().indexOf(filter) >= 0) {
		String newRole = (String) currentRoles.get(l.getSharedletMIME());
		if (newRole != null)
		    l.roleChanged(newRole);
	    }
	}
    }
    
    private void setApplicationRole(String newRole, String requestor) {
	newRole = newRole.toLowerCase();
	if (newRole.equals(m_applicationRole))
	    LogManager.log(7, "CapabilityManager", String.valueOf(new StringBuffer("Already in ").append(m_applicationRole).append(".  Ignoring request")));
	else {
	    Hashtable sharedletRoles = (Hashtable) m_appRoleTable.get(newRole);
	    m_enabledModTable.clear();
	    m_visibleModeratables.clear();
	    m_applicationRole = newRole;
	}
    }
    
    private GMS_TextMessage remoteCommand(String command, String sharedletMIME, String element, UserID user)
    throws GXO_Exception {
	GMS_TextMessage message = (GMS_TextMessage) m_publisher.createMessage((short) 0, (short) 1);
	message.setProperty("sharedlet", sharedletMIME);
	message.setProperty("element", element);
	message.setProperty("requestor", m_myUserID.toString());
	message.setText(command);
	LogManager.log(10, "CapabilitiesManager", String.valueOf(new StringBuffer("Sent command '").append(command).append("',sharedlet=").append(sharedletMIME).append(",param=").append(element)));
	GMS_UserDestinationSelector selector = (GMS_UserDestinationSelector) m_publisher.createDestinationSelector("GMS_UserDestinationSelector");
	selector.setUserID(user);
	GMS_Destination dst = m_stream.findDestination(selector);
	message = (GMS_TextMessage) m_publisher.request(message, dst, 2000L);
	if (message != null)
	    LogManager.log(10, "CapabilitiesManager", String.valueOf(new StringBuffer("Received reply '").append(message.getText()).append("'")));
	else
	    LogManager.err("CapabilitiesManager", "No reply.");
	return message;
    }
    
    private void disableModeratable(String sharedletMIME, String moderatable) {
	Vector enabledModeratables = (Vector) m_enabledModTable.get(sharedletMIME);
	int index = enabledModeratables.indexOf(moderatable);
	if (index >= 0) {
	    SharedletInfo sinfo = m_sharedletManager.getInfo(sharedletMIME);
	    Vector moderatableInfos = sinfo.getModeratableInfos();
	    Enumeration enum = moderatableInfos.elements();
	    while (enum.hasMoreElements()) {
		ModeratableElementInfo info = (ModeratableElementInfo) enum.nextElement();
		if (info.getName().equals(moderatable)) {
		    Vector capabilities = info.getCapabilities();
		    Enumeration enum2 = capabilities.elements();
		    while (enum2.hasMoreElements())
			disableCapability(sharedletMIME, (String) enum2.nextElement(), true);
		}
	    }
	    enabledModeratables.removeElementAt(index);
	}
    }
    
    private void enableModeratable(String sharedletMIME, String moderatable) {
	Vector enabledModeratables = (Vector) m_enabledModTable.get(sharedletMIME);
	int index = enabledModeratables.indexOf(moderatable);
	if (index < 0) {
	    SharedletInfo sinfo = m_sharedletManager.getInfo(sharedletMIME);
	    Vector moderatableInfos = sinfo.getModeratableInfos();
	    Enumeration enum = moderatableInfos.elements();
	    while (enum.hasMoreElements()) {
		ModeratableElementInfo info = (ModeratableElementInfo) enum.nextElement();
		if (info.getName().equals(moderatable)) {
		    Vector capabilities = info.getCapabilities();
		    Enumeration enum2 = capabilities.elements();
		    while (enum2.hasMoreElements())
			enableCapability(sharedletMIME, (String) enum2.nextElement(), true);
		}
	    }
	    enabledModeratables.addElement(moderatable);
	}
    }
    
    private void enableCapability(String sharedletMIME, String capability, boolean internalCall) {
	/* empty */
    }
    
    private void disableCapability(String sharedletMIME, String capability, boolean internalCall) {
	/* empty */
    }
    
    public void enableCapability(String sharedletMIME, String capability)
    throws PermissionDeniedException {
	if (m_mode != 2)
	    throw new PermissionDeniedException("You must be in master mode to enable capability");
	enableCapability(sharedletMIME, capability, false);
    }
    
    public void disableCapability(String sharedletMIME, String capability)
    throws PermissionDeniedException {
	if (m_mode != 2)
	    throw new PermissionDeniedException("You must be in master mode to disable capability");
	disableCapability(sharedletMIME, capability, false);
    }
    
    private Hashtable parseRoleParameter(String roles) {
	if (roles == null) {
	    LogManager.log("CapabilitiesManager", "No roles definied using first defined role");
	    return null;
	}
	Hashtable h = new Hashtable();
	StringTokenizer st = new StringTokenizer(roles, ",");
	while (st.hasMoreTokens()) {
	    String sharedletRole = st.nextToken();
	    int commaIndex = sharedletRole.indexOf(':');
	    if (commaIndex < 0)
		LogManager.err("CapabilitiesManager", "Roles parameter syntax error ".concat(roles));
	    String sharedletMIME = sharedletRole.substring(0, commaIndex);
	    String roleName = sharedletRole.substring(commaIndex + 1, sharedletRole.length());
	    h.put(sharedletMIME, roleName);
	}
	return h;
    }
    
    private void updateModerates(String mimeType) {
	Vector v = (Vector) m_visibleModeratables.get(mimeType);
	if (v != null) {
	    Vector enabledModeratables = (Vector) m_enabledModTable.get(mimeType);
	    SharedletInfo sinfo = m_sharedletManager.getInfo(mimeType);
	    Vector moderatableInfos = sinfo.getModeratableInfos();
	    Enumeration enum = moderatableInfos.elements();
	    while (enum.hasMoreElements()) {
		ModeratableElementInfo meinfo = (ModeratableElementInfo) enum.nextElement();
		if (v.contains(meinfo.getName())) {
		    Vector cl = meinfo.getCapabilities();
		    Enumeration clnum = cl.elements();
		    boolean enabled = true;
		while_0_:
		    do {
			String capability;
			do {
			    if (!clnum.hasMoreElements())
				break while_0_;
			    capability = (String) clnum.nextElement();
			} while (isCapable(mimeType, capability));
			if (enabledModeratables.contains(meinfo.getName()))
			    enabledModeratables.removeElement(meinfo.getName());
			enabled = false;
		    } while (false);
		    if (enabled && !enabledModeratables.contains(meinfo.getName()))
			enabledModeratables.addElement(meinfo.getName());
		}
	    }
	}
    }
    
    private void addSharedlet(SharedletInfo info, String roleName) {
	String mimeType = info.getMIMEType();
	Vector enabledModeratables = new Vector();
	m_enabledModTable.put(info.getMIMEType(), enabledModeratables);
	Vector visibleModeratables = new Vector();
	m_visibleModeratables.put(info.getMIMEType(), visibleModeratables);
	Vector v = info.getRoleInfos();
	Enumeration enum = v.elements();
	boolean isFirstRole = true;
	SharedletRoleInfo firstRole = null;
	SharedletRoleInfo matchedRole = null;
    while_1_:
	do {
	    SharedletRoleInfo roleInfo;
	    do {
		if (!enum.hasMoreElements())
		    break while_1_;
		roleInfo = (SharedletRoleInfo) enum.nextElement();
		if (isFirstRole) {
		    firstRole = roleInfo;
		    isFirstRole = false;
		}
	    } while (!roleInfo.getID().equals(roleName));
	    CapabilityList list = new CapabilityList(roleInfo.getRoleCapabilities());
	    matchedRole = roleInfo;
	    LogManager.log("CapabilitiesManager", String.valueOf(new StringBuffer("Found matching role ").append(roleName).append(" for sharedlet ").append(mimeType)));
	} while (false);
	if (matchedRole == null && firstRole != null) {
	    LogManager.warn("CapabilitiesManager", String.valueOf(new StringBuffer("Unable to find a matching role '").append(roleName).append("' for sharedlet '").append(mimeType).append("'...using first role: ").append(firstRole.getID())));
	    CapabilityList list = new CapabilityList(firstRole.getRoleCapabilities());
	    matchedRole = firstRole;
	} else if (matchedRole == null && firstRole == null) {
	    LogManager.warn("CapabilitiesManager", "No roles defined for sharedlet '".concat(mimeType));
	    return;
	}
	Vector moderatableList = new Vector();
	enum = matchedRole.getRoleModeratableElements().elements();
	while (enum.hasMoreElements())
	    moderatableList.addElement(enum.nextElement());
	v = info.getModeratableInfos();
	enum = v.elements();
	while (enum.hasMoreElements()) {
	    ModeratableElementInfo meinfo = (ModeratableElementInfo) enum.nextElement();
	    if (moderatableList.contains(meinfo.getName())) {
		visibleModeratables.addElement(meinfo.getName());
		moderatableList.removeElement(meinfo.getName());
	    }
	    boolean enabled = true;
	    Vector cap = meinfo.getCapabilities();
	    Enumeration enum2 = cap.elements();
	while_2_:
	    do {
		do {
		    if (!enum2.hasMoreElements())
			break while_2_;
		} while (isCapable(mimeType, (String) enum2.nextElement()));
		enabled = false;
	    } while (false);
	    if (enabled && !enabledModeratables.contains(meinfo.getName()))
		enabledModeratables.addElement(meinfo.getName());
	}
	if (moderatableList.size() > 0) {
	    LogManager.err("CapabilitiesManager", "Invalid moderatable element definitions for ".concat(info.getMIMEType()));
	    enum = moderatableList.elements();
	    while (enum.hasMoreElements())
		LogManager.err("CapabilitiesManager", "  - ".concat((String) enum.nextElement()));
	}
    }
    
    public Vector getModeratableElements(String sharedletMIME) {
	Vector v = (Vector) m_visibleModeratables.get(sharedletMIME);
	if (v == null) {
	    LogManager.warn("CapabilitiesManager", String.valueOf(new StringBuffer("Requesting modertable elements for ").append(sharedletMIME).append(" but it doesn't not exist")));
	    return new Vector();
	}
	return v;
    }
}
