/* DefaultSessionManagerOnServer - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sessionserver;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Vector;

import com.anabas.concepts.SessionID;
import com.anabas.concepts.User;
import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_ObjectMessage;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.SessionEvent;
import com.anabas.sharedlet.SessionListener;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.framework.SessionIDImpl;
import com.anabas.sonicmq.UserIDImpl;
import com.anabas.sonicmq.UserImpl;
import com.anabas.util.misc.LogManager;

public class DefaultSessionManagerOnServer
    implements SessionManager
{
    private static final String s_selfMIMEType = "application/x-sharedletservice-sessionmanager";
    private GMS_StreamPublisher m_publisherPublic;
    private GMS_StreamPublisher m_publisherPrivate;
    private GMS_StreamSubscriber m_subscriberPublic;
    private GMS_StreamSubscriber m_subscriberPrivate;
    private GMS_Stream m_streamPublic;
    private GMS_Stream m_streamPrivate;
    private Thread m_requestor;
    private boolean m_stopRequestor = false;
    private Hashtable m_sessionParams = new Hashtable();
    private Hashtable m_roles = new Hashtable();
    private Hashtable m_clientNeededConfiguration = new Hashtable();
    private Object m_lock = new String();
    private Hashtable m_invitee = new Hashtable();
    private Vector m_participants = new Vector();
    private Vector m_reportedParticipants = new Vector();
    private Vector m_leftUser = new Vector();
    private Vector m_listeners = new Vector();
    private SessionID m_sessionID;
    private User m_myUser = new UserImpl("<server>", "<server>", new UserIDImpl("<server>"));
    private String m_meetingID;
    private Context m_ctx;
    
    class PublicMessageListener
	implements GMS_MessageListener
    {
	public void onMessage(GMS_Message message) {
	    /* empty */
	}
	
	public void onRequest(GMS_Message message, GMS_MessageReplyer replyer) {
	    /* empty */
	}
    }
    
    class PrivateMessageListener
	implements GMS_MessageListener
    {
	public void onMessage(GMS_Message message) {
	    GMS_TextMessage txtMsg = (GMS_TextMessage) message;
	    try {
		String type = (String) txtMsg.getProperty("t");
		String userID = txtMsg.getText();
		User u = (User) m_invitee.get(userID);
		if (u == null) {
		    LogManager.warn("SessionManager", String.valueOf(new StringBuffer("Did not find user ").append(userID).append(" in invitee list for message")));
		    u = DefaultSessionManagerOnServer.this.getUserFromJSP(userID);
		}
		if (type.equals("join")) {
		    synchronized (m_lock) {
			addUser(u);
		    }
		    LogManager.log("SessionManager", "A user has joined ".concat(String.valueOf(u)));
		    DefaultSessionManagerOnServer.this.sendUserMessage(u, "join");
		} else if (type.equals("leave")) {
		    LogManager.log("SessionManager", "A user has left: ".concat(userID));
		    synchronized (m_lock) {
			removeUser(u);
			m_leftUser.addElement(u);
		    }
		    DefaultSessionManagerOnServer.this.sendUserMessage(u, "leave");
		} else if (type.equals("yes")) {
		    synchronized (m_lock) {
			if (m_reportedParticipants.contains(u))
			    LogManager.warn("SessionManager", String.valueOf(new StringBuffer("A user ").append(u).append(" reported in more than once")));
			else
			    m_reportedParticipants.addElement(u);
		    }
		} else
		    LogManager.warn("SessionManager", "Received unrecognized message '".concat(type));
	    } catch (GXO_Exception e) {
		LogManager.err("SessionManager", "Unable to extract join message user object", e);
	    }
	}
	
	public void onRequest(GMS_Message message, GMS_MessageReplyer replyer) {
	    try {
		String userID = null;
		User user = null;
		if (message instanceof GMS_TextMessage) {
		    GMS_TextMessage txtMsg = (GMS_TextMessage) message;
		    userID = txtMsg.getText();
		}
		LogManager.log("SessionManager", String.valueOf(new StringBuffer("[").append(userID).append("] Received request for config")));
		if (userID != null) {
		    user = (User) m_invitee.get(userID);
		    if (user == null) {
			LogManager.log("SessionManager", String.valueOf(new StringBuffer("[").append(userID).append("] Did not find user in invitation list...look in JSP")));
			user = DefaultSessionManagerOnServer.this.getUserFromJSP(userID);
			m_invitee.put(userID, user);
		    }
		    LogManager.log("SessionManager", String.valueOf(new StringBuffer("[").append(user).append("] Got user info.")));
		    m_clientNeededConfiguration.put(userID, user);
		    m_clientNeededConfiguration.put("?participants", m_participants);
		    GMS_ObjectMessage response = (GMS_ObjectMessage) m_publisherPublic.createMessage((short) 0, (short) 3);
		    response.setObject(m_clientNeededConfiguration);
		    replyer.reply(message, response);
		    m_clientNeededConfiguration.remove(userID);
		}
	    } catch (GXO_Exception e) {
		LogManager.err("SessionManager", "Unable to reply to state update request", e);
	    }
	}
    }
    
    public void setSessionParameter(String paramName, Object obj) {
	m_sessionParams.put(paramName, obj);
    }
    
    public void setSessionRole(String sharedletAppMIME, String roleName) {
	m_roles.put(sharedletAppMIME, roleName);
    }
    
    public void addSessionListener(SessionListener l) {
	m_listeners.addElement(l);
    }
    
    public void removeSessionListener(SessionListener l) {
	m_listeners.removeElement(l);
    }
    
    protected void fireUserJoinedEvent(User u) {
	Enumeration enum = m_listeners.elements();
	while (enum.hasMoreElements()) {
	    SessionListener l = (SessionListener) enum.nextElement();
	    try {
		l.userJoined(new SessionEvent(u));
	    } catch (Exception e) {
		LogManager.err("SessionManager", "User join caused exception in listener", e);
	    }
	}
    }
    
    protected void fireUserLeftEvent(User u) {
	Enumeration enum = m_listeners.elements();
	while (enum.hasMoreElements()) {
	    SessionListener l = (SessionListener) enum.nextElement();
	    try {
		l.userLeft(new SessionEvent(u));
	    } catch (Exception e) {
		LogManager.err("SessionManager", "User left caused exception in listener", e);
	    }
	}
    }
    
    public User getMyUser() {
	return m_myUser;
    }
    
    public Object getSessionParameter(String paraName) {
	return m_sessionParams;
    }
    
    public Vector getParticipants() {
	return m_participants;
    }
    
    public String getSessionRoleID(String MIMEType) {
	return (String) m_roles.get(MIMEType);
    }
    
    public SessionID getSessionID() {
	return m_sessionID;
    }
    
    public void init() {
	LogManager.log("SessionManager", "Initializing SessionManager");
	m_ctx = ContextManager.getInitialContext();
	try {
	    m_meetingID = (String) m_ctx.lookup("session_param/meetingID");
	    m_sessionID = new SessionIDImpl(m_meetingID);
	} catch (NamingException e) {
	    LogManager.err("SessionManager", "Unable to get my user object or meeting id", e);
	}
	try {
	    CommunicationService com = (CommunicationService) m_ctx.lookup("services/CommunicationService");
	    m_streamPublic = com.findStream("application/x-sharedletservice-sessionmanager/public");
	    m_streamPrivate = com.findStream("application/x-sharedletservice-sessionmanager/private");
	    if (m_streamPublic == null)
		m_streamPublic = com.createStream("application/x-sharedletservice-sessionmanager/public");
	    if (m_streamPrivate == null)
		m_streamPrivate = com.createStream("application/x-sharedletservice-sessionmanager/private");
	    m_publisherPublic = m_streamPublic.createPublisher();
	    m_publisherPrivate = m_streamPrivate.createPublisher();
	    m_subscriberPublic = m_streamPublic.createSubscriber();
	    m_subscriberPrivate = m_streamPrivate.createSubscriber();
	    m_subscriberPublic.setMessageListener(new PublicMessageListener());
	    m_subscriberPrivate.setMessageListener(new PrivateMessageListener());
	} catch (NamingException e) {
	    LogManager.err("SessionManager", "Unable to locate communication service", e);
	} catch (GXO_Exception e) {
	    LogManager.err("SessionManager", "Unable to initialize stream", e);
	}
	getInviteeList();
	m_requestor = new Thread() {
	    public void run() {
		while (!m_stopRequestor) {
		    DefaultSessionManagerOnServer.this.sendCheckMessage();
		    try {
			Thread.sleep(15000L);
		    } catch (Exception exception_1_2_) {
			/* empty */
		    }
		    DefaultSessionManagerOnServer.this.updateUserStatus();
		}
	    }
	};
	m_requestor.start();
	prepareClientNeededConfiguration();
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void shutdown() {
	m_stopRequestor = true;
    }
    
    public void resume() {
	/* empty */
    }
    
    protected synchronized void removeUser(User u) {
	Enumeration enum = m_participants.elements();
	User leftUser = null;
	while (enum.hasMoreElements()) {
	    User user = (User) enum.nextElement();
	    if (user.getUserID().equals(u.getUserID())) {
		leftUser = user;
		m_participants.removeElement(leftUser);
		LogManager.log("SessionManager", String.valueOf(new StringBuffer("User ").append(leftUser.getUserID()).append(" has left.")));
	    }
	}
	if (leftUser == null)
	    LogManager.err("SessionManager", String.valueOf(new StringBuffer("Received user left ").append(u.getUserID()).append(" and could not find in internal table.  Firing leave anyways")));
	fireUserLeftEvent(u);
    }
    
    protected synchronized void addUser(User u) {
	Enumeration enum = m_participants.elements();
	boolean duplicates = false;
	while (enum.hasMoreElements()) {
	    User user = (User) enum.nextElement();
	    if (user.getUserID().equals(u.getUserID())) {
		duplicates = true;
		m_participants.removeElement(user);
		LogManager.err("SessionManager", String.valueOf(new StringBuffer("User ").append(user).append(" is duplicate.  Using new user info.")));
	    }
	}
	LogManager.log(8, "SessionManager", "Added user ".concat(String.valueOf(u)));
	m_participants.addElement(u);
	if (!duplicates)
	    fireUserJoinedEvent(u);
    }
    
    private void sendUserMessage(User u, String type) {
	try {
	    synchronized (m_publisherPublic) {
		GMS_ObjectMessage msg = (GMS_ObjectMessage) m_publisherPublic.createMessage((short) 0, (short) 3);
		msg.setProperty("t", type);
		msg.setObject(u);
		m_publisherPublic.broadcast(msg);
	    }
	} catch (GXO_Exception e) {
	    LogManager.err("SessionManager", String.valueOf(new StringBuffer("Unable to send '").append(type).append("' message")), e);
	}
    }
    
    private void keepPollingClients() {
	/* empty */
    }
    
    private void updateUserStatus() {
	synchronized (m_lock) {
	    LogManager.log("SessionManager", String.valueOf(m_reportedParticipants.size()).concat(" users reported in."));
	    LogManager.log(9, "SessionManager", "Following users reported in: ");
	    if (m_reportedParticipants.size() > 0) {
		Enumeration en = m_reportedParticipants.elements();
		while (en.hasMoreElements())
		    LogManager.log(9, "SessionManager", ((User) en.nextElement()).toString());
	    }
	    Enumeration enum = m_participants.elements();
	    while (enum.hasMoreElements()) {
		User user = (User) enum.nextElement();
		if (!m_reportedParticipants.removeElement(user)) {
		    removeUser(user);
		    sendUserMessage(user, "leave");
		    LogManager.log("SessionManager", String.valueOf(new StringBuffer("User ").append(user.getUserID()).append(" not alive")));
		}
	    }
	    Enumeration enum2 = m_reportedParticipants.elements();
	    while (enum2.hasMoreElements()) {
		User user = (User) enum2.nextElement();
		if (!m_leftUser.contains(user)) {
		    addUser(user);
		    sendUserMessage(user, "join");
		    LogManager.log("SessionManager", String.valueOf(new StringBuffer("User ").append(user.getUserID()).append(" is alive again")));
		} else
		    LogManager.warn("SessionManager", String.valueOf(new StringBuffer("Get user ").append(user.getUserID()).append(" reporting after").append("he/she leaves, ignore ...")));
	    }
	    m_leftUser.removeAllElements();
	    m_reportedParticipants.removeAllElements();
	}
    }
    
    private void sendCheckMessage() {
	try {
	    synchronized (m_publisherPublic) {
		GMS_TextMessage msg = (GMS_TextMessage) m_publisherPublic.createMessage((short) 0, (short) 1);
		String time = Long.toString(System.currentTimeMillis());
		msg.setProperty("time", time);
		msg.setText("alive?");
		LogManager.log(9, "SessionManager", "Sending keep alive @ ".concat(time));
		m_publisherPublic.broadcast(msg);
	    }
	} catch (GXO_Exception e) {
	    LogManager.err("SessionManager", "Unable to send checking alive message", e);
	}
    }
    
    private void getInviteeList() {
	try {
	    com.anabas.naming.NamingEnumeration invitee = m_ctx.list("session_param/invitee");
	    while (invitee.hasMoreElements()) {
		String id = (String) invitee.nextElement();
		User user = (User) m_ctx.lookup("session_param/invitee/".concat(id));
		LogManager.log("SessionManager", "\tInvittee: ".concat(String.valueOf(user)));
		m_invitee.put(id, user);
	    }
	} catch (NamingException e) {
	    LogManager.err("SessionManager", "Unable to get invitee list", e);
	}
    }
    
    private void prepareClientNeededConfiguration() {
	try {
	    Enumeration params = m_ctx.list("session_param");
	    while (params.hasMoreElements()) {
		String paramName = (String) params.nextElement();
		if (paramName.startsWith("roles.possible")) {
		    Enumeration roles = m_ctx.list("session_param/roles.possible");
		    while (roles.hasMoreElements()) {
			String roleName = "roles.possible/".concat(String.valueOf(roles.nextElement()));
			String roleValue = (String) m_ctx.lookup("session_param/".concat(roleName));
			m_clientNeededConfiguration.put(roleName, roleValue);
		    }
		} else {
		    String paramValue = null;
		    if (!paramName.startsWith("invitee") && !paramName.startsWith("host") && !paramName.startsWith("meetingID") && !paramName.startsWith("user.ID")) {
			try {
			    paramValue = (String) m_ctx.lookup("session_param/".concat(paramName));
			    m_clientNeededConfiguration.put(paramName, paramValue);
			} catch (ClassCastException classcastexception_4_3_) {
			    /* empty */
			}
		    }
		}
	    }
	} catch (NamingException e) {
	    LogManager.err("SessionManager", "Unable to prepare client needed configurateion", e);
	}
    }
    
    private User getUserFromJSP(String userID) {
	User defaultUser = new UserImpl(userID, userID, new UserIDImpl(userID));
	defaultUser.setProperty("role", "participant");
	String userJSP = null;
	try {
	    userJSP = (String) m_ctx.lookup("session_param/userInfoJSPURL");
	    URL url = new URL(String.valueOf(new StringBuffer(userJSP).append("?COMMAND=GETINFO&MEETINGID=").append(m_meetingID).append("&USERID=").append(userID)));
	    InputStream input = url.openStream();
	    Properties p = new Properties();
	    p.load(input);
	    String firstName = p.getProperty("FIRSTNAME");
	    String lastName = p.getProperty("LASTNAME");
	    String role = p.getProperty("roles.current");
	    if (firstName == null || lastName == null) {
		LogManager.err("SessionManager", "Unable to get user info for user ".concat(userID));
		firstName = "<unknown>";
		lastName = "<unknown>";
	    }
	    User u = new UserImpl(firstName, lastName, new UserIDImpl(userID));
	    if (role == null)
		u.setProperty("role", "participant");
	    else
		u.setProperty("role", role);
	    User user_11_4_ = u;
	    return user_11_4_;
	} catch (NamingException e) {
	    LogManager.err("SessionManager", "Unable to get parameter for userInforJSPURL", e);
	    User user_5_5_ = defaultUser;
	    return user_5_5_;
	} catch (MalformedURLException e) {
	    LogManager.err("SessionManager", "unable to find the URL specified", e);
	    User user_5_6_ = defaultUser;
	    return user_5_6_;
	} catch (IOException e) {
	    LogManager.err("SessionManager", "Unable to connect to the specified URL", e);
	    User user_5_7_ = defaultUser;
	    return user_5_7_;
	}
    }
}
