/* DefaultLauncherService - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sharedlet.framework;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.LauncherService;
import com.anabas.sharedlet.LayoutService;
import com.anabas.sharedlet.PermissionDeniedException;
import com.anabas.sharedlet.Sharedlet;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.util.misc.LogManager;

public class DefaultLauncherService
    implements LauncherService, GMS_MessageListener
{
    private Context m_context;
    private SharedletManager m_sharedletManager;
    private LayoutService m_layoutService = null;
    private GMS_Stream m_stream;
    private GMS_StreamSubscriber m_subscriber;
    private GMS_StreamPublisher m_publisher;
    private CommunicationService m_commService;
    private SharedletViewManager m_viewManager;
    private Hashtable m_extensionTable = new Hashtable();
    private static final String s_selfMIMEType = "application/x-sharedletservice-launcher";
    
    public boolean launch(URL documentURL)
      throws PermissionDeniedException {
      String extension = getExtension(documentURL);
      Vector sharedletInfos = (Vector) m_extensionTable.get(extension.toLowerCase());
      if (sharedletInfos == null)
        sharedletInfos = (Vector) m_extensionTable.get("*");
      if (sharedletInfos == null) {
        LogManager.warn("LauncherService", String.valueOf(new StringBuffer("Tried to launch '").append(documentURL).append("' but no compatible sharedlet")));
        return false;
      }
      SharedletInfo sinfo = (SharedletInfo) sharedletInfos.elementAt(0);
      Sharedlet sharedlet = m_sharedletManager.getSharedlet(sinfo);
      sharedlet.loadDocument(documentURL);
      return true;
    }
    
    private void sendLaunchCommand(String mimeType) {
	try {
	    GMS_TextMessage msg = (GMS_TextMessage) m_publisher.createMessage((short) 2, (short) 1);
	    msg.setText(mimeType);
	    m_publisher.broadcast(msg);
	    LogManager.log("LauncherService", "Send launch command for ".concat(mimeType));
	} catch (GXO_Exception e) {
	    LogManager.err("LauncherService", "Unable to send launch command for sharedlet ".concat(mimeType), e);
	}
    }
    
    public void onRequest(GMS_Message message, GMS_MessageReplyer replyer) {
	/* empty */
    }
    
    public void onMessage(GMS_Message message) {
	try {
	    String mimeType = ((GMS_TextMessage) message).getText();
	    if (m_layoutService == null) {
		try {
		    m_layoutService = (LayoutService) m_context.lookup("services/LayoutService");
		} catch (NamingException e) {
		    LogManager.err("LauncherService", "Unable to locate layout service", e);
		    return;
		}
	    }
	    LogManager.log("LauncherService", "Received launch command for ".concat(mimeType));
	    m_layoutService.activateViews(mimeType);
	} catch (GXO_Exception e) {
	    LogManager.err("LauncherService", "Unable to launch sharedlet based on remote command", e);
	}
    }
    
    public void init() {
	m_context = ContextManager.getInitialContext();
	try {
	    m_commService = (CommunicationService) m_context.lookup("services/CommunicationService");
	    m_stream = m_commService.findStream("application/x-sharedletservice-launcher");
	    if (m_stream == null)
		m_stream = m_commService.createStream("application/x-sharedletservice-launcher");
	    m_publisher = m_stream.createPublisher();
	    m_subscriber = m_stream.createSubscriber();
	    m_subscriber.setMessageListener(this);
	} catch (NamingException e) {
	    LogManager.err("LauncherService", "Unable to locate communication service", e);
	} catch (GXO_Exception e) {
	    LogManager.err("LauncherService", "Unable to initialize stream", e);
	}
	try {
	    m_sharedletManager = (SharedletManager) m_context.lookup("services/SharedletManager");
	} catch (NamingException e) {
	    LogManager.err("LauncherService", "Unable to find sharedlet manager");
	    return;
	}
	Vector sharedletInfos = m_sharedletManager.getSharedletInfos();
	Enumeration senum = sharedletInfos.elements();
	while (senum.hasMoreElements()) {
	    SharedletInfo sinfo = (SharedletInfo) senum.nextElement();
	    String[] docTypes = sinfo.getSupportedDocumentTypes();
	    if (docTypes != null && docTypes.length != 0) {
		for (int i = 0; i < docTypes.length; i++) {
		    Vector existingSharedlets = (Vector) m_extensionTable.get(docTypes[i]);
		    if (existingSharedlets == null) {
			existingSharedlets = new Vector();
			m_extensionTable.put(docTypes[i].toLowerCase(), existingSharedlets);
		    }
		    if (docTypes[i].equals("*"))
			existingSharedlets.insertElementAt(sinfo, existingSharedlets.size());
		    else
			existingSharedlets.insertElementAt(sinfo, 0);
		}
	    }
	}
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void shutdown() {
	/* empty */
    }
    
    public void resume() {
	/* empty */
    }
    
    public String getExtension(URL url) {
	String urlStr = url.getFile();
	int dotIndex = urlStr.lastIndexOf('.');
	if (dotIndex < 0)
	    return "html";
	return urlStr.substring(dotIndex + 1, urlStr.length());
    }
}
