/* DefaultLayoutService - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sharedlet.framework;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JToggleButton;
import javax.swing.UIManager;
import javax.swing.plaf.metal.MetalLookAndFeel;

import com.anabas.concepts.UserID;
import com.anabas.gxo.GMS_Destination;
import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_MulticastDestinationSelector;
import com.anabas.gxo.GMS_ObjectMessage;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.CapabilitiesManager;
import com.anabas.sharedlet.CapabilityListener;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.JavaViewConstraints;
import com.anabas.sharedlet.LayoutService;
import com.anabas.sharedlet.LayoutServiceEvent;
import com.anabas.sharedlet.LayoutServiceListener;
import com.anabas.sharedlet.NativeRenderer;
import com.anabas.sharedlet.PersistentStoreService;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.Sharedlet;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletRoleInfo;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletViewInfo;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.sharedlet.SharedletViewRenderer;
import com.anabas.util.io.StreamUtil;
import com.anabas.util.misc.LogManager;
import com.anabas.util.misc.StringUtil;
import com.anabas.util.ui.ImageButton;
import com.anabas.util.ui.VerticalFlowLayout;

public class DefaultLayoutService
    implements LayoutService, ActionListener, CapabilityListener, GMS_MessageListener
{
    protected static final int TRAP_LAYER = JLayeredPane.DEFAULT_LAYER.intValue() + 10;
    private static final String s_selfMIMEType = "application/x-sharedletservice-layout";
    private static final String MASTER_ROLE = "master";
    private static final String SLAVE_ROLE = "slave";
    private static final String FRAMEWORK_X0 = "framework.x0";
    private static final String FRAMEWORK_Y0 = "framework.y0";
    private static final String FRAMEWORK_WIDTH = "framework.width";
    private static final String FRAMEWORK_HEIGHT = "framework.height";
    private static final String CONTROLSPLITPANE_DIVIDER_LOCATION = "control.div";
    private static final String SMALLSPLITPANE_DIVIDER_LOCATION = "small.div";
    private static final String BIGSPLITPANE_DIVIDER_LOCATION = "big.div";
    private static final String DISPLAY_ORDER_PARAM = "session_param/system.displayorder";
    private static final String ACTIVE_SHAREDLETS_PARAM = "session_param/system.displayactive";
    private static final String[] s_supportedRegions = {
	"application", "control", "present", "tool"
    };
    protected JFrame m_frame = new JFrame();
    protected JSplitPane m_bigSplitPane = new JSplitPane(0);
    protected JSplitPane m_smallSplitPane = new JSplitPane(1);
    protected JPanel m_presentationPanel = new JPanel();
    protected JPanel m_controlPanel = new JPanel();
    protected JPanel m_applicationPanel = new JPanel();
    protected JPanel m_toolPanel = new JPanel();
    protected JSplitPane m_controlSplitPane = new JSplitPane();
    protected JPanel m_controlPaneTemp = new JPanel();
    protected JPanel m_controlWrapperPane = new JPanel();
    protected JPanel m_controlTrap = new JPanel();
    protected JScrollPane m_controlScrollPane = new JScrollPane();
    private JButton m_controlScrollUpButton = new ScrollButton("upArrow.gif");
    private JButton m_controlScrollDownButton = new ScrollButton("downArrow.gif");
    protected Hashtable m_view2region = new Hashtable();
    protected Hashtable m_view2control = new Hashtable();
    private SharedletView m_activePresentationView = null;
    private JScrollPane m_presentationScrollPane = new JScrollPane();
    private JPanel m_presentationPane = new JPanel();
    protected JPanel m_blankPanel = new BlankPanel();
    protected JPanel m_controlFixedPane = new JPanel();
    private JPanel m_tabbedPane = new JPanel();
    protected JToggleButton m_hideAppButton = new JToggleButton();
    protected ImageButton m_dockButton = new ImageButton(getClass());
    protected Dimension m_screenSize;
    private Vector m_Listeners = new Vector();
    private LayoutWindowListener m_windowListener;
    private int m_screenWidth;
    private int m_screenHeight;
    private int m_presentationWidth;
    private int m_presentationHeight;
    private int m_controlWidth;
    private int m_tabbedHeight;
    private int m_tabbedFrameHeight;
    private SharedletManager m_sharedletManager;
    private SharedletViewManager m_viewManager;
    private CapabilitiesManager m_capabilitiesManager;
    private CommunicationService m_commService;
    private GMS_Stream m_stream;
    private GMS_StreamPublisher m_publisher;
    private GMS_StreamSubscriber m_subscriber;
    private SessionManager m_sessionManager;
    private PersistentStoreService m_persistentStoreService;
    private SharedletRoleInfo m_myRoleInfo;
    protected boolean m_applicationFrameVisible = false;
    
    public void init()
    throws Exception {
	try {
	    UIManager.setLookAndFeel(new MetalLookAndFeel());
	    LogManager.log("LayoutService", "Setting to metal look n' feel");
	} catch (Exception e) {
	    LogManager.err("LayoutService", "Unable to set metal look n' feel", e);
	    e.printStackTrace();
	}
	m_screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	if (m_screenSize == null)
	    m_screenSize = new Dimension(600, 400);
	Context ctx = ContextManager.getInitialContext();
	try {
	    m_persistentStoreService = (PersistentStoreService) ctx.lookup("services/PersistentStoreService");
	    LogManager.log("LayoutService", "Got parameters to layout frames");
	} catch (NamingException e) {
	    LogManager.err("LayoutService", "Unable to locate PersistentStoreService", e);
	}
	String frame_x0 = m_persistentStoreService.getParameter("framework.x0");
	String frame_y0 = m_persistentStoreService.getParameter("framework.y0");
	String frame_width = m_persistentStoreService.getParameter("framework.width");
	String frame_height = m_persistentStoreService.getParameter("framework.height");
	int x0;
	if (frame_x0 != null)
	    x0 = Integer.parseInt(frame_x0);
	else
	    x0 = 0;
	int y0;
	if (frame_y0 != null)
	    y0 = Integer.parseInt(frame_y0);
	else
	    y0 = 0;
	int width;
	if (frame_width != null)
	    width = Integer.parseInt(frame_width);
	else
	    width = m_screenSize.width;
	int height;
	if (frame_height != null)
	    height = Integer.parseInt(frame_height);
	else
	    height = m_screenSize.height - 40;
	if (x0 < 0 && x0 + width < 0 || x0 > m_screenSize.width)
	    x0 = 10;
	if (y0 < 0 || y0 > m_screenSize.height)
	    y0 = 10;
	if (height < 20 || width < 20) {
	    height = m_screenSize.height;
	    width = m_screenSize.width - 40;
	}
	do {
	    try {
		m_sessionManager = (SessionManager) ctx.lookup("services/SessionManager");
		m_sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
		m_capabilitiesManager = (CapabilitiesManager) ctx.lookup("services/CapabilitiesManager");
		m_capabilitiesManager.addCapabilityListener(this);
		try {
		    m_commService = (CommunicationService) ctx.lookup("services/CommunicationService");
		    m_stream = m_commService.findStream("application/x-sharedletservice-layout");
		    if (m_stream == null)
			m_stream = m_commService.createStream("application/x-sharedletservice-layout");
		    m_publisher = m_stream.createPublisher();
		    m_subscriber = m_stream.createSubscriber();
		    m_subscriber.setMessageListener(this);
		} catch (GXO_Exception e) {
		    LogManager.err("LauncherService", "Unable to initialize stream", e);
		    break;
		}
		break;
	    } catch (NamingException e) {
		LogManager.err("LayoutService", "services not found!", e);
		break;
	    }
	} while (false);
	m_viewManager = m_sharedletManager.getViewManager();
	m_controlPanel.setLayout(new BorderLayout());
	m_controlWrapperPane.setLayout(new BorderLayout());
	m_controlScrollUpButton.setToolTipText("Scroll up");
	m_controlScrollUpButton.setMargin(new Insets(0, 0, 0, 0));
	m_controlScrollUpButton.addActionListener(this);
	m_controlScrollDownButton.setToolTipText("Scroll down");
	m_controlScrollDownButton.setMargin(new Insets(0, 0, 0, 0));
	m_controlScrollDownButton.addActionListener(this);
	VerticalFlowLayout vfl2 = new VerticalFlowLayout();
	vfl2.setHgap(0);
	vfl2.setVgap(0);
	m_controlScrollPane.getViewport().setLayout(vfl2);
	m_controlScrollPane.getViewport().add(m_controlPaneTemp, null);
	m_controlScrollPane.setHorizontalScrollBarPolicy(31);
	m_controlScrollPane.setVerticalScrollBarPolicy(21);
	m_controlWrapperPane.add(m_controlScrollUpButton, "North");
	m_controlWrapperPane.add(m_controlScrollDownButton, "South");
	m_controlScrollPane.setBorder(null);
	m_controlWrapperPane.add(m_controlScrollPane, "Center");
	m_controlWrapperPane.setMinimumSize(new Dimension(50, 70));
	m_controlSplitPane.setDividerSize(2);
	m_controlSplitPane.setOrientation(0);
	m_controlSplitPane.add(m_controlWrapperPane, "top");
	m_controlSplitPane.add(m_controlFixedPane, "bottom");
	m_controlPanel.add(m_controlSplitPane, "Center");
	m_controlFixedPane.setLayout(new GridBagLayout());
	VerticalFlowLayout vfl3 = new VerticalFlowLayout();
	vfl3.setHgap(0);
	vfl3.setVgap(3);
	m_controlPaneTemp.setLayout(vfl3);
	byte[] bytes = null;
	try {
	    bytes = StreamUtil.inputStreamToBytes(getClass().getResourceAsStream("icon.gif"));
	    Image im = Toolkit.getDefaultToolkit().createImage(bytes);
	    m_frame.setIconImage(im);
	} catch (Exception e) {
	    LogManager.err("LayoutService", "Unable to load window icon");
	}
	m_frame.setTitle("Anabas Collaboration");
	m_presentationPane.setDoubleBuffered(true);
	m_presentationPane.setLayout(new BorderLayout());
	m_presentationPane.add(m_blankPanel);
	m_presentationPanel.setLayout(new BorderLayout());
	m_presentationPanel.add(m_presentationScrollPane, "Center");
	m_presentationScrollPane.getViewport().add(m_presentationPane, null);
	m_applicationPanel.setLayout(new BorderLayout());
	m_tabbedPane.setLayout(new BorderLayout());
	m_applicationPanel.add(m_tabbedPane, "Center");
	showSharedlets();
	m_toolPanel.setLayout(new VerticalFlowLayout());
	m_controlPanel.setMinimumSize(new Dimension(168, 20));
	m_frame.getContentPane().setLayout(new BorderLayout());
	m_frame.getContentPane().add(m_toolPanel, "North");
	m_smallSplitPane.setDividerSize(3);
	m_smallSplitPane.add(m_controlPanel, "left");
	m_smallSplitPane.add(m_presentationPanel, "right");
	m_bigSplitPane.setDividerSize(3);
	m_bigSplitPane.add(m_smallSplitPane, "top");
	m_bigSplitPane.add(m_applicationPanel, "bottom");
	m_frame.getContentPane().add(m_bigSplitPane, "Center");
	String control_div = m_persistentStoreService.getParameter("control.div");
	String small_div = m_persistentStoreService.getParameter("small.div");
	String big_div = m_persistentStoreService.getParameter("big.div");
	m_frame.setLocation(x0, y0);
	m_frame.setSize(width, height);
	m_frame.setVisible(true);
	int bigDiv = 0;
	int smallDiv = 0;
	int controlDiv = 0;
	try {
	    if (big_div == null)
		m_bigSplitPane.setDividerLocation(0.8);
	    else {
		bigDiv = Integer.parseInt(big_div);
		if (bigDiv < 10)
		    m_bigSplitPane.setDividerLocation(0.8);
		else
		    m_bigSplitPane.setDividerLocation(bigDiv);
	    }
	    if (small_div == null)
		m_smallSplitPane.setDividerLocation(168);
	    else {
		smallDiv = Integer.parseInt(small_div);
		if (smallDiv < 10)
		    m_smallSplitPane.setDividerLocation(168);
		else
		    m_smallSplitPane.setDividerLocation(smallDiv);
	    }
	    if (control_div == null)
		m_controlSplitPane.setDividerLocation(225);
	    else {
		controlDiv = Integer.parseInt(control_div);
		if (controlDiv < 10)
		    m_controlSplitPane.setDividerLocation(0.5);
		else
		    m_controlSplitPane.setDividerLocation(controlDiv);
	    }
	} catch (NumberFormatException e) {
	    LogManager.warn("LayoutService", "Unable to parse integer. Properties file must be currupted");
	}
	activateSharedlets();
	getActiveSharedlet();
	m_windowListener = new LayoutWindowListener(this);
    }
    
    public void addLayoutListener(LayoutServiceListener l) {
	m_Listeners.addElement(l);
    }
    
    public void removeLayoutListener(LayoutServiceListener l) {
	m_Listeners.removeElement(l);
    }
    
    public void shutdown() {
	if (m_frame != null) {
	    m_frame.setVisible(false);
	    m_frame.dispose();
	}
	Rectangle r = m_frame.getBounds();
	LogManager.log("LayoutService", "Saving framework bounds: ".concat(String.valueOf(r)));
	m_persistentStoreService.setParameter("framework.width", Integer.toString(r.width));
	m_persistentStoreService.setParameter("framework.height", Integer.toString(r.height));
	m_persistentStoreService.setParameter("framework.x0", Integer.toString(r.x));
	m_persistentStoreService.setParameter("framework.y0", Integer.toString(r.y));
	int control_div = m_controlSplitPane.getDividerLocation();
	int small_div = m_smallSplitPane.getDividerLocation();
	int big_div = m_bigSplitPane.getDividerLocation();
	m_persistentStoreService.setParameter("control.div", Integer.toString(control_div));
	m_persistentStoreService.setParameter("small.div", Integer.toString(small_div));
	m_persistentStoreService.setParameter("big.div", Integer.toString(big_div));
	Enumeration viewEnum = m_view2region.keys();
	while (viewEnum.hasMoreElements()) {
	    SharedletView view = (SharedletView) viewEnum.nextElement();
	    view.deactivate();
	}
    }
    
    public void activateViews(String mimeType) {
	activateViews(mimeType, null);
    }
    
    public void deactivateViews(String mimeType) {
	deactivateViews(mimeType, null);
    }
    
    public void activateView(SharedletView view) {
	String region = (String) m_view2region.get(view);
	if (region == null)
	    LogManager.warn("LayoutService", String.valueOf(new StringBuffer("Found view ").append(view).append(" without region")));
	else if (region.equals("application"))
	    activateApplicationView(view);
	else if (region.equals("control"))
	    activateControlView(view);
	else if (region.equals("present"))
	    activatePresentationView(view);
	else if (region.equals("tool"))
	    activateToolView(view);
    }
    
    public void deactivateView(SharedletView view) {
	String region = (String) m_view2region.get(view);
	if (region != null) {
	    if (region.equals("application"))
		deactivateApplicationView(view);
	    else if (region.equals("control"))
		deactivateControlView(view);
	    else if (region.equals("present"))
		deactivatePresentationView(view);
	    else if (region.equals("tool"))
		deactivateToolView(view);
	}
    }
    
    public String[] getSupportedRegions() {
	return s_supportedRegions;
    }
    
    public Dimension getRegionDimension(String region) {
	if (region.equals("control"))
	    return m_controlPanel.getSize();
	if (region.equals("application"))
	    return m_applicationPanel.getSize();
	if (region.equals("present"))
	    return m_presentationPanel.getSize();
	if (region.equals("tool"))
	    return m_toolPanel.getSize();
	return null;
    }
    
    public Point getRegionPosition(String region) {
	if (region.equals("control"))
	    return m_controlPanel.getLocation();
	if (region.equals("application"))
	    return m_applicationPanel.getLocation();
	if (region.equals("present"))
	    return m_presentationPanel.getLocation();
	if (region.equals("tool"))
	    return m_toolPanel.getLocation();
	return null;
    }
    
    public void onMessage(GMS_Message msg) {
	try {
	    String mimeType = ((GMS_TextMessage) msg).getText();
	    activateViews(mimeType);
	    LogManager.log("LayoutService", "Received & Exec'ed remote launch cmd for ".concat(mimeType));
	} catch (GXO_Exception e) {
	    LogManager.err("LayoutService", "Received remote launch cmd but can't launch", e);
	}
    }
    
    public void onRequest(GMS_Message msg, GMS_MessageReplyer replyer) {
	try {
	    String role = m_capabilitiesManager.getRole("application/x-sharedletservice-layout");
	    if (role.toLowerCase().equals("master")) {
		GMS_TextMessage replymsg = (GMS_TextMessage) m_publisher.createMessage((short) 0, (short) 1);
		if (m_activePresentationView != null) {
		    Sharedlet sharedlet = m_sharedletManager.getViewManager().getSharedlet(m_activePresentationView);
		    SharedletInfo info = m_sharedletManager.getInfo(sharedlet);
		    replymsg.setText(info.getMIMEType());
		} else
		    replymsg.setText("");
		replyer.reply(msg, replymsg);
	    }
	} catch (GXO_Exception e) {
	    LogManager.err("LayoutService", "Unable to reply with active sharedlet", e);
	}
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void resume() {
	/* empty */
    }
    
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == m_controlScrollUpButton) {
	    int step = 40;
	    Point p = m_controlScrollPane.getViewport().getViewPosition();
	    Dimension vd = m_controlScrollPane.getViewport().getSize();
	    Dimension pd = m_controlPaneTemp.getSize();
	    int y;
	    if (p.y - step < 0)
		y = 0;
	    else
		y = p.y - step;
	    m_controlScrollPane.getViewport().setViewPosition(new Point(p.x, y));
	} else if (e.getSource() == m_controlScrollDownButton) {
	    int step = 40;
	    Point p = m_controlScrollPane.getViewport().getViewPosition();
	    Dimension vd = m_controlScrollPane.getViewport().getSize();
	    Dimension pd = m_controlPaneTemp.getSize();
	    if (pd.height >= vd.height) {
		int y;
		if (p.y + vd.height + step > pd.height)
		    y = pd.height - vd.height;
		else
		    y = p.y + step;
		m_controlScrollPane.getViewport().setViewPosition(new Point(p.x, y));
	    }
	}
    }
    
    public void remoteCapabilityChanged(String capability, boolean enabled, UserID user) {
	/* empty */
    }
    
    public void capabilityChanged(String capability, boolean enabled) {
	/* empty */
    }
    
    public void modeChanged(short newMode) {
	/* empty */
    }
    
    public String getSharedletMIME() {
	return "application/x-sharedletservice-layout";
    }
    
    public void roleChanged(String roleName) {
	Vector v = m_sharedletManager.getSharedletInfos();
	Enumeration enum = v.elements();
	while (enum.hasMoreElements())
	    updateSharedlet((SharedletInfo) enum.nextElement());
    }
    
    protected void deactivateViews(String mimeType, SharedletView excludeView) {
	SharedletInfo info = m_sharedletManager.getInfo(mimeType);
	if (info == null)
	    LogManager.err("LayoutService", String.valueOf(new StringBuffer("Sharedlet of type '").append(mimeType).append("' not found.  Deactivate views aborted.")));
	else {
	    Vector views = m_viewManager.getViews(info.getMIMEType());
	    Enumeration enum = views.elements();
	    while (enum.hasMoreElements()) {
		SharedletView view = (SharedletView) enum.nextElement();
		if (view != excludeView) {
		    LogManager.log(9, "LayoutService", "  deactivate: ".concat(String.valueOf(view)));
		    deactivateView(view);
		} else
		    LogManager.log(9, "LayoutService", "  skipping deactivate: ".concat(String.valueOf(view)));
	    }
	}
    }
    
    protected void activateViews(String mimeType, SharedletView excludeView) {
	SharedletInfo info = m_sharedletManager.getInfo(mimeType);
	if (info == null)
	    LogManager.err("LayoutService", String.valueOf(new StringBuffer("Sharedlet of type '").append(mimeType).append("' not found.  Activate views aborted.")));
	else {
	    Vector views = m_viewManager.getViews(info.getMIMEType());
	    Enumeration enum = views.elements();
	    while (enum.hasMoreElements()) {
		SharedletView view = (SharedletView) enum.nextElement();
		if (view != excludeView)
		    activateView(view);
	    }
	}
    }
    
    protected void fireEventAllWindowsClosed(LayoutServiceEvent e) {
	Enumeration enum = m_Listeners.elements();
	while (enum.hasMoreElements()) {
	    LayoutServiceListener l = (LayoutServiceListener) enum.nextElement();
	    l.allWindowsClosed(e);
	}
    }
    
    protected void activateApplicationView(SharedletView view) {
	/* empty */
    }
    
    protected void deactivateApplicationView(SharedletView view) {
	/* empty */
    }
    
    protected void activateToolView(SharedletView view) {
	SharedletViewInfo info = m_viewManager.getViewInfo(view);
	String id = info.getID();
	for (int i = 0; i < m_toolPanel.getComponentCount(); i++) {
	    /* empty */
	}
	view.activate();
    }
    
    protected void deactivateToolView(SharedletView view) {
	/* empty */
    }
    
    protected void activateControlView(SharedletView view) {
	ControlViewContainer container = (ControlViewContainer) m_view2control.get(view);
	if (container.isShrunk())
	    container.expandView();
    }
    
    protected void deactivateControlView(SharedletView view) {
	ControlViewContainer container = (ControlViewContainer) m_view2control.get(view);
	if (!container.isShrunk())
	    container.shrinkView();
    }
    
    protected void deactivatePresentationView(SharedletView view) {
	if (view != null) {
	    if (m_activePresentationView == view) {
		m_activePresentationView = null;
		m_presentationPane.removeAll();
		m_presentationPane.add(m_blankPanel);
		m_presentationPanel.validate();
		m_presentationPanel.repaint();
		view.deactivate();
	    }
	}
    }
    
    protected void activatePresentationView(SharedletView view) {
	if (m_activePresentationView != view) {
	    if (m_activePresentationView != null) {
		Sharedlet sharedlet = m_viewManager.getSharedlet(m_activePresentationView);
		SharedletInfo info = m_sharedletManager.getInfo(sharedlet);
		deactivateViews(info.getMIMEType());
		LogManager.log("LayoutService", "Deactivating ".concat(info.getMIMEType()));
	    }
	    m_activePresentationView = view;
	    String role = m_capabilitiesManager.getRole("application/x-sharedletservice-layout");
	    if (role.toLowerCase().equals("master")) {
		Sharedlet sh = m_viewManager.getSharedlet(m_activePresentationView);
		SharedletInfo info = m_sharedletManager.getInfo(sh);
		activateRemoteSharedlet(info.getMIMEType());
	    }
	    SharedletViewRenderer r = view.getRenderer("application/java");
	    if (r != null) {
		Component c = (Component) r.getRendering();
		m_presentationPane.removeAll();
		m_presentationPane.add(c);
		m_presentationPane.revalidate();
		m_presentationPane.repaint();
	    } else {
		try {
		    r = (NativeRenderer) view.getRenderer("application/native");
		} catch (Exception e) {
		    LogManager.err("LayoutService", "Unable to set native renderer", e);
		}
	    }
	    LogManager.log(9, "LayoutService", "Activating presentation view ".concat(String.valueOf(view)));
	    m_activePresentationView.activate();
	}
    }
    
    private void getActiveSharedlet() {
	try {
	    GMS_ObjectMessage msg = (GMS_ObjectMessage) m_publisher.createMessage((short) 0, (short) 3);
	    msg.setObject(m_sessionManager.getMyUser().getUserID());
	    GMS_MulticastDestinationSelector selector = (GMS_MulticastDestinationSelector) m_publisher.createDestinationSelector("GMS_MulticastDestinationSelector");
	    GMS_Destination dst = m_stream.findDestination(selector);
	    GMS_TextMessage response = (GMS_TextMessage) m_publisher.request(msg, dst, 1000L);
	    if (response != null) {
		String activeMIMEType = response.getText();
		if (activeMIMEType.length() != 0) {
		    LogManager.log("LayoutService", "Found active sharedlet of ".concat(activeMIMEType));
		    activateViews(activeMIMEType);
		} else
		    LogManager.log("LayoutService", "Nothing currently active");
	    }
	} catch (GXO_Exception e) {
	    LogManager.err("LayoutService", "Unable to get active sharedlet.", e);
	}
    }
    
    private void activateRemoteSharedlet(String mimeType) {
	try {
	    GMS_TextMessage msg = (GMS_TextMessage) m_publisher.createMessage((short) 2, (short) 1);
	    msg.setText(mimeType);
	    m_publisher.broadcast(msg);
	    LogManager.log("LayoutService", "Send launch command for ".concat(mimeType));
	} catch (GXO_Exception e) {
	    LogManager.err("LayoutService", "Unable to send launch command for sharedlet ".concat(mimeType), e);
	}
    }
    
    private void activateSharedlets() {
	String[] activeDisplayArray = null;
	try {
	    String activeSharedlets = (String) ContextManager.getInitialContext().lookup("session_param/system.displayactive");
	    activeDisplayArray = StringUtil.splitString(activeSharedlets, ',');
	} catch (NamingException e) {
	    LogManager.log("LayoutService", "No display order specifiede");
	}
	for (int i = 0; activeDisplayArray != null && i < activeDisplayArray.length; i++) {
	    if (activeDisplayArray[i].startsWith("application/"))
		activateViews(activeDisplayArray[i]);
	    else
		activateViews("application/".concat(activeDisplayArray[i]));
	}
    }
    
    private void showSharedlets() {
	String[] displayOrder = null;
	String[] activeDisplayArray = null;
	try {
	    String displayOrderStr = (String) ContextManager.getInitialContext().lookup("session_param/system.displayorder");
	    String activeSharedlets = (String) ContextManager.getInitialContext().lookup("session_param/system.displayactive");
	    displayOrder = StringUtil.splitString(displayOrderStr, ',');
	    activeDisplayArray = StringUtil.splitString(activeSharedlets, ',');
	} catch (NamingException e) {
	    LogManager.log("LayoutService", "No display order specified");
	}
	Vector v = m_sharedletManager.getSharedletInfos();
	SharedletInfo[] displayInfo = new SharedletInfo[v.size() + displayOrder.length];
	int nonOrderedIndex = displayOrder.length;
	Enumeration enum = v.elements();
	while (enum.hasMoreElements()) {
	    SharedletInfo info = (SharedletInfo) enum.nextElement();
	    boolean ordered = false;
	    for (int i = 0; i < displayOrder.length; i++) {
		if (info.getMIMEType().endsWith(displayOrder[i])) {
		    displayInfo[i] = info;
		    ordered = true;
		    break;
		}
	    }
	    if (!ordered)
		displayInfo[nonOrderedIndex++] = info;
	}
	for (int i = 0; i < nonOrderedIndex; i++) {
	    if (displayInfo[i] != null)
		updateSharedlet(displayInfo[i]);
	}
    }
    
    private Dimension calculateDimensions(JavaViewConstraints vc) {
	Dimension min = vc.getMinimumSize();
	Dimension pref = vc.getPreferredSize();
	Dimension max = vc.getMaximumSize();
	Dimension app = new Dimension();
	String region = vc.getProperty("region");
	if (region.equals("application"))
	    app.setSize(m_presentationWidth, m_tabbedHeight - 50);
	else if (region.equals("control"))
	    app.setSize(m_controlWidth, m_presentationHeight);
	else if (!region.equals("free") && region.equals("present"))
	    app.setSize(m_presentationWidth, m_presentationHeight);
	if (min != null) {
	    if (min.width > app.width)
		return null;
	    if (min.height > app.height)
		return null;
	}
	if (max != null) {
	    if (max.width < app.width)
		return null;
	    if (max.height < app.height)
		return null;
	}
	if (pref != null) {
	    app.width = pref.width;
	    app.height = pref.height;
	}
	return app;
    }
    
    private void addView(SharedletView view, String sharedletMIME) {
	SharedletViewInfo viewInfo = m_viewManager.getViewInfo(view);
	SharedletViewRenderer renderer = view.getRenderer("application/java");
	JavaViewConstraints vc = (JavaViewConstraints) viewInfo.getConstraints("application/java");
	Dimension real = calculateDimensions(vc);
	String region = vc.getProperty("region");
	m_view2region.put(view, region);
	if (renderer == null)
	    LogManager.log("LayoutService", String.valueOf(new StringBuffer("Renderer for ").append(viewInfo.getID()).append(" does not exist...skipping placement")));
	else {
	    Component c = (Component) renderer.getRendering();
	    if (c == null)
		LogManager.err("LayoutService", String.valueOf(new StringBuffer("Java rendering for ").append(viewInfo.getID()).append(" does not exist.")));
	    else if (real == null)
		LogManager.err("LayoutService", "View parameteres exceed limits for ".concat(viewInfo.getID()));
	    else {
		c.setSize(real);
		if (region.equals("tool")) {
		    Dimension dim = m_toolPanel.getSize();
		    m_toolPanel.add(c, null);
		    m_toolPanel.validate();
		    m_toolPanel.repaint();
		    view.activate();
		    m_frame.validate();
		} else if (region.equals("control_fixed")) {
		    ControlViewContainer container = new ControlViewContainer(this, viewInfo.getID(), sharedletMIME, view, c, m_controlWidth);
		    GridBagConstraints constraints = new GridBagConstraints();
		    constraints.fill = 1;
		    constraints.weightx = 1.0;
		    constraints.weighty = 1.0;
		    int compCount = m_controlFixedPane.getComponentCount();
		    Dimension minDim = c.getMinimumSize();
		    Dimension maxDim = c.getMaximumSize();
		    if (minDim.equals(maxDim))
			constraints.weighty = 0.0;
		    constraints.gridy = compCount;
		    m_controlFixedPane.add(c, constraints);
		    m_controlFixedPane.validate();
		    view.activate();
		    m_view2control.put(view, container);
		    LogManager.log("LayoutService", "Added control view ".concat(viewInfo.getID()));
		} else if (region.equals("control")) {
		    ControlViewContainer container = new ControlViewContainer(this, viewInfo.getID(), sharedletMIME, view, c, m_controlWidth);
		    m_controlPaneTemp.add(container, m_controlPaneTemp.getComponentCount());
		    m_controlPaneTemp.validate();
		    m_view2control.put(view, container);
		    LogManager.log("LayoutService", "Added control view ".concat(viewInfo.getID()));
		} else if (region.equals("application")) {
		    m_tabbedPane.add(c, "Center");
		    m_tabbedPane.validate();
		    LogManager.log("LayoutService", "Added application view ".concat(viewInfo.getID()));
		} else if (region.equals("free"))
		    LogManager.log("LayoutService", "Added free form view ".concat(viewInfo.getID()));
		else if (region.equals("present"))
		    LogManager.log("LayoutService", "Added presentation view ".concat(viewInfo.getID()));
	    }
	}
    }
    
    private void removeView(SharedletView view) {
	SharedletViewRenderer r = view.getRenderer("application/java");
	Component c = (Component) r.getRendering();
	SharedletViewInfo info = m_viewManager.getViewInfo(view);
	JavaViewConstraints vc = (JavaViewConstraints) info.getConstraints("application/java");
	String region = (String) m_view2region.get(view);
	if (region != null) {
	    if (region.equals("tool")) {
		Dimension dim = m_toolPanel.getSize();
		m_toolPanel.remove(c);
		m_toolPanel.validate();
		m_toolPanel.repaint();
		m_frame.validate();
	    } else if (region.equals("application")) {
		m_tabbedPane.remove(c);
		m_tabbedPane.validate();
		m_tabbedPane.repaint();
	    } else if (region.equals("control")) {
		m_view2control.remove(view);
		m_controlPaneTemp.remove(c);
		m_controlPaneTemp.validate();
		m_controlPaneTemp.repaint();
	    } else if (region.equals("control_fixed")) {
		m_view2control.remove(view);
		m_controlFixedPane.remove(c);
		m_controlFixedPane.validate();
		m_controlFixedPane.repaint();
	    } else if (!region.equals("free") && region.equals("present")) {
		m_presentationPane.remove(c);
		m_presentationPane.validate();
		m_presentationPane.repaint();
	    }
	    view.deactivate();
	    m_view2region.remove(view);
	}
    }
    
    private SharedletRoleInfo getMyRoleInfo(SharedletInfo sinfo) {
	String roleName = m_capabilitiesManager.getRole(sinfo.getMIMEType());
	Vector v = sinfo.getRoleInfos();
	Enumeration enum = v.elements();
    while_0_:
	do {
	    SharedletRoleInfo role;
	    do {
		if (!enum.hasMoreElements())
		    break while_0_;
		role = (SharedletRoleInfo) enum.nextElement();
	    } while (!role.getID().equals(roleName));
	    return role;
	} while (false);
	LogManager.err("LayoutService", String.valueOf(new StringBuffer("Unable to find a matching role in sharedlet ").append(sinfo.getMIMEType()).append(" for role name ").append(roleName)));
	return null;
    }
    
    private void updateSharedlet(SharedletInfo sharedletInfo) {
	Vector viewInfos = sharedletInfo.getViewInfos();
	Vector allowedRoleViews = null;
	SharedletRoleInfo role = getMyRoleInfo(sharedletInfo);
	if (role == null)
	    LogManager.err("LayoutService", "No roles matched so allowing all views");
	else
	    allowedRoleViews = role.getRoleViews();
	Enumeration enum = viewInfos.elements();
	while (enum.hasMoreElements()) {
	    SharedletViewInfo info = (SharedletViewInfo) enum.nextElement();
	    SharedletView view = m_viewManager.getView(info);
	    if (view == null) {
		LogManager.err("LayoutService", String.valueOf(new StringBuffer("View of ").append(info.getID()).append(" not found even though there exist a view info with the same name")));
		break;
	    }
	    if (allowedRoleViews != null && !allowedRoleViews.contains(info.getID())) {
		LogManager.log("LayoutService", String.valueOf(new StringBuffer("view ").append(info.getID()).append(" is not allowed for sharedlet ").append(sharedletInfo.getMIMEType()).append(" in a role of ").append(role.getID())));
		if (m_view2region.get(view) != null) {
		    LogManager.log("LayoutService", "Taking away view ".concat(info.getID()));
		    removeView(view);
		}
	    } else if (m_view2region.get(view) == null)
		addView(view, sharedletInfo.getMIMEType());
	}
    }
    
    private void removeSharedlet(SharedletInfo sharedletInfo) {
	Vector v = sharedletInfo.getViewInfos();
	Enumeration enum = v.elements();
	while (enum.hasMoreElements()) {
	    SharedletViewInfo viewInfo = (SharedletViewInfo) enum.nextElement();
	    SharedletView view = m_viewManager.getView(viewInfo);
	    removeView(view);
	}
    }
    
    static {
	try {
	    UIManager.setLookAndFeel(new MetalLookAndFeel());
	    LogManager.log("LayoutService", "Setting to metal look n' feel");
	} catch (Exception e) {
	    LogManager.err("LayoutService", "Unable to set metal look n' feel", e);
	    e.printStackTrace();
	}
    }
}
