/* SDPresentationView - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sdsharedlet;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.Vector;

import com.anabas.concepts.User;
import com.anabas.concepts.UserID;
import com.anabas.gxo.GMS_BytesMessage;
import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_ObjectMessage;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.sharedlet.CapabilitiesManager;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletViewInfo;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.sharedlet.SharedletViewRenderer;
import com.anabas.util.misc.LogManager;

public class SDPresentationView
    implements SharedletView, GMS_MessageListener
{
    private static final String PROP_REQ_TYPE = "req1";
    static final String JAVA_RENDERER_MIME = "application/java";
    private SDNativeRenderer m_renderer;
    private SDControlView m_controlView;
    private SDWrapper m_sdWrapper;
    private SDEventListenerThread m_eventListenerThread;
    private boolean m_host = false;
    private boolean m_participant = false;
    private String m_role;
    private int[] m_appsToRestore = new int[0];
    private boolean m_startPosting = false;
    private boolean m_bIsPresenter = false;
    private SharedletManager m_sharedletManager;
    private SDSharedlet m_sdsharedlet;
    private SharedletInfo m_sharedletInfo;
    private SharedletViewManager m_viewManager;
    private CapabilitiesManager m_capabilitiesManager;
    private SessionManager m_sessionManager;
    private CommunicationService m_commService;
    private GMS_Stream m_stream;
    private GMS_StreamPublisher m_publisher;
    private GMS_StreamSubscriber m_subscriber;
    private User m_thisUser;
    private Vector m_RFUQueue = new Vector();
    
    public SDPresentationView() {
	log("Creating Presentation View ...");
	try {
	    m_controlView = (SDControlView) getMyView("Shared Display");
	} catch (Exception ex) {
	    err("SDPresentationView: Err:", ex);
	}
	if (m_controlView == null) {
	    log("### SDPresentationView: could not get the SDControl view ");
	    m_renderer = new SDNativeRenderer(null);
	} else {
	    m_sdWrapper = m_controlView.getSDWrapper();
	    m_renderer = new SDNativeRenderer(m_sdWrapper);
	}
	getServices();
    }
    
    public void activate() {
	log("activate: called ");
	m_sdWrapper.init();
	m_eventListenerThread = new SDEventListenerThread(m_publisher, m_stream, m_sdWrapper, this, m_controlView);
	testWndListener();
	boolean canControlInput = canControlInput();
	long presentationToken = m_controlView.getToken("1:presentation");
	long icToken = m_controlView.getToken("1:input_control");
	log(String.valueOf(new StringBuffer("Got Presentation Token ==========[").append(presentationToken).append("]===========")));
	log(String.valueOf(new StringBuffer("Got input control Token ==========[").append(icToken).append("]===========")));
	m_bIsPresenter = canPresent();
	if (m_bIsPresenter) {
	    log(String.valueOf(new StringBuffer("==========> Presenter >> activated with Input control set to [").append(canControlInput).append("]")));
	    m_sdWrapper.listen(presentationToken);
	    m_sdWrapper.EnableInputControl(canControlInput, icToken);
	    m_eventListenerThread.beginThread(true);
	    restoreApps();
	    m_controlView.enableRemoveURL(true);
	} else {
	    log(String.valueOf(new StringBuffer("==========> Participant >> activated with Input control set to [").append(canControlInput).append("]")));
	    m_sdWrapper.connect(presentationToken);
	    m_eventListenerThread.beginThread(false);
	    m_sdWrapper.EnableInputControl(canControlInput, icToken);
	    UserID id = m_thisUser.getUserID();
	    log("<<<<<<< Participant broadcasting the Request Full Update >>>>>");
	    log("User id = ".concat(String.valueOf(id)));
	    broadcastObjectMessage(id, "req1", "<RUF>");
	}
    }
    
    public void deactivate() {
	log("deactivate: called ...");
	if (m_eventListenerThread != null) {
	    m_controlView.enableRemoveURL(false);
	    m_appsToRestore = m_controlView.getSharedWnds();
	    m_sdWrapper.release();
	    m_eventListenerThread.stopThread();
	}
    }
    
    private boolean canPresent() {
	return m_capabilitiesManager.isCapable("application/x-sharedlet-sd", "1:presentation");
    }
    
    private boolean canControlInput() {
	return m_capabilitiesManager.isCapable("application/x-sharedlet-sd", "1:input_control");
    }
    
    private void restoreApps() {
	log(String.valueOf(new StringBuffer("######### restoring apps [").append(m_appsToRestore.length).append("] ")));
	for (int iCount = 0; iCount < m_appsToRestore.length; iCount++) {
	    log(String.valueOf(new StringBuffer("######### restoring app [").append(m_appsToRestore[iCount]).append("] ")));
	    if (!m_sdWrapper.ClickToShare(m_appsToRestore[iCount], 1))
		m_sdsharedlet.removeURL(new Integer(m_appsToRestore[iCount]));
	    else
		log("####### app restored successfully #####");
	}
	int lastActivatedWnd = m_controlView.getLastActivatedWnd();
	if (lastActivatedWnd != 0)
	    m_sdWrapper.ClickToShare(lastActivatedWnd, 3);
    }
    
    public SharedletViewRenderer getRenderer(String MIMEType) {
	log(String.valueOf(new StringBuffer("getRenderer: called with MIME type [").append(MIMEType).append("]")));
	if (MIMEType.equals("application/java"))
	    return m_renderer;
	return null;
    }
    
    public void onMessage(GMS_Message m) {
	int MsgBodyType = (int) m.getBodyType();
	if (m_bIsPresenter)
	    processHostMessage(m, MsgBodyType);
	else
	    processParticipantMessage(m, MsgBodyType);
    }
    
    public void onRequest(GMS_Message m, GMS_MessageReplyer r) {
	/* empty */
    }
    
    synchronized void addToRFUQue(UserID userId) {
	m_RFUQueue.addElement(userId);
    }
    
    synchronized UserID getNextInRFUQue() {
	UserID userId = null;
	try {
	    userId = (UserID) m_RFUQueue.elementAt(0);
	    m_RFUQueue.removeElement(userId);
	} catch (ArrayIndexOutOfBoundsException arrayindexoutofboundsexception_2_0_) {
	    /* empty */
	}
	return userId;
    }
    
    private void processHostMessage(GMS_Message m, int MsgBodyType) {
	switch (MsgBodyType) {
	case 3:
	    try {
		GMS_ObjectMessage msg = (GMS_ObjectMessage) m;
		log("!!!!!!!!!!!!! Host got the object message !!!!!!!!!!!!!!");
		String strVal = (String) msg.getProperty("req1");
		if (strVal.equals("<RUF>")) {
		    UserID newUserID = (UserID) msg.getObject();
		    log(String.valueOf(new StringBuffer("!!!!!!!!! Host sending RFU for user [").append(newUserID.getID()).append("] !!!!!!!!!!!")));
		    addToRFUQue(newUserID);
		    m_eventListenerThread.requestFullUpdate(102);
		}
	    } catch (GXO_Exception e) {
		err("processHostMessage: Error", e);
	    }
	    break;
	case 4:
	    try {
		GMS_BytesMessage msg = (GMS_BytesMessage) m;
		byte[] eventBuf = msg.getBytes();
		m_sdWrapper.PostEvent(eventBuf);
	    } catch (GXO_Exception e) {
		err("processHostMessage: Error", e);
	    }
	    break;
	}
    }
    
    private void processParticipantMessage(GMS_Message m, int MsgBodyType) {
	switch (MsgBodyType) {
	case 4:
	    try {
		GMS_BytesMessage msg = (GMS_BytesMessage) m;
		byte[] eventBuf = msg.getBytes();
		m_sdWrapper.PostEvent(eventBuf);
	    } catch (GXO_Exception e) {
		err("processParticipantMessage: Error", e);
	    }
	    break;
	default:
	    log("processParticipantMessage: got invalid message ...");
	}
    }
    
    private boolean getServices() {
	try {
	    Context ctx = ContextManager.getInitialContext();
	    m_commService = (CommunicationService) ctx.lookup("services/CommunicationService");
	    m_stream = m_commService.findStream("application/x-sharedlet-sd");
	    if (m_stream == null)
		m_stream = m_commService.createStream("application/x-sharedlet-sd");
	    m_publisher = m_stream.createPublisher();
	    m_subscriber = m_stream.createSubscriber();
	    m_subscriber.setMessageListener(this);
	    m_capabilitiesManager = (CapabilitiesManager) ctx.lookup("services/CapabilitiesManager");
	    m_role = m_capabilitiesManager.getRole("application/x-sharedlet-sd");
	    if (m_role == null)
		log("Could not get role from the Capabilities manager ...");
	    else if (m_role.equals("Host"))
		m_host = true;
	    else if (m_role.equals("Participant"))
		m_participant = true;
	    m_sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	    m_sdsharedlet = (SDSharedlet) m_sharedletManager.getSharedlet(m_sharedletManager.getInfo("application/x-sharedlet-sd"));
	    m_sessionManager = (SessionManager) ctx.lookup("services/SessionManager");
	    m_thisUser = m_sessionManager.getMyUser();
	} catch (Exception ex) {
	    err("getServices: Error", ex);
	    boolean bool_2_1_ = false;
	    return bool_2_1_;
	}
	return true;
    }
    
    private void broadcastTextMessage(String strMsg, String propName, Object val) {
	try {
	    GMS_TextMessage msg = (GMS_TextMessage) m_publisher.createMessage((short) 1, (short) 1);
	    if (msg == null) {
		log("broadcastTextMessage: null message ...");
		SDSharedlet.handleDisconnected();
	    } else {
		msg.setText(strMsg);
		if (propName != null)
		    msg.setProperty(propName, val);
		m_publisher.broadcast(msg);
	    }
	} catch (Exception ex) {
	    SDSharedlet.handleDisconnected();
	    err("broadcastTextMessage: Error", ex);
	}
    }
    
    private void broadcastObjectMessage(Object objMsg, String propName, String propVal) {
	try {
	    GMS_ObjectMessage msg = (GMS_ObjectMessage) m_publisher.createMessage((short) 1, (short) 3);
	    if (msg == null) {
		log("broadcastObjectMessage: null message ...");
		SDSharedlet.handleDisconnected();
	    } else {
		msg.setObject((Serializable) objMsg);
		if (propName != null)
		    msg.setProperty(propName, propVal);
		m_publisher.broadcast(msg);
	    }
	} catch (Exception ex) {
	    SDSharedlet.handleDisconnected();
	    err("broadcastObjectMessage: Error", ex);
	}
    }
    
    private void testWndListener() {
	m_renderer.addComponentListener(new ComponentAdapter() {
	    public void componentHidden(ComponentEvent e) {
		SDPresentationView.this.log("============> sd wnd hidden ");
	    }
	    
	    public void componentMoved(ComponentEvent e) {
		Point p = m_renderer.getLocation();
		SDPresentationView.this.log(String.valueOf(new StringBuffer("============> sd wnd moved to [").append(p.x).append(",").append(p.y).append("]")));
	    }
	    
	    public void componentResized(ComponentEvent e) {
		Dimension d = m_renderer.getDimension();
		SDPresentationView.this.log(String.valueOf(new StringBuffer("============> sd wnd resized to [").append(d.width).append(",").append(d.height).append("]")));
	    }
	    
	    public void componentShown(ComponentEvent e) {
		SDPresentationView.this.log("============> sd wnd shown ");
	    }
	});
	m_renderer.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd closing ");
	    }
	    
	    public void windowClosed(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd closed ");
	    }
	    
	    public void windowOpened(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd opened ");
	    }
	    
	    public void windowIconified(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd iconified ");
	    }
	    
	    public void windowDeiconified(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd deiconified ");
	    }
	    
	    public void windowActivated(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd activated ");
	    }
	    
	    public void windowDeactivated(WindowEvent e) {
		SDPresentationView.this.log("============> sd wnd deactivated ");
	    }
	});
    }
    
    void initJMS() {
	/* empty */
    }
    
    void refresh() {
	m_renderer.refresh();
    }
    
    void setAsPresenter(boolean bPresenter) {
	m_bIsPresenter = bPresenter;
    }
    
    private boolean getMyViewInfo()
    throws Exception {
	Context ctx = ContextManager.getInitialContext();
	SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	m_sharedletInfo = sharedletManager.getInfo("application/x-sharedlet-sd");
	if (m_sharedletInfo == null)
	    throw new Exception("### getMyViewInfo: cannot get sharedlet info for [application/x-sharedlet-sd]");
	m_viewManager = sharedletManager.getViewManager();
	return m_viewManager != null;
    }
    
    SharedletView getMyView(String viewName)
    throws Exception {
	if ((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo()) {
	    log(String.valueOf(new StringBuffer("==========>> 1 : ").append(m_sharedletInfo).append(", ").append(m_viewManager).append("<<======")));
	    return null;
	}
	Vector views = m_sharedletInfo.getViewInfos();
	if (views == null)
	    throw new Exception("### getMyView: cannot get views for [application/x-sharedlet-sd]");
	SharedletViewInfo viewInfo = null;
	Enumeration enum = views.elements();
    while_5_:
	do {
	    SharedletViewInfo item;
	    do {
		if (!enum.hasMoreElements())
		    break while_5_;
		item = (SharedletViewInfo) enum.nextElement();
	    } while (!item.getID().equals(viewName));
	    viewInfo = item;
	} while (false);
	if (viewInfo == null)
	    throw new Exception(String.valueOf(new StringBuffer("### getMyView: cannot get view named [").append(viewName).append("]")));
	return m_viewManager.getView(viewInfo);
    }
    
    SDEventListenerThread getEventListenerThread() {
	return m_eventListenerThread;
    }
    
    private void err(String ErrMsg, Exception ex) {
	LogManager.err("SDSharedlet::SDPresentationView", ErrMsg, ex);
    }
    
    private void log(String msg) {
	LogManager.log("SDSharedlet::SDPresentationView", msg);
    }
}
