/* ServerTokenService - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sessionserver;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import com.anabas.concepts.User;
import com.anabas.gxo.GMS_Destination;
import com.anabas.gxo.GMS_Message;
import com.anabas.gxo.GMS_MessageListener;
import com.anabas.gxo.GMS_MessageReplyer;
import com.anabas.gxo.GMS_ObjectMessage;
import com.anabas.gxo.GMS_Stream;
import com.anabas.gxo.GMS_StreamPublisher;
import com.anabas.gxo.GMS_StreamSubscriber;
import com.anabas.gxo.GMS_TextMessage;
import com.anabas.gxo.GMS_UserDestinationSelector;
import com.anabas.gxo.GXO_Exception;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.CommunicationService;
import com.anabas.sharedlet.SessionEvent;
import com.anabas.sharedlet.SessionListener;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.Token;
import com.anabas.sharedlet.TokenListener;
import com.anabas.sharedlet.TokenService;
import com.anabas.sharedlet.framework.TokenImpl;
import com.anabas.util.misc.LogManager;

public class ServerTokenService
    implements TokenService, SessionListener, GMS_MessageListener
{
    private static final String s_selfMIMEType = "application/x-sharedletservice-token";
    private Hashtable m_tokens = new Hashtable();
    private Vector m_masters = new Vector();
    private Vector m_lostTokens = new Vector();
    private Context m_context;
    private SessionManager m_sessionManager;
    private CommunicationService m_commService;
    private GMS_Stream m_streamPrivate;
    private GMS_StreamSubscriber m_subscriberPrivate;
    private GMS_Stream m_streamPublic;
    private GMS_StreamPublisher m_publisherPublic;
    
    public void init() {
	m_context = ContextManager.getInitialContext();
	try {
	    m_sessionManager = (SessionManager) m_context.lookup("services/SessionManager");
	    m_sessionManager.addSessionListener(this);
	    m_commService = (CommunicationService) m_context.lookup("services/CommunicationService");
	    m_streamPrivate = m_commService.findStream("application/x-sharedletservice-token/private");
	    if (m_streamPrivate == null)
		m_streamPrivate = m_commService.createStream("application/x-sharedletservice-token/private");
	    m_subscriberPrivate = m_streamPrivate.createSubscriber();
	    m_subscriberPrivate.setMessageListener(this);
	    m_streamPublic = m_commService.findStream("application/x-sharedletservice-token/public");
	    if (m_streamPublic == null)
		m_streamPublic = m_commService.createStream("application/x-sharedletservice-token/public");
	    m_publisherPublic = m_streamPublic.createPublisher();
	} catch (NamingException e) {
	    LogManager.err("TokenService", "Unable to initialize.  Can't find prerequiste service.", e);
	} catch (GXO_Exception e) {
	    LogManager.err("TokenService", "Unable to initialize stream", e);
	}
    }
    
    public short getMode() {
	return (short) 0;
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void shutdown() {
	/* empty */
    }
    
    public void resume() {
	/* empty */
    }
    
    public void requestToken(String name) {
	/* empty */
    }
    
    public void releaseToken(String name) {
	/* empty */
    }
    
    public void giveToken(String name, String target) {
	/* empty */
    }
    
    public void createToken(String name) {
	/* empty */
    }
    
    public void addTokenListener(TokenListener l) {
	/* empty */
    }
    
    public void removeTokenListener(TokenListener l) {
	/* empty */
    }
    
    public Token getToken(String t) {
	return null;
    }
    
    public boolean isOwned(String tokenName) {
	return false;
    }
    
    public void userJoined(SessionEvent e) {
	User u = (User) e.getSource();
	LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("Querying new user ").append(u.getUserID()).append(" mode")));
	sendMessage("query-mode", u.getUserID().toString(), "");
    }
    
    public void userLeft(SessionEvent e) {
	User u = (User) e.getSource();
	String userID = u.getUserID().getID();
	remove(userID, false);
    }
    
    public void onMessage(GMS_Message msg) {
	try {
	    String command = ((GMS_TextMessage) msg).getText();
	    String param = (String) msg.getProperty("1");
	    String id = (String) msg.getProperty("id");
	    if (command.equals("master")) {
		addMaster(id);
		LogManager.log(7, "TokenService", "New master registered ".concat(id));
	    } else if (command.equals("nomaster")) {
		remove(id, true);
		LogManager.log(7, "TokenService", "Old master demoted ".concat(id));
	    } else if (command.equals("request")) {
		synchronized (m_tokens) {
		    TokenInfo t = (TokenInfo) m_tokens.get(param);
		    if (t == null) {
			LogManager.warn("TokenService", "A client asked for a token that does not exist");
			deniedToken(t, id);
		    } else if (t.m_currentOwnerID.equals(id))
			LogManager.log("TokenService", String.valueOf(new StringBuffer(id).append(" asked for a token ").append(t).append(" he already owns")));
		    else {
			boolean isMaster;
			synchronized (m_masters) {
			    isMaster = m_masters.contains(id);
			}
			if (isMaster) {
			    LogManager.log(7, "TokenService", "Master asked for token, release ".concat(String.valueOf(t)));
			    releaseToken(t);
			    grantToken(t, id);
			    LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("Granted master '").append(id).append("' token: ").append(t)));
			} else if (t.m_currentOwnerID.length() <= 0) {
			    grantToken(t, id);
			    LogManager.log(7, "TokenService", "No current owner, granting ".concat(String.valueOf(t)));
			} else {
			    LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("Denied request by '").append(id).append("' for token ").append(t)));
			    deniedToken(t, id);
			}
		    }
		}
	    } else if (command.equals("release")) {
		synchronized (m_tokens) {
		    TokenInfo t = (TokenInfo) m_tokens.get(param);
		    LogManager.log(7, "TokenService", String.valueOf(new StringBuffer(t.m_currentOwnerID).append(" releasing token. Last master=").append(t.m_lastMasterOwnerID)));
		    t.m_currentOwnerID = t.m_lastMasterOwnerID;
		    if (t.m_currentOwnerID.length() > 0)
			grantToken(t, t.m_currentOwnerID);
		}
	    } else if (command.equals("create"))
		createToken(param, id);
	    else if (command.equals("give")) {
		String param2 = (String) msg.getProperty("2");
		synchronized (m_tokens) {
		    TokenInfo t = (TokenInfo) m_tokens.get(param);
		    if (t == null)
			LogManager.err("TokenService", String.valueOf(new StringBuffer("Attempted to give away non existent token: ").append(param).append(" by ").append(param2)));
		    else
			giveToken(t, param2, id);
		}
	    } else if (command.equals("status"))
		sendStatus(id);
	} catch (GXO_Exception e) {
	    LogManager.err("TokenService", "Error reading command: ".concat(String.valueOf(msg)), e);
	}
    }
    
    public void onRequest(GMS_Message msg, GMS_MessageReplyer replyer) {
	/* empty */
    }
    
    private void sendStatus(String target) {
	synchronized (m_tokens) {
	    Vector v = new Vector(m_tokens.size());
	    Enumeration enum = m_tokens.elements();
	    while (enum.hasMoreElements())
		v.addElement(((TokenInfo) enum.nextElement()).m_token);
	    sendMessage("status", target, v);
	}
    }
    
    private void addMaster(String masterID) {
	synchronized (m_masters) {
	    if (m_masters.contains(masterID)) {
		/* empty */
	    } else {
		m_masters.addElement(masterID);
		while (m_lostTokens.size() > 0) {
		    TokenInfo t = (TokenInfo) m_lostTokens.elementAt(0);
		    m_lostTokens.removeElementAt(0);
		    t.m_lastMasterOwnerID = masterID;
		    LogManager.log("TokenService", String.valueOf(new StringBuffer("Granting new master ").append(masterID).append(" lost token: ").append(t)));
		    grantToken(t, masterID);
		}
	    }
	}
    }
    
    private void remove(String userID, boolean masterOnly) {
	boolean isMaster;
	synchronized (m_masters) {
	    isMaster = m_masters.removeElement(userID);
	}
	Enumeration enum = m_tokens.elements();
	while (enum.hasMoreElements()) {
	    TokenInfo t = (TokenInfo) enum.nextElement();
	    synchronized (m_tokens) {
		if (isMaster && t.m_lastMasterOwnerID.equals(userID)) {
		    synchronized (m_masters) {
			if (m_masters.size() > 0)
			    t.m_lastMasterOwnerID = (String) m_masters.elementAt(0);
			else
			    t.m_lastMasterOwnerID = "";
		    }
		}
		if (!masterOnly && t.m_currentOwnerID.equals(userID)) {
		    if (t.m_lastMasterOwnerID.length() > 0) {
			grantToken(t, t.m_lastMasterOwnerID);
			LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("User ").append(userID).append(" left. Token ").append(t).append(" is granted to last master ").append(t.m_lastMasterOwnerID)));
		    } else {
			m_lostTokens.addElement(t);
			LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("Token ").append(t).append(" is now lost until new master arrives")));
		    }
		}
	    }
	}
    }
    
    private void giveToken(TokenInfo token, String dst, String requestor) {
	if (m_masters.contains(requestor))
	    grantToken(token, dst);
	else if (token.m_currentOwnerID.equals(requestor) && m_masters.contains(dst))
	    grantToken(token, dst);
	else {
	    LogManager.log(8, "TokenService", String.valueOf(new StringBuffer("Denied token ").append(token).append(" to ").append(requestor)));
	    deniedToken(token, requestor);
	}
    }
    
    private void createToken(String tokenName, String creator) {
	synchronized (m_masters) {
	    if (!m_masters.contains(creator)) {
		LogManager.err("TokenService", String.valueOf(new StringBuffer("A non registered master '").append(creator).append("' tried to create token ").append(tokenName)));
		sendMessage("denied", creator, tokenName);
		return;
	    }
	}
	TokenInfo t = (TokenInfo) m_tokens.get(tokenName);
	if (t == null) {
	    t = new TokenInfo();
	    t.m_token = new TokenImpl(tokenName);
	    t.m_currentOwnerID = "";
	    t.m_lastMasterOwnerID = creator;
	    synchronized (m_tokens) {
		m_tokens.put(tokenName, t);
	    }
	    grantToken(t, creator);
	    LogManager.log(7, "TokenService", String.valueOf(new StringBuffer("Created token ").append(t).append(" and given to ").append(creator)));
	} else
	    LogManager.log(7, "TokenService", String.valueOf(new StringBuffer(creator).append(" attempted to create token ").append(t).append(" but token already exists")));
    }
    
    private void grantToken(TokenInfo token, String target) {
	((TokenImpl) token.m_token).incrementID();
	if (m_masters.contains(token.m_currentOwnerID))
	    token.m_lastMasterOwnerID = token.m_currentOwnerID;
	token.m_currentOwnerID = target;
	sendMessage("grant", target, token.m_token);
    }
    
    private void deniedToken(TokenInfo token, String target) {
	sendMessage("denied", target, token == null ? "<none>" : token.m_token.getName());
    }
    
    private void releaseToken(TokenInfo token) {
	String lastOwner = token.m_currentOwnerID;
	sendMessage("release", lastOwner, token.m_token.getName());
	token.m_currentOwnerID = "";
    }
    
    private void sendMessage(String reply, String targetID, Serializable obj) {
	try {
	    GMS_ObjectMessage msg = (GMS_ObjectMessage) m_publisherPublic.createMessage((short) 0, (short) 3);
	    msg.setProperty("c", reply);
	    msg.setProperty("id", targetID);
	    msg.setObject(obj);
	    if (reply.equals("grant"))
		sendMessage(msg, "*");
	    else
		sendMessage(msg, targetID);
	    LogManager.log("TokenService", String.valueOf(new StringBuffer("Send message '").append(reply).append(" to [").append(targetID).append("] for token (").append(obj).append(")")));
	} catch (GXO_Exception e) {
	    LogManager.err("TokenService", String.valueOf(new StringBuffer("Error with message '").append(reply).append(" to [").append(targetID).append("] for token (").append(obj).append(")")));
	}
    }
    
    private void sendMessage(GMS_Message msg, String targetID)
    throws GXO_Exception {
	if (targetID.equals("*"))
	    m_publisherPublic.broadcast(msg);
	else {
	    GMS_UserDestinationSelector s = (GMS_UserDestinationSelector) m_publisherPublic.createDestinationSelector("GMS_UserDestinationSelector");
	    s.setUserID(targetID);
	    GMS_Destination dst = m_streamPublic.findDestination(s);
	    m_publisherPublic.sendMessage(msg, dst);
	}
    }
    
    private void sendMessage(String reply, String targetID, String token) {
	try {
	    GMS_TextMessage msg = (GMS_TextMessage) m_publisherPublic.createMessage((short) 0, (short) 1);
	    msg.setProperty("c", reply);
	    msg.setProperty("id", targetID);
	    msg.setText(token);
	    sendMessage(msg, targetID);
	    LogManager.log("TokenService", String.valueOf(new StringBuffer("Send message '").append(reply).append(" to [").append(targetID).append("] for token (").append(token).append(")")));
	} catch (GXO_Exception e) {
	    LogManager.err("TokenService", String.valueOf(new StringBuffer("Error with message '").append(reply).append(" to [").append(targetID).append("] for token (").append(token).append(")")));
	}
    }
}
