/* ShutdownService - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sessionserver;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.naming.NamingException;
import com.anabas.sharedlet.SessionEvent;
import com.anabas.sharedlet.SessionListener;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.SharedletService;
import com.anabas.util.misc.LogManager;

public class ShutdownService
    implements SharedletService
{
    private Context m_context;
    private long m_waitMins = 30L;
    private MySessionListener m_myListener;
    
    private class MySessionListener
	implements SessionListener
    {
	protected ShutdownThread m_shutdownThread;
	
	private MySessionListener() {
	    /* empty */
	}
	
	public void userJoined(SessionEvent e) {
	    try {
		SessionManager sm = (SessionManager) m_context.lookup("services/SessionManager");
		if (m_shutdownThread.isAlive()) {
		    LogManager.log(5, "ShutdownService", "User Joined. Cancel shutdown");
		    m_shutdownThread.setShutdown(false);
		}
	    } catch (NamingException ex) {
		LogManager.err("ShutdownService", "can't find sessionManager", ex);
	    }
	}
	
	public void userLeft(SessionEvent e) {
	    try {
		SessionManager sm = (SessionManager) m_context.lookup("services/SessionManager");
		LogManager.log(0, "ShutdownService", "UserLeft,total user:".concat(String.valueOf(sm.getParticipants().size())));
		if (sm.getParticipants().size() <= 0) {
		    m_shutdownThread.setShutdown(true);
		    LogManager.log(0, "ShutdownService", String.valueOf(new StringBuffer("Sleep ").append(m_waitMins).append(" minuts Then Shutdown If no user join.")));
		}
	    } catch (NamingException ex) {
		LogManager.err("ShutdownService", "can't find sessionManager", ex);
	    }
	}
	
	/*synthetic*/  MySessionListener($1 x$1) {
	    this();
	}
    }
    
    private class ShutdownThread
	extends Thread
    {
	private boolean freshStart = true;
	private long m_shutdownTime = System.currentTimeMillis() + m_waitMins * (long) 60 * (long) 1000;
	boolean m_stop = true;
	
	private ShutdownThread() {
	    /* empty */
	}
	
	public void run() {
	    try {
		for (;;) {
		    Thread.sleep(60000L);
		    if (m_stop && System.currentTimeMillis() >= m_shutdownTime) {
			if (freshStart)
			    LogManager.log(0, "ShutdownServer", "Shutting down due to no one joining");
			shutdown();
			LogManager.log(0, "ShutdownService", "Shut Down This Session");
			System.exit(0);
		    }
		}
	    } catch (InterruptedException ex) {
		LogManager.err("ShutdownService", "sleep interrupted", ex);
	    }
	}
	
	public synchronized void setShutdown(boolean value) {
	    freshStart = false;
	    if (value)
		m_shutdownTime = System.currentTimeMillis() + m_waitMins * (long) 60 * (long) 1000;
	    m_stop = value;
	}
	
	/*synthetic*/  ShutdownThread($1 x$1) {
	    this();
	}
    }
    
    public void init() {
	m_context = ContextManager.getInitialContext();
	try {
	    String shutdownMinutes = (String) m_context.lookup("session_param/shutdownMinutes");
	    m_waitMins = (long) Integer.parseInt(shutdownMinutes);
	} catch (NamingException e) {
	    LogManager.err("ShutdownService ", "Unable to get shutdown parameter");
	}
	m_myListener = new MySessionListener(null);
	try {
	    ((SessionManager) m_context.lookup("services/SessionManager")).addSessionListener(m_myListener);
	} catch (NamingException e) {
	    LogManager.err("ShutdownService ", "Unable to get SessionManager");
	}
	m_myListener.m_shutdownThread = new ShutdownThread(null);
	m_myListener.m_shutdownThread.start();
    }
    
    public void shutdown() {
	SharedletService[] services = DefaultSessionLogicServer.s_services;
	for (int i = services.length - 1; i >= 0; i--) {
	    try {
		if (services[i] != null && !(services[i] instanceof ShutdownService)) {
		    LogManager.log(0, "ShutdownService", "Shutting down ".concat(String.valueOf(services[i])));
		    services[i].shutdown();
		}
	    } catch (Exception e) {
		LogManager.err("ShutdownService", "Error while shutting down ".concat(String.valueOf(services[i])), e);
	    }
	}
	try {
	    LogManager.log("ShutdownService", "Shutting down shutdown thread");
	    m_myListener.m_shutdownThread.interrupt();
	    LogManager.log("ShutdownService", "Shutdown thread dead...sleeping 2 seconds.");
	    Thread.sleep(2000L);
	} catch (Exception exception_2_0_) {
	    /* empty */
	}
	LogManager.log("ShutdownService", "Exiting.....");
	System.exit(0);
    }
    
    public void suspend() {
	/* empty */
    }
    
    public void resume() {
	/* empty */
    }
}
