/* SDControlView - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sdsharedlet;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;

import com.anabas.concepts.User;
import com.anabas.concepts.UserID;
import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.sharedlet.CapabilitiesManager;
import com.anabas.sharedlet.CapabilityListener;
import com.anabas.sharedlet.JavaViewRenderer;
import com.anabas.sharedlet.LayoutService;
import com.anabas.sharedlet.SessionEvent;
import com.anabas.sharedlet.SessionListener;
import com.anabas.sharedlet.SessionManager;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletViewInfo;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.sharedlet.SharedletViewRenderer;
import com.anabas.sharedlet.framework.DefaultCapabilitiesManager;
import com.anabas.util.io.StreamUtil;
import com.anabas.util.misc.LogManager;
import com.anabas.util.nativeutils.NativeUtilsWrapper;

public class SDControlView
    extends JPanel
    implements SharedletView, CapabilityListener, ActionListener, SessionListener
{
    private static final int VIEW_WIDTH = 150;
    private static final int VIEW_HEIGHT = 35;
    private static final int COMBO_WIDTH = 148;
    private static final int COMBO_HEIGHT = 22;
    private static final String ACTION_COMMAND_PAUSE = "a";
    private static final String ACTION_COMMAND_CLICK_TO_SHARE = "b";
    private static final String ACTION_COMMAND_SD_APP_LIST = "c";
    private static final String ACTION_COMMAND_RESUME = "d";
    private static final String ACTION_COMMAND_SD_CUR_APP_LIST = "e";
    private static final String ACTION_COMMAND_LIST_ALL_APPS = "f";
    private static final String ACTION_COMMAND_HILIGHT = "g";
    private static final String ACTION_COMMAND_MARKER = "h";
    private static final String ACTION_COMMAND_CLEAR = "i";
    private static final String PAUSE_IMAGE = "Pause.gif";
    private static final String CLICK_TO_SHARE_IMAGE = "ClickToShare.gif";
    private static final String SHOW_ALL_APPS_IMAGE = "share.gif";
    private static final String HIGHLIGHT_IMAGE = "Highlight.gif";
    private static final String MARKER_IMAGE = "Marker.gif";
    private static final String CLEAR_ANNOTATION_IMAGE = "ClearAll.gif";
    private static final String PAUSEPRESSED_IMAGE = "PausePressed.gif";
    private static final String PAUSE_TOOLTIP = "Pause";
    private static final String CLICK_TO_SHARE_TOOLTIP = "Click to Share";
    private static final String SHOW_ALL_APPS_TOOLTIP = "Show All Applications";
    private static final String HIGHLIGHT_TOOLTIP = "Highlight";
    private static final String MARKER_TOOLTIP = "Marker";
    private static final String CLEAR_ANNOTATION_TOOLTIP = "Clear All";
    private static final String RESUME_TOOLTIP = "Resume";
    private static final Color SELECTED_BUTTON_COLOR = new Color(170, 170, 170);
    private static final Border EMPTY_BORDER = new EmptyBorder(2, 2, 2, 2);
    private int m_lastActivatedWnd = 0;
    private boolean m_bHost = false;
    private boolean m_bParticipant = false;
    private boolean m_bAnnotating = false;
    private boolean m_bRemoveURL = false;
    private String m_role;
    private Hashtable m_ht_sdAppList = new Hashtable();
    private Hashtable m_ht_curAppList = new Hashtable();
    private SharedletInfo m_sharedletInfo;
    private SharedletViewManager m_viewManager;
    private SharedletManager m_sharedletManager;
    private SDSharedlet m_sdsharedlet;
    private User m_thisUser;
    private JavaViewRenderer m_renderer;
    private CapabilitiesManager m_capabilitiesManager;
    private SessionManager m_sessionManager;
    private LayoutService m_layoutService;
    private SDWrapper m_sdWrapper;
    private NativeUtilsWrapper m_nativeUtils;
    private SDEventListenerThread m_eventListenerThread;
    private SDPresentationView m_presentationView;
    private NativeUtilsWrapper.SharedAppInfo m_curAppInfo;
    private ImageIcon m_pauseIcon;
    private ImageIcon m_resumeIcon;
    private JLabel m_label1 = new JLabel("Shared Applications");
    private JComboBox m_cb_sdAppList = new JComboBox();
    private JButton m_pauseResumeButton = new JButton();
    private JButton m_clickToShareButton = new JButton();
    private JButton m_AllAppsButton = new JButton();
    private JButton m_HilightButton = new JButton();
    private JButton m_MarkerButton = new JButton();
    private JButton m_ClearAnnotButton = new JButton();
    private JPanel MainPanel;
    private JButton m_pressedButton;
    private SDCurAppsDialog m_curAppsDialog;
    private JFrame m_mainFrame;
    static Class class$com$anabas$sdsharedlet$SDControlView;
    
    public SDControlView() {
	log("Creating ControlView ...");
	m_sdWrapper = new SDWrapper(this);
	m_nativeUtils = new NativeUtilsWrapper();
	m_renderer = new JavaViewRenderer(this, this);
	getServices();
	jbInit();
    }
    
    public void activate() {
	boolean canAnnotate = canAnnotate();
	m_mainFrame = SDNativeRenderer.getMainFrame(this);
	log(String.valueOf(new StringBuffer("activate: called  with Annotation set to [").append(canAnnotate).append("]")));
	m_curAppsDialog = new SDCurAppsDialog(m_sdWrapper, m_mainFrame);
	if (m_layoutService == null)
	    getLayoutService();
	m_sdWrapper.enableAnnotation(canAnnotate);
	enableAnnotationButtons(canAnnotate);
    }
    
    public void deactivate() {
	log("deactivate: called ");
	if (m_curAppsDialog != null)
	    m_curAppsDialog.dispose();
    }
    
    public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand().equals("d"))
	    resumePressed();
	else if (e.getActionCommand().equals("a"))
	    pausePressed();
	else if (e.getActionCommand().equals("b"))
	    clickToSharePressed();
	else if (e.getActionCommand().equals("c"))
	    appSelected();
	else if (e.getActionCommand().equals("f"))
	    listAllAppsPressed();
	else if (e.getActionCommand().equals("g"))
	    hilightPressed();
	else if (e.getActionCommand().equals("h"))
	    markerPressed();
	else if (e.getActionCommand().equals("i"))
	    clearPressed();
    }
    
    private void clearPressed() {
	log("Clear pressed ...");
	endAnnotation();
	m_sdWrapper.clearAnnotations();
    }
    
    private void resumePressed() {
	log("Resume pressed ...");
	enableSDButtons(true);
	enableAnnotationButtons(canAnnotate());
	m_pauseResumeButton.setToolTipText("Pause");
	pressPauseResumeButton(false);
	m_pauseResumeButton.setActionCommand("a");
	m_sdWrapper.pauseCapture(false);
    }
    
    private void pausePressed() {
	log("Pause pressed ...");
	pressPauseResumeButton(true);
	m_AllAppsButton.setEnabled(false);
	enableAnnotationButtons(false);
	m_pauseResumeButton.setToolTipText("Resume");
	m_pauseResumeButton.setActionCommand("d");
	m_sdWrapper.pauseCapture(true);
    }
    
    private void pressPauseResumeButton(boolean press) {
	ImageIcon icon = press ? m_resumeIcon : m_pauseIcon;
	m_pauseResumeButton.setIcon(icon);
    }
    
    private void enableSDButtons(boolean enable) {
	m_label1.setEnabled(enable);
	m_AllAppsButton.setEnabled(enable);
	m_pauseResumeButton.setEnabled(enable);
    }
    
    private void setButtonPressed(JComponent component) {
	component.setBackground(SELECTED_BUTTON_COLOR);
	Color background = component.getBackground();
	Color highlight = component.getBackground().brighter().brighter();
	Color shadow = component.getBackground().darker().darker();
	Border b = new BevelBorder(1, highlight, background, shadow, background);
	component.setBorder(b);
    }
    
    private void clickToSharePressed() {
	log("Click to Share pressed ...");
	if (!m_clickToShareButton.isSelected()) {
	    setButtonPressed(m_clickToShareButton);
	    m_clickToShareButton.setSelected(true);
	    m_sdWrapper.ClickToShare(0, 0);
	}
    }
    
    private void listAllAppsPressed() {
	log("List All Apps Pressed");
	m_ht_curAppList = m_nativeUtils.getCurApps();
	int iCount = 0;
	Enumeration enum = m_ht_curAppList.elements();
	while (enum.hasMoreElements()) {
	    enum.nextElement();
	    iCount++;
	}
	log(String.valueOf(new StringBuffer("Total #of current apps [").append(iCount).append("]")));
	Object[] apps = new Object[iCount];
	enum = m_ht_curAppList.elements();
	iCount = 0;
	while (enum.hasMoreElements()) {
	    Object item = enum.nextElement();
	    apps[iCount++] = item;
	}
	m_curAppsDialog.setLocation(calculateDialogPos());
	NativeUtilsWrapper.SharedAppInfo curApp = null;
	m_curAppsDialog.show(apps);
    }
    
    private Point calculateDialogPos() {
	if (m_layoutService != null || getLayoutService() && m_mainFrame != null) {
	    Point pt1 = m_mainFrame.getLocationOnScreen();
	    Point pt2 = new Point(0, 0);
	    Point CentrePt = new Point(0, 0);
	    log(String.valueOf(new StringBuffer("######### calculateDialogPos: Got main frame Position [").append(pt1).append("] ########")));
	    Dimension d = m_mainFrame.getSize();
	    log(String.valueOf(new StringBuffer("######### calculateDialogPos: Got main frame size [").append(d).append("] ########")));
	    pt2.x = pt1.x + d.width;
	    pt2.y = pt1.y + d.height;
	    CentrePt.x = pt1.x + (pt2.x - pt1.x) / 2;
	    CentrePt.y = pt1.y + (pt2.y - pt1.y) / 2;
	    Dimension dim = m_curAppsDialog.getDimension();
	    return new Point(CentrePt.x - dim.width / 2, CentrePt.y - dim.height / 2);
	}
	log("######### calculateDialogPos: cannot get Layout Service ###########");
	return new Point(0, 0);
    }
    
    private void appSelected() {
	NativeUtilsWrapper.SharedAppInfo appInfo = (NativeUtilsWrapper.SharedAppInfo) m_cb_sdAppList.getSelectedItem();
	if (appInfo != null && m_curAppInfo != appInfo) {
	    m_curAppInfo = appInfo;
	    String str = appInfo.getName();
	    int app_id = appInfo.getId();
	    m_sdWrapper.ClickToShare(app_id, 3);
	}
    }
    
    private void hilightPressed() {
	log("Hilight pressed ...");
	if (!m_HilightButton.isSelected()) {
	    endAnnotation();
	    m_bAnnotating = true;
	    setButtonPressed(m_HilightButton);
	    m_HilightButton.setSelected(true);
	    log("Calling Hilight on SDWrapper ...");
	    m_sdWrapper.hilight();
	}
    }
    
    private void markerPressed() {
	log("Marker pressed ...");
	if (!m_MarkerButton.isSelected()) {
	    endAnnotation();
	    m_bAnnotating = true;
	    setButtonPressed(m_MarkerButton);
	    m_MarkerButton.setSelected(true);
	    m_sdWrapper.mark();
	}
    }
    
    void endAnnotation() {
	JButton pressedBut = m_HilightButton.isSelected() ? m_HilightButton : m_MarkerButton.isSelected() ? m_MarkerButton : null;
	if (pressedBut != null) {
	    depressButton(pressedBut);
	    pressedBut.setSelected(false);
	    m_bAnnotating = false;
	}
    }
    
    private void depressButton(JComponent component) {
	component.setBackground(getBackground());
	clearBorder(component);
    }
    
    private void clearBorder(JComponent component) {
	component.setBorder(EMPTY_BORDER);
    }
    
    public SharedletViewRenderer getRenderer(String MIMEType) {
	if (MIMEType.equals("application/java"))
	    return m_renderer;
	return null;
    }
    
    public void userJoined(SessionEvent e) {
	User user = (User) e.getSource();
	log(String.valueOf(new StringBuffer("New user joined [").append(user.getFirstName()).append("]")));
    }
    
    public void userLeft(SessionEvent e) {
	User user = (User) e.getSource();
	log(String.valueOf(new StringBuffer("User left [").append(user.getFirstName()).append("]")));
    }
    
    public String getSharedletMIME() {
	return "application/x-sharedlet-sd";
    }
    
    public void remoteCapabilityChanged(String capability, boolean enabled, UserID userid) {
	log(String.valueOf(new StringBuffer("Remote capability [").append(capability).append("] of user [").append(userid.getID()).append("] is [").append(enabled).append("]")));
    }
    
    public void capabilityChanged(String capability, boolean enabled) {
	log(String.valueOf(new StringBuffer("My '").append(capability).append("' is now ").append(enabled)));
	if (capability.equals("1:input_control"))
	    enableInputControl(enabled);
	else if (capability.equals("annotation"))
	    enableAnnotationCapability(enabled);
	else if (capability.equals("1:presentation"))
	    enablePresentationCapability(enabled);
	else
	    log("Capability changed to : Unknown : ".concat(capability));
    }
    
    public void roleChanged(String newRole) {
	log(String.valueOf(new StringBuffer("roleChanged: ==========> My Role changed to [").append(newRole).append("]")));
	if (m_presentationView != null || getPresentationView() != null)
	    m_presentationView.refresh();
    }
    
    void enableAnnotationButtons(boolean enable) {
	m_HilightButton.setEnabled(enable);
	m_MarkerButton.setEnabled(enable);
	m_ClearAnnotButton.setEnabled(enable);
    }
    
    void enableAnnotationCapability(boolean enable) {
	log(String.valueOf(new StringBuffer("calling enable Annotation on SDWrapper with [").append(enable).append("]")));
	boolean ret = m_sdWrapper.enableAnnotation(enable);
	log(String.valueOf(new StringBuffer("enableAnnotation: returned : [").append(ret).append("]")));
	enableAnnotationButtons(enable);
    }
    
    private void enableInputControl(boolean enable) {
	m_sdWrapper.EnableInputControl(enable, getToken("1:input_control"));
    }
    
    private void enablePresentationCapability(boolean enable) {
	if (enable)
	    m_sdWrapper.listen(getToken("1:presentation"));
	else
	    m_sdWrapper.connect(getToken("1:presentation"));
	if (m_eventListenerThread != null || getEventListenerThread())
	    m_eventListenerThread.startRFUThread(enable);
	if (m_presentationView != null || getPresentationView() != null) {
	    log(String.valueOf(new StringBuffer("!!!!!!!!!!!!!!!!!!!! seting presenter as [").append(enable).append("] !!!!!!!!!!!!!!!!!!!!!!!!")));
	    m_presentationView.setAsPresenter(enable);
	}
	enableSDButtons(enable);
    }
    
    private void jbInit() {
	Dimension d = new Dimension(150, 35);
	setPreferredSize(d);
	setLayout(new GridBagLayout());
	MainPanel = new JPanel();
	MainPanel.setLayout(new GridBagLayout());
	addImageButtons(MainPanel);
	constrain(this, MainPanel, 1, 1, 5, 2, 0, 10, 1.0, 0.0, 0, 0, 0, 0);
	enableAnnotationButtons(canAnnotate());
	enableSDButtons(canPresent());
	try {
	    m_pauseIcon = new ImageIcon(StreamUtil.inputStreamToBytes((class$com$anabas$sdsharedlet$SDControlView == null ? class$com$anabas$sdsharedlet$SDControlView = class$("com.anabas.sdsharedlet.SDControlView") : class$com$anabas$sdsharedlet$SDControlView).getResourceAsStream("Pause.gif")));
	    m_resumeIcon = new ImageIcon(StreamUtil.inputStreamToBytes((class$com$anabas$sdsharedlet$SDControlView == null ? class$com$anabas$sdsharedlet$SDControlView = class$("com.anabas.sdsharedlet.SDControlView") : class$com$anabas$sdsharedlet$SDControlView).getResourceAsStream("PausePressed.gif")));
	} catch (Exception ex) {
	    err("Error: loading button image icons: ", ex);
	}
    }
    
    private void addImageButtons(Container panel) {
	Dimension ButtonSize = new Dimension(24, 24);
	ImageIcon icon = null;
	JButton[] buttons = {
	    m_AllAppsButton, m_pauseResumeButton, m_HilightButton, m_MarkerButton, m_ClearAnnotButton
	};
	String[] defaultIcons = {
	    "share.gif", "Pause.gif", "Highlight.gif", "Marker.gif", "ClearAll.gif"
	};
	String[] tooltips = {
	    "Show All Applications", "Pause", "Highlight", "Marker", "Clear All"
	};
	String[] actionCommands = {
	    "f", "a", "g", "h", "i"
	};
	try {
	    java.awt.event.MouseListener mouseListener = new MouseAdapter() {
		public void mouseEntered(MouseEvent e) {
		    JButton but = (JButton) e.getSource();
		    if (!but.isSelected()) {
			Color background = but.getBackground();
			Color highlight = but.getBackground().brighter().brighter();
			Color shadow = but.getBackground().darker().darker();
			Border b = new BevelBorder(0, highlight, background, shadow, background);
			if (but.isEnabled())
			    but.setBorder(b);
		    }
		}
		
		public void mouseExited(MouseEvent e) {
		    JButton but = (JButton) e.getSource();
		    if (!but.isSelected() && but.isEnabled())
			SDControlView.this.clearBorder(but);
		}
	    };
	    for (int ButtonCount = 0; ButtonCount < buttons.length; ButtonCount++) {
		icon = new ImageIcon(StreamUtil.inputStreamToBytes((class$com$anabas$sdsharedlet$SDControlView == null ? class$com$anabas$sdsharedlet$SDControlView = class$("com.anabas.sdsharedlet.SDControlView") : class$com$anabas$sdsharedlet$SDControlView).getResourceAsStream(defaultIcons[ButtonCount])));
		buttons[ButtonCount].setIcon(icon);
		clearBorder(buttons[ButtonCount]);
		buttons[ButtonCount].setFocusPainted(false);
		buttons[ButtonCount].setToolTipText(tooltips[ButtonCount]);
		buttons[ButtonCount].setActionCommand(actionCommands[ButtonCount]);
		buttons[ButtonCount].addActionListener(this);
		buttons[ButtonCount].addMouseListener(mouseListener);
		buttons[ButtonCount].setMaximumSize(ButtonSize);
		buttons[ButtonCount].setMinimumSize(ButtonSize);
		buttons[ButtonCount].setPreferredSize(ButtonSize);
		constrain(panel, buttons[ButtonCount], ButtonCount, 1, 1, 1, 0, 15, 0.0, 1.0, 2, 0, 0, 0);
	    }
	} catch (IOException ex) {
	    err("setButtonImages: Error", ex);
	}
    }
    
    boolean canAnnotate() {
	return m_capabilitiesManager.isCapable("application/x-sharedlet-sd", "annotation");
    }
    
    boolean canPresent() {
	return m_capabilitiesManager.isCapable("application/x-sharedlet-sd", "1:presentation");
    }
    
    private void constrain(Container container, Component component, int grid_x, int grid_y, int grid_width, int grid_height, int fill, int anchor, double weight_x, double weight_y, int top, int left, int bottom, int right) {
	GridBagConstraints c = new GridBagConstraints();
	c.gridx = grid_x;
	c.gridy = grid_y;
	c.gridwidth = grid_width;
	c.gridheight = grid_height;
	c.fill = fill;
	c.anchor = anchor;
	c.weightx = weight_x;
	c.weighty = weight_y;
	if (top + bottom + left + right > 0)
	    c.insets = new Insets(top, left, bottom, right);
	((GridBagLayout) container.getLayout()).setConstraints(component, c);
	container.add(component);
    }
    
    private boolean getLayoutService() {
	try {
	    Context ctx = ContextManager.getInitialContext();
	    m_layoutService = (LayoutService) ctx.lookup("services/LayoutService");
	} catch (Exception ex) {
	    boolean bool_2_3_ = false;
	    return bool_2_3_;
	}
	return true;
    }
    
    void enableRemoveURL(boolean enable) {
	m_bRemoveURL = enable;
    }
    
    int[] getSharedWnds() {
	int apps = m_ht_sdAppList.size();
	int[] ids = new int[apps];
	int iCount = 0;
	Enumeration enum = m_ht_sdAppList.keys();
	while (enum.hasMoreElements()) {
	    Integer id = (Integer) enum.nextElement();
	    ids[iCount++] = id.intValue();
	}
	return ids;
    }
    
    void updateApplication(int id, String strTitle, int command) {
	if (m_clickToShareButton.isSelected()) {
	    log("depressing Click-To-Share button ...");
	    depressButton(m_clickToShareButton);
	    m_clickToShareButton.setSelected(false);
	}
	NativeUtilsWrapper.SharedAppInfo appInfo = null;
	Integer key = null;
	switch (command) {
	case 0:
	    log("updateApplication: Adding application : ".concat(strTitle));
	    appInfo = new NativeUtilsWrapper.SharedAppInfo(id, strTitle);
	    m_ht_sdAppList.put(new Integer(id), appInfo);
	    m_cb_sdAppList.removeActionListener(this);
	    m_cb_sdAppList.addItem(appInfo);
	    m_cb_sdAppList.setSelectedItem(appInfo);
	    m_curAppInfo = appInfo;
	    m_cb_sdAppList.addActionListener(this);
	    break;
	case 1:
	    log("updateApplication: Activating application : ".concat(strTitle));
	    key = new Integer(id);
	    appInfo = (NativeUtilsWrapper.SharedAppInfo) m_ht_sdAppList.get(key);
	    if (appInfo != null) {
		m_lastActivatedWnd = id;
		m_cb_sdAppList.removeActionListener(this);
		m_cb_sdAppList.setSelectedItem(appInfo);
		m_curAppInfo = appInfo;
		m_cb_sdAppList.addActionListener(this);
	    } else
		log(String.valueOf(new StringBuffer("updateApplication: Got invalid id from natie code while activating app [").append(strTitle).append("]")));
	    break;
	case 2:
	    log("updateApplication: Removing application : ".concat(strTitle));
	    key = new Integer(id);
	    if (m_bRemoveURL)
		m_sdsharedlet.removeURL(key);
	    appInfo = (NativeUtilsWrapper.SharedAppInfo) m_ht_sdAppList.get(key);
	    if (appInfo != null) {
		m_ht_sdAppList.remove(key);
		m_cb_sdAppList.removeItem(appInfo);
	    } else
		log(String.valueOf(new StringBuffer("updateApplication: Got invalid id from natie code while removing app [").append(strTitle).append("]")));
	    break;
	case 4:
	    log("updateApplication: application closed: ".concat(strTitle));
	    break;
	case 5:
	    log("updateApplication: application share cancelled: ".concat(strTitle));
	    break;
	default:
	    log(String.valueOf(new StringBuffer("updateApplication: updating application [").append(strTitle).append("]")));
	    log(String.valueOf(new StringBuffer("Unknow command [").append(command).append("] while updating application ...")));
	}
    }
    
    private boolean getServices() {
	try {
	    Context ctx = ContextManager.getInitialContext();
	    m_capabilitiesManager = (CapabilitiesManager) ctx.lookup("services/CapabilitiesManager");
	    m_capabilitiesManager.addCapabilityListener(this);
	    m_role = m_capabilitiesManager.getRole("application/x-sharedlet-sd");
	    if (m_role == null)
		log("Could not get role from the Capabilities manager ...");
	    else {
		log(String.valueOf(new StringBuffer("My role is [").append(m_role).append("]")));
		if (m_role.equals("Host"))
		    m_bHost = true;
		else if (m_role.equals("Participant"))
		    m_bParticipant = true;
	    }
	    m_sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	    m_sdsharedlet = (SDSharedlet) m_sharedletManager.getSharedlet(m_sharedletManager.getInfo("application/x-sharedlet-sd"));
	    m_sessionManager = (SessionManager) ctx.lookup("services/SessionManager");
	    m_sessionManager.addSessionListener(this);
	    m_thisUser = m_sessionManager.getMyUser();
	    log(String.valueOf(new StringBuffer("The current user is [").append(m_thisUser.getFirstName()).append("]")));
	} catch (Exception ex) {
	    err("getServices: Error", ex);
	    boolean bool_2_4_ = false;
	    return bool_2_4_;
	}
	return true;
    }
    
    SDWrapper getSDWrapper() {
	return m_sdWrapper;
    }
    
    Object getPresentationView() {
	try {
	    m_presentationView = (SDPresentationView) getMyView("sd_presentation_view");
	} catch (Exception ex) {
	    err("getPresentationView: Error: ", ex);
	}
	return m_presentationView;
    }
    
    int getLastActivatedWnd() {
	return m_lastActivatedWnd;
    }
    
    boolean getEventListenerThread() {
	if (m_presentationView != null || getPresentationView() != null)
	    m_eventListenerThread = m_presentationView.getEventListenerThread();
	return m_eventListenerThread != null;
    }
    
    long getToken(String capability) {
	DefaultCapabilitiesManager defLayoutService = (DefaultCapabilitiesManager) m_capabilitiesManager;
	return defLayoutService.getAtomicCapabilityNumber("application/x-sharedlet-sd", capability);
    }
    
    private boolean getMyViewInfo()
    throws Exception {
	Context ctx = ContextManager.getInitialContext();
	SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	m_sharedletInfo = sharedletManager.getInfo("application/x-sharedlet-sd");
	if (m_sharedletInfo == null)
	    throw new Exception("### getMyViewInfo: cannot get sharedlet info for [application/x-sharedlet-sd]");
	m_viewManager = sharedletManager.getViewManager();
	return m_viewManager != null;
    }
    
    SharedletView getMyView(String viewName)
    throws Exception {
	if ((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo()) {
	    log(String.valueOf(new StringBuffer("==========>> 1 : ").append(m_sharedletInfo).append(", ").append(m_viewManager).append("<<======")));
	    return null;
	}
	Vector views = m_sharedletInfo.getViewInfos();
	if (views == null)
	    throw new Exception("### getMyView: cannot get views for [application/x-sharedlet-sd]");
	SharedletViewInfo viewInfo = null;
	Enumeration enum = views.elements();
    while_0_:
	do {
	    SharedletViewInfo item;
	    do {
		if (!enum.hasMoreElements())
		    break while_0_;
		item = (SharedletViewInfo) enum.nextElement();
	    } while (!item.getID().equals(viewName));
	    viewInfo = item;
	} while (false);
	if (viewInfo == null)
	    throw new Exception(String.valueOf(new StringBuffer("### getMyView: cannot get view named [").append(viewName).append("]")));
	return m_viewManager.getView(viewInfo);
    }
    
    private void err(String ErrMsg, Exception ex) {
	LogManager.err("SDSharedlet::SDControlView", ErrMsg, ex);
    }
    
    private void log(String msg) {
	LogManager.log("SDSharedlet::SDControlView", msg);
    }
}
