/* SDNativeRenderer - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sdsharedlet;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JFrame;

import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.sharedlet.NativeRenderer;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletViewInfo;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.util.misc.LogManager;

public class SDNativeRenderer
    extends Component
    implements NativeRenderer
{
    private SDWrapper m_sdWrapper;
    private SDControlView m_controlView;
    private Point m_pt = new Point();
    private Dimension m_dim = new Dimension();
    private Vector m_compListeners = new Vector();
    private Vector m_wndListeners = new Vector();
    private SharedletViewManager m_viewManager;
    private SharedletInfo m_sharedletInfo;
    private Container m_parent;
    private JFrame m_mainFrame;
    private ComponentListener m_compListener1;
    private ComponentListener m_compListener2;
    private WindowListener m_wndListener;
    private byte[] m_eventData;
    
    public SDNativeRenderer(SDWrapper sdWrapper) {
	m_sdWrapper = sdWrapper;
	m_eventData = new byte[80];
	if (m_sdWrapper == null)
	    log("### SDNativeRenderer: could not get the SDWrapper ");
	getControlView();
    }
    
    public void setLocation(Point pt) {
	m_sdWrapper.SetPosition(pt.x, pt.y, -1, -1, true);
    }
    
    public void setDimension(Dimension dim) {
	m_sdWrapper.SetPosition(-1, -1, dim.width, dim.height, true);
    }
    
    public void setVisible(boolean visible) {
	if (!m_sdWrapper.SetPosition(-1, -1, -1, -1, visible))
	    log("!!!!!!!!!!!!!!!! SetVisible failed !!!!!!!!!!!!!!!!!");
    }
    
    public void addComponentListener(ComponentListener listener) {
	m_compListeners.addElement(listener);
    }
    
    public void removeComponentListener(ComponentListener listener) {
	m_compListeners.removeElement(listener);
    }
    
    public void addWindowListener(WindowListener listener) {
	m_wndListeners.addElement(listener);
    }
    
    public void removeWindowListener(WindowListener listener) {
	m_wndListeners.removeElement(listener);
    }
    
    public Object getRendering() {
	return this;
    }
    
    public Point getLocation() {
	m_pt.x = byteArrToInt(m_eventData, 14);
	m_pt.y = byteArrToInt(m_eventData, 18);
	return m_pt;
    }
    
    public Dimension getDimension() {
	int left = byteArrToInt(m_eventData, 14);
	int top = byteArrToInt(m_eventData, 18);
	int right = byteArrToInt(m_eventData, 22);
	int bottom = byteArrToInt(m_eventData, 26);
	m_dim.width = right - left;
	m_dim.height = bottom - top;
	return m_dim;
    }
    
    public void toFront() {
	setLocation(m_parent.getLocationOnScreen());
    }
    
    void setWindowEvent(WindowEvent we, byte[] eventData) {
	m_eventData = eventData;
	switch (we.getID()) {
	case 205:
	    if (m_mainFrame != null)
		m_mainFrame.setVisible(true);
	    break;
	case 202:
	    break;
	case 201:
	    break;
	case 206:
	    break;
	case 204:
	    break;
	case 203:
	    break;
	case 200:
	    break;
	default:
	    log("!!!!!!!!!!!!!!!!!!!!!!!! Unknown wnd event got in Renderer !!!!!!!!!!!!!!!!!!!!!!!");
	}
    }
    
    void setComponentEvent(ComponentEvent ce, byte[] eventData) {
	m_eventData = eventData;
	switch (ce.getID()) {
	case 103:
	    break;
	case 100:
	    break;
	case 101:
	    break;
	case 102:
	    break;
	default:
	    log("!!!!!!!!!!!!!!!!!!!!!!!! Unknown componenet event got in Renderer !!!!!!!!!!!!!!!!!!!!!!!");
	}
    }
    
    boolean getControlView() {
	try {
	    m_controlView = (SDControlView) getMyView("Shared Display");
	} catch (Exception ex) {
	    err("getControlView: Err:", ex);
	    boolean bool_2_0_ = false;
	    return bool_2_0_;
	}
	return true;
    }
    
    static int byteArrToInt(byte[] ba, int startIndex) {
	int result = 0;
	int tmp = 0;
	for (int iCount = startIndex; iCount < startIndex + 4; iCount++) {
	    tmp = ba[iCount];
	    tmp &= 0xff;
	    tmp <<= 8 * (iCount - startIndex);
	    result |= tmp;
	}
	return result;
    }
    
    public void doLayout() {
	log("<<<<<<<<<<<<< doLayout called >>>>>>>>>>>>>>>>");
    }
    
    public float getAlignmentX() {
	log("<<<<<<<<<<<<< getAlignmentX called >>>>>>>>>>>>>>>>");
	return super.getAlignmentX();
    }
    
    public float getAlignmentY() {
	return super.getAlignmentY();
    }
    
    public Rectangle getBounds() {
	Point p = getLocation();
	Dimension d = getDimension();
	return new Rectangle(p, d);
    }
    
    public void setBounds(int x, int y, int width, int height) {
	if (m_parent == null) {
	    m_parent = getParent();
	    if (m_parent == null) {
		log("<<<<<<<<<<<<< Could not get parent >>>>>>>>>>>>>>");
		return;
	    }
	}
	Point pt = m_parent.getLocationOnScreen();
	setLocation(pt);
	setDimension(new Dimension(width, height));
    }
    
    public int getHeight() {
	log("<<<<<<<<<<<<< getHeight called >>>>>>>>>>>>>>>>");
	return 5;
    }
    
    public int getWidth() {
	log("<<<<<<<<<<<<< getWidth called >>>>>>>>>>>>>>>>");
	return 5;
    }
    
    public Dimension getMaximumSize() {
	return new Dimension(5, 5);
    }
    
    public Dimension getMinimumSize() {
	return new Dimension(5, 5);
    }
    
    public Dimension getPreferredSize() {
	return new Dimension(5, 5);
    }
    
    public Dimension getSize() {
	log("<<<<<<<<<<<<< getSize-1 called >>>>>>>>>>>>>>>>");
	return new Dimension(5, 5);
    }
    
    public Dimension getSize(Dimension rv) {
	log("<<<<<<<<<<<<< getSize-2 called >>>>>>>>>>>>>>>>");
	if (rv == null)
	    return new Dimension(5, 5);
	rv.width = 5;
	rv.height = 5;
	return rv;
    }
    
    public void addNotify() {
	log("<<<<<<<<<<<<< addNotify called >>>>>>>>>>>>>>>>");
	super.addNotify();
	m_parent = getParent();
	m_mainFrame = getMainFrame(this);
	String strMainFrameTitle = m_mainFrame.getTitle();
	if (!m_sdWrapper.setParent(strMainFrameTitle))
	    log("********** cannot set parent in native ***********");
	else
	    log("********** parent set in native successfully ***********");
	log(String.valueOf(new StringBuffer("************ Main Frame Caption [").append(strMainFrameTitle).append("] ***************")));
	m_compListener1 = new ComponentAdapter() {
	    public void componentHidden(ComponentEvent e) {
		/* empty */
	    }
	    
	    public void componentMoved(ComponentEvent e) {
		setLocation(m_parent.getLocationOnScreen());
	    }
	    
	    public void componentResized(ComponentEvent e) {
		/* empty */
	    }
	    
	    public void componentShown(ComponentEvent e) {
		setVisible(true);
	    }
	};
	m_mainFrame.addComponentListener(m_compListener1);
	m_compListener2 = new ComponentAdapter() {
	    public void componentHidden(ComponentEvent e) {
		/* empty */
	    }
	    
	    public void componentMoved(ComponentEvent e) {
		setLocation(m_parent.getLocationOnScreen());
	    }
	    
	    public void componentResized(ComponentEvent e) {
		/* empty */
	    }
	    
	    public void componentShown(ComponentEvent e) {
		SDNativeRenderer.this.log("************* [componentShown][2] ****************");
	    }
	};
	addListenersToParents(m_compListener2);
	log("<<<<<<<<<<<< added listener to the parents >>>>>>>>>>>>>");
	m_wndListener = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		/* empty */
	    }
	    
	    public void windowClosed(WindowEvent e) {
		SDNativeRenderer.this.log("************* windowClosed ****************");
	    }
	    
	    public void windowOpened(WindowEvent e) {
		SDNativeRenderer.this.log("************* windowOpened ****************");
	    }
	    
	    public void windowIconified(WindowEvent e) {
		SDNativeRenderer.this.log("************* windowIconified ****************");
		setVisible(false);
	    }
	    
	    public void windowDeiconified(WindowEvent e) {
		SDNativeRenderer.this.log("************* windowDeiconified ****************");
		setVisible(true);
	    }
	    
	    public void windowActivated(WindowEvent e) {
		setVisible(true);
	    }
	    
	    public void windowDeactivated(WindowEvent e) {
		/* empty */
	    }
	};
	m_mainFrame.addWindowListener(m_wndListener);
    }
    
    public void removeNotify() {
	log("<<<<<<<<<<<<< removeNotify called >>>>>>>>>>>>>>>>");
	super.removeNotify();
	m_mainFrame.removeComponentListener(m_compListener1);
	m_parent.removeComponentListener(m_compListener2);
	m_mainFrame.removeWindowListener(m_wndListener);
    }
    
    void refresh() {
	/* empty */
    }
    
    void addListenersToParents(ComponentListener compListener) {
	Component temp = this;
	Component root = null;
	for (;;) {
	    root = temp;
	    temp = root.getParent();
	    if (temp == null)
		break;
	    temp.addComponentListener(compListener);
	}
    }
    
    static JFrame getMainFrame(Component child) {
	Component temp = child;
	Component root = null;
	for (/**/; temp != null; temp = root.getParent())
	    root = temp;
	return (JFrame) root;
    }
    
    private boolean getMyViewInfo()
    throws Exception {
	Context ctx = ContextManager.getInitialContext();
	SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	m_sharedletInfo = sharedletManager.getInfo("application/x-sharedlet-sd");
	if (m_sharedletInfo == null)
	    throw new Exception("### getMyViewInfo: cannot get sharedlet info for [application/x-sharedlet-sd]");
	m_viewManager = sharedletManager.getViewManager();
	return m_viewManager != null;
    }
    
    SharedletView getMyView(String viewName)
    throws Exception {
	if ((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo()) {
	    log(String.valueOf(new StringBuffer("==========>> 1 : ").append(m_sharedletInfo).append(", ").append(m_viewManager).append("<<======")));
	    return null;
	}
	Vector views = m_sharedletInfo.getViewInfos();
	if (views == null)
	    throw new Exception("### getMyView: cannot get views for [application/x-sharedlet-sd]");
	SharedletViewInfo viewInfo = null;
	Enumeration enum = views.elements();
    while_4_:
	do {
	    SharedletViewInfo item;
	    do {
		if (!enum.hasMoreElements())
		    break while_4_;
		item = (SharedletViewInfo) enum.nextElement();
	    } while (!item.getID().equals(viewName));
	    viewInfo = item;
	} while (false);
	if (viewInfo == null)
	    throw new Exception(String.valueOf(new StringBuffer("### getMyView: cannot get view named [").append(viewName).append("]")));
	return m_viewManager.getView(viewInfo);
    }
    
    private void err(String ErrMsg, Exception ex) {
	LogManager.err("SDSharedlet::SDNativeRenderer", ErrMsg, ex);
    }
    
    private void log(String msg) {
	LogManager.log("SDSharedlet::SDNativeRenderer", msg);
    }
}
