/* SDSharedlet - Decompiled by JODE
 * http://www.informatik.uni-oldenburg.de/~delwi/jode/jode.html
 * Send comments or bug reports to jochen@gnu.org
 */
package com.anabas.sdsharedlet;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Vector;

import javax.swing.JOptionPane;

import com.anabas.naming.Context;
import com.anabas.naming.ContextManager;
import com.anabas.sharedlet.DefaultSharedletImpl;
import com.anabas.sharedlet.LayoutService;
import com.anabas.sharedlet.SharedletInfo;
import com.anabas.sharedlet.SharedletManager;
import com.anabas.sharedlet.SharedletView;
import com.anabas.sharedlet.SharedletViewInfo;
import com.anabas.sharedlet.SharedletViewManager;
import com.anabas.util.misc.LogManager;
import com.anabas.util.nativeutils.NativeUtilsWrapper;

public class SDSharedlet
    extends DefaultSharedletImpl
{
    private static boolean m_bAlreadyDisplayed;
    private SharedletInfo m_sharedletInfo;
    private SharedletViewManager m_viewManager;
    private LayoutService m_layoutService;
    private Hashtable m_ht_curURLs = new Hashtable();
    private SDWrapper m_sdWrapper;
    private SDControlView m_controlView;
    private NativeUtilsWrapper m_nativeUtilsWrapper;
    
    public SDSharedlet() {
	super("application/x-sharedlet-sd");
	log("Creating SDSharedlet ...");
	m_nativeUtilsWrapper = new NativeUtilsWrapper();
	m_sdWrapper = new SDWrapper();
	m_bAlreadyDisplayed = false;
    }
    
    public void loadDocument(URL url) {
	int hwnd = 0;
	log(String.valueOf(new StringBuffer("loadDocument: called with [").append(url).append("]")));
	try {
	    loadSDSharedletViews();
	    getControlView();
	} catch (Exception ex) {
	    err("Error while loading SDSharedlet views", ex);
	}
	String strFile = getActualFile(url);
	if (strFile != null) {
	    File file = new File(strFile);
	    if (!file.exists()) {
		err(String.valueOf(new StringBuffer("loadDocument: file doesn't exists [").append(strFile).append("]")), new Exception());
		errMsg("File doesn't exist ...");
	    } else {
		boolean bIsURL = false;
		String strUrl = null;
		if (strFile.endsWith(".url")) {
		    strUrl = getActualURL(file);
		    bIsURL = true;
		} else
		    strUrl = url.toString();
		log(String.valueOf(new StringBuffer("loadDocument: loading [").append(strUrl).append("]")));
	    while_6_:
		do {
		    if (!bIsURL) {
			Enumeration enum = m_ht_curURLs.keys();
			String val;
			Integer key;
			do {
			    if (!enum.hasMoreElements())
				break while_6_;
			    key = (Integer) enum.nextElement();
			    val = (String) m_ht_curURLs.get(key);
			    log(String.valueOf(new StringBuffer("Key [").append(key).append("] Val [").append(val).append("]")));
			} while (!val.equals(strUrl));
			log(String.valueOf(new StringBuffer("loadDocument: document already loaded : [").append(strUrl).append("]")));
			m_sdWrapper.ClickToShare(key.intValue(), 3);
			return;
		    }
		} while (false);
		log("loadDocument: calling launch with : ".concat(strFile));
		if (this != null) {
		    /* empty */
		}
		hwnd = NativeUtilsWrapper.launch(strFile);
		if (hwnd == 0) {
		    log("##########################################");
		    log("loadDocument: Could not get new window handle ...");
		    log("##########################################");
		} else if (hwnd < 0) {
		    err("loadDocument: cannot launch the file", new Exception());
		    String[] ErrMsgs = {
			"Cannot launch the file ...", "No supported application for this file found ..."
		    };
		    errMsg(ErrMsgs);
		} else {
		    log(String.valueOf(new StringBuffer("loadDocument: launch successful : window handle [").append(hwnd).append("]")));
		    if (m_sdWrapper.ClickToShare(hwnd, 1)) {
			if (!bIsURL)
			    m_ht_curURLs.put(new Integer(hwnd), strUrl);
		    } else
			log("loadDocument: could not share the new doc ...");
		}
	    }
	}
    }
    
    String getActualURL(File file) {
	Properties props = new Properties();
	FileInputStream fis = null;
	try {
	while_7_:
	    do {
		try {
		    fis = new FileInputStream(file);
		    props.load(fis);
		    Enumeration enum = props.propertyNames();
		    String prop;
		    do {
			if (!enum.hasMoreElements())
			    break while_7_;
			prop = (String) enum.nextElement();
		    } while (!prop.equalsIgnoreCase("URL"));
		    return props.getProperty(prop);
		} catch (IOException ex) {
		    err("getActualURL: Error", ex);
		    return "";
		}
	    } while (false);
	} finally {
	    try {
		if (fis != null)
		    fis.close();
	    } catch (Exception ex) {
		err("Cannot close file : ".concat(String.valueOf(file)), ex);
	    }
	}
	return "";
    }
    
    void removeURL(Integer hwnd) {
	m_ht_curURLs.remove(hwnd);
    }
    
    private boolean getLayoutService() {
	try {
	    Context ctx = ContextManager.getInitialContext();
	    m_layoutService = (LayoutService) ctx.lookup("services/LayoutService");
	} catch (Exception ex) {
	    boolean bool_2_0_ = false;
	    return bool_2_0_;
	}
	return true;
    }
    
    void loadSDSharedletViews()
    throws Exception {
	if (m_layoutService != null || getLayoutService()) {
	    log(">>>>>>>>>>>> activating Sharedlet views <<<<<<<<<<<<<");
	    m_layoutService.activateViews("application/x-sharedlet-sd");
	} else {
	    log("################################");
	    log("loadSDSharedletViews: Could not get the LayoutService ...");
	    log("################################");
	}
    }
    
    private void getControlView()
    throws Exception {
	m_controlView = (SDControlView) getMyView("Shared Display");
    }
    
    private String getActualFile(URL url) {
	String strScheme = url.getProtocol();
	String strFile = url.getFile();
	String fileSeparator = System.getProperty("file.separator");
	strFile = strFile.replace('/', fileSeparator.charAt(0));
	if (strScheme.equalsIgnoreCase("file")) {
	    String strDriveName = url.getHost();
	    return strDriveName.equals("") ? strFile : String.valueOf(new StringBuffer(String.valueOf(strDriveName.charAt(0))).append(":").append(strFile));
	}
	err("getActualFile: not a file url ...", new Exception());
	String[] ErrMsgs = {
	    "Cannot open the URL :", url.toString()
	};
	errMsg(ErrMsgs);
	return null;
    }
    
    private boolean getMyViewInfo()
    throws Exception {
	Context ctx = ContextManager.getInitialContext();
	SharedletManager sharedletManager = (SharedletManager) ctx.lookup("services/SharedletManager");
	m_sharedletInfo = sharedletManager.getInfo("application/x-sharedlet-sd");
	if (m_sharedletInfo == null)
	    throw new Exception("### getMyViewInfo: cannot get sharedlet info for [application/x-sharedlet-sd]");
	m_viewManager = sharedletManager.getViewManager();
	return m_viewManager != null;
    }
    
    SharedletView getMyView(String viewName)
    throws Exception {
	if ((m_sharedletInfo == null || m_viewManager == null) && !getMyViewInfo()) {
	    log(String.valueOf(new StringBuffer("==========>> 1 : ").append(m_sharedletInfo).append(", ").append(m_viewManager).append("<<======")));
	    return null;
	}
	Vector views = m_sharedletInfo.getViewInfos();
	if (views == null)
	    throw new Exception("### getMyView: cannot get views for [application/x-sharedlet-sd]");
	SharedletViewInfo viewInfo = null;
	Enumeration enum = views.elements();
    while_8_:
	do {
	    SharedletViewInfo item;
	    do {
		if (!enum.hasMoreElements())
		    break while_8_;
		item = (SharedletViewInfo) enum.nextElement();
	    } while (!item.getID().equals(viewName));
	    viewInfo = item;
	} while (false);
	if (viewInfo == null)
	    throw new Exception(String.valueOf(new StringBuffer("### getMyView: cannot get view named [").append(viewName).append("]")));
	return m_viewManager.getView(viewInfo);
    }
    
    public static void main(String[] args)
    throws Exception {
	SDSharedlet ns = new SDSharedlet();
	String file1 = "file://C:/milind/tmp/a.url";
	String file2 = "file://C:/milind/tmp/b.url";
	try {
	    ns.loadDocument(new URL(file1));
	    Thread.sleep(5000L);
	    log("------------------ Now loading File 2 ---------------");
	    ns.loadDocument(new URL(file2));
	} catch (Exception exception_4_1_) {
	    /* empty */
	}
    }
    
    static void handleDisconnected() {
	if (!m_bAlreadyDisplayed) {
	    m_bAlreadyDisplayed = true;
	    String[] ErrMsg = {
		"The connection with the Server is lost", "Please restart the Application and Try again ..."
	    };
	    errMsg(ErrMsg);
	}
    }
    
    static void errMsg(Object ErrMsg) {
	JOptionPane.showMessageDialog(null, ErrMsg, "Error", 0);
    }
    
    private void err(String ErrMsg, Exception ex) {
	LogManager.err("SDSharedlet::SDSharedlet", ErrMsg, ex);
    }
    
    private static void log(String msg) {
	LogManager.log("SDSharedlet::SDSharedlet", msg);
    }
}
